/*""FILE COMMENT""**************************************************************
*
*   System Name  : H8S/2472 Sample Program
*   File Name    : phy.c
*   Contents     : PHY-LSIݒ
*   Version      : 1.00.00
*   Model        : 
*   CPU          : H8S/2472
*   Compiler     : 
*   OS           : None
*
*   note         : sAʂǂݏo߂̊֐pӂĂ܂B
*                : 
*
*                  <ӎ>
*                  {TvvOׂ͂ĎQlłA
*                  ̓ۏ؂̂ł͂܂B
*                  {TvvO͂ql̃\tgEGAJ
*                  ZpQlƂĂpB
*
*    Copyright (C) 2007 Renesas Technology Corp. All Rights Reserved
*    and Renesas Solutions Corp. All Rights Reserved
*
*    history      :2007.05.10 ver.1.00.00 
*""FILE COMMENT END""*********************************************************/
#include "iodefine2472.h"
#include "phy.h"

/* **** vg^Cv錾 **** */
static unsigned short	phy_reg_read(unsigned short reg_addr);
static void	phy_reg_write(unsigned short reg_addr, unsigned short data);
static void	mii_preamble(void);
static void	mii_cmd(unsigned short reg_addr, int option);
static void	mii_reg_read(unsigned short *data);
static void	mii_reg_write(unsigned short data);
static void	mii_z(void);
static void	mii_ta_10(void);
static void	mii_write_1(void);
static void	mii_write_0(void);


#define	NO_WAIT
//#undef	NO_WAITE

//#define	PHY_LOOP_BACK


/* **** }N` **** */
/* PHY-LSIMIIWX^ */
//#define	PHY_ADD						0x0000
#define	PHY_ADD						0x03c0
#define	BASIC_MODE_CONTROL_REG		PHY_ADD+(0x0000)
#define	BASIC_MODE_STATUS_REG		PHY_ADD+(0x0001)
#define	PHY_IDENTIFIER1_REG			PHY_ADD+(0x0002)
#define	PHY_IDENTIFIER2_REG			PHY_ADD+(0x0003)
#define	AN_ADVERTISEMENT_REG		PHY_ADD+(0x0004)
#define	AN_LINK_PARTNER_ABILITY_REG	PHY_ADD+(0x0005)
#define	AN_EXPANSION_REG			PHY_ADD+(0x0006)
#define	PHY_CONTROL1				PHY_ADD+(0x001e)
#define	PHY_CONTROL2				PHY_ADD+(0x001f)
/* MIIANZXp */
#define PHY_ST						1
#define PHY_WRITE					1
#define PHY_READ					2
#define PHY_ADDR0					1
#define PHY_ADDR1					1

/*""FUNC COMMENT""*************************************************************
* Outline     : PHYŇʌo
*----------------------------------------------------------------------------
* Include     : #include "iodefine.h"
*----------------------------------------------------------------------------
* Declaration : int phy_autonego(void);
*----------------------------------------------------------------------------
* Function    : ʂǂݍ݁A߂lŕԂ܂B
*             : ő5bԁAI܂Ŗ{֐ő҂܂B
*             : 
*----------------------------------------------------------------------------
* Argument    : 
*---------------------------------------------------------------------------- 
* Return Value: 4(FULL_TX) :100Mbps Sd
*             : 3(HALF_TX) :100Mbps d
*             : 2(FULL_10M):10Mbps  Sd
*             : 1(HALF_10M):10Mbps  d
*             : 0(NEGO_FAIL) :s
*----------------------------------------------------------------------------
* Notice      : 
*             : 
*             : 
*             : 
*             : 
*""FUNC COMMENT END""*********************************************************/

unsigned short data0,data1,data2;
int	status;

int	phy_autonego(void)
{
//	unsigned short data0,data1;
	int link = NEGO_FAIL;
	volatile int t;
	int i;

	data0 = phy_reg_read(BASIC_MODE_CONTROL_REG);
	data0 = data0 | 0x8000;
	phy_reg_write(BASIC_MODE_CONTROL_REG, data0);

	/* ---- EFCg ---- */
	for(i=0;i<1000;i++){
		t=600000;
		while( --t){					/* 10ms EFCgJEg @200MHz */
			;
		}
	}

#ifdef PHY_LOOP_BACK
	data0 = phy_reg_read(BASIC_MODE_CONTROL_REG);
	data0 = data0 & ~0x1000;
	phy_reg_write(BASIC_MODE_CONTROL_REG, data0);
	/* ---- 10msEFCg ---- */
	t=290000;
	while( --t){					/* 10ms EFCgJEg @200MHz */
		;
	}
	data0 = phy_reg_read(BASIC_MODE_CONTROL_REG);
	data0 = data0 | 0x4000;
	phy_reg_write(BASIC_MODE_CONTROL_REG, data0);
	/* ---- 10msEFCg ---- */
	t=290000;
	while( --t){					/* 10ms EFCgJEg @200MHz */
		;
	}
	data0 = phy_reg_read(BASIC_MODE_CONTROL_REG);
	data0 = data0 | 0x0100;
	phy_reg_write(BASIC_MODE_CONTROL_REG, data0);
	/* ---- 10msEFCg ---- */
	t=290000;
	while( --t){					/* 10ms EFCgJEg @200MHz */
		;
	}
	data0 = phy_reg_read(BASIC_MODE_CONTROL_REG);
	return FULL_TX;	
//	return FULL_10M;
#endif

 	/* ==== ̏I҂[v ==== */
 	for( i=0; i<500; i++){	
		
		/* ---- 10msEFCg ---- */
		t=290000;
		while( --t){					/* 10ms EFCgJEg @200MHz */
			;
		}
#if 0
		/* ---- mF ---- */
		data0 = phy_reg_read(PHY_CONTROL2);
		data0 = data0 | 0x0800;
		phy_reg_write(PHY_CONTROL2, data0);
		data0 = 0;
		data0 = phy_reg_read(PHY_CONTROL2);

		/* ---- 10msEFCg ---- */
		t=290000;
		while( --t){					/* 10ms EFCgJEg @200MHz */
			;
		}
#endif
		data0 = phy_reg_read(BASIC_MODE_STATUS_REG);
		if(data0 & 0x0020){	 /*  */
		
			/* ---- ʎ擾 ---- */
			data1 = phy_reg_read(AN_LINK_PARTNER_ABILITY_REG);
								/* AN_LINK_PARTNER_ABILITY_REG *
								 * 肪ɑΉĂȂꍇ*
								 * 񌟏os邪Aʂ͂̃W*
								 * X^ɔfB                  */
			/* ---- ʔ->Ibreak ---- */

/*			if( !(data1&0x4000) ){
				link = NEGO_FAIL;
				break;
			}
*/
			if( data1&0x0100 ){
				link = FULL_TX;	
			}
			else if( data1&0x0080 ){
				link = HALF_TX;
			}
			else if( data1&0x0040 ){
				link = FULL_10M;
			}
			else if( data1&0x0020 ){
				link = HALF_10M;
			}
			else{
				link = NEGO_FAIL;
			}
			break;
		}
	}
	return link;
}


/*""FUNC COMMENT""********************************************************************
* Outline     : PHY-LSI̊eMIIWX^[h
*------------------------------------------------------------------------------------
* Include     : 
*------------------------------------------------------------------------------------
* Declaration : static unsigned short	phy_reg_read(unsigned short reg_addr)
*------------------------------------------------------------------------------------
* Function    : PHY-LSI̊eMIIWX^l擾܂B
*------------------------------------------------------------------------------------
* 
* Argument    : unsigned short reg_addr : I : lǂݍPHY-LSIWX^AhX
*------------------------------------------------------------------------------------ 
* Return Value: 擾WX^̒l
*------------------------------------------------------------------------------------
* Notice      : 
*""FUNC COMMENT END""****************************************************************/
static unsigned short	phy_reg_read(unsigned short reg_addr)
{
	unsigned short	data;

	PE.ODR.BIT.PE0ODR = 0;
	mii_preamble();
	mii_cmd(reg_addr, PHY_READ);
	mii_z();
	PE.ODR.BIT.PE0ODR = 1;
	mii_reg_read(&data);
	mii_z();
	PE.ODR.BIT.PE0ODR = 0;

	return data;
}

/*""FUNC COMMENT""***************************************************************
* Outline     : PHY-LSI̊eMIIWX^Cg
*-------------------------------------------------------------------------------
* Include     : 
*-------------------------------------------------------------------------------
* Declaration : static void phy_reg_write(unsigned short reg_addr,
*             :                       unsigned short data )
*-------------------------------------------------------------------------------
* Function    : PHY-LSI̊eMIIWX^ɒlݒ肵܂B
*-------------------------------------------------------------------------------
* Argument    : unsigned short reg_addr : I : lPHY-LSIWX^AhX
*             : unsigned short data     : I : PHY-LSĨWX^ɐݒ肷l
*------------------------------------------------------------------------------- 
* Return Value: void
*-------------------------------------------------------------------------------
* Notice      : 
*""FUNC COMMENT END""***********************************************************/
static void	phy_reg_write(unsigned short reg_addr, unsigned short data)
{
	mii_preamble();
	mii_cmd(reg_addr, PHY_WRITE);
	mii_ta_10();
	mii_reg_write(data);
	mii_z();

}

/*""FUNC COMMENT""*************************************************************
* Outline     : PHY-LSI̊eMIIWX^ւ̃ANZX
*----------------------------------------------------------------------------
* Include     : 
*----------------------------------------------------------------------------
* Declaration : static void mii_preamble(void)
*----------------------------------------------------------------------------
* Function    : PHY-LSIWX^ɃANZX邽߂̑OƂāA
*             : MII ubN32rbg1o͂܂B
*----------------------------------------------------------------------------
* Argument    : 
*---------------------------------------------------------------------------- 
* Return Value: void
*----------------------------------------------------------------------------
* Notice      : 
*""FUNC COMMENT END""*********************************************************/
static void	mii_preamble(void)
{
	short	i;

	i = 32;
	while( i > 0 ) {
		/* MII(Media Independent Interface)ubN1óB*/
		mii_write_1();
		i--;
	}
}

/*""FUNC COMMENT""*************************************************************
* Outline     : PHY-LSI̊eMIIWX^[hݒ
*----------------------------------------------------------------------------
* Include     :
*----------------------------------------------------------------------------
* Declaration : static void mii_cmd(unsigned short reg_addr, 
*             :                                                int option)
*----------------------------------------------------------------------------
* Function    : PHY-LSI̊eMIIWX^ R/W [hݒ肵܂B
*----------------------------------------------------------------------------
* Argument    : unsigned short reg_addr : I : PHY-LSĨWX^AhX
*             : int option             : I : R/W [hw
*---------------------------------------------------------------------------- 
* Return Value: void
*----------------------------------------------------------------------------
* Notice      : 
*""FUNC COMMENT END""*********************************************************/
static void	mii_cmd(unsigned short reg_addr, int option)
{
	int	i;
	unsigned short	data;

	data = 0;
	data = (PHY_ST << 14);				/* ST code		*/
	if( option == PHY_READ ) {
		data |= (PHY_READ << 12);		/* OP code(RD)	*/
	}
	else {
		data |= (PHY_WRITE << 12);		/* OP code(WT)	*/
	}
	
	data |= (PHY_ADDR0 << 7);		/* PHY Address	*/
	data |= (reg_addr << 2);			/* Reg Address	*/

	for(i=14; i>0; i--){
		if( (data & 0x8000) == 0 ) {
			mii_write_0();
		}
		else {
			mii_write_1();
		}
		data <<= 1;
	}
}

/*""FUNC COMMENT""*************************************************************
* Outline     : PHY-LSI̊eMIIWX^l擾
*----------------------------------------------------------------------------
* Include     :
*----------------------------------------------------------------------------
* Declaration : static void mii_reg_read(unsigned short *data)
*----------------------------------------------------------------------------
* Function    : PHY-LSI̊eMIIWX^l1rbg擾܂B
*----------------------------------------------------------------------------
* Argument    : unsigned short *data : O : 擾l̊i[AhX
*---------------------------------------------------------------------------- 
* Return Value: void
*----------------------------------------------------------------------------
* Notice      : 
*""FUNC COMMENT END""*********************************************************/
static void	mii_reg_read(unsigned short *data)
{
	int	i;
	unsigned short	reg_data;

#ifdef	NO_WAIT
	/* 1 rbgf[^ǂݍށB*/
	reg_data = 0;
	for(i=16; i>0; i--){
		MAC0.PIR.LONG = 0x00000000;
		MAC0.PIR.LONG = 0x00000001;
		MAC0.PIR.LONG = 0x00000001;
		reg_data <<= 1;
		reg_data |= (MAC0.PIR.LONG & 0x00000008) >> 3;	/* MDI read	*/
		MAC0.PIR.LONG = 0x00000001;
		MAC0.PIR.LONG = 0x00000000;
	}
	*data = reg_data;
#else
	/* 1 rbgf[^ǂݍށB*/
	int	j;
	reg_data = 0;
	for(i=16; i>0; i--){
		for(j=0; j<3; j++)	MAC0.PIR.LONG = 0x00000000;
		for(j=0; j<3; j++)	MAC0.PIR.LONG = 0x00000001;
		for(j=0; j<3; j++)	MAC0.PIR.LONG = 0x00000001;
		reg_data <<= 1;
		reg_data |= (MAC0.PIR.LONG & 0x00000008) >> 3;	/* MDI read	*/
		for(j=0; j<3; j++)	MAC0.PIR.LONG = 0x00000001;
		for(j=0; j<3; j++)	MAC0.PIR.LONG = 0x00000000;
	}
	*data = reg_data;
#endif
}

/*""FUNC COMMENT""*************************************************************
* Outline     : PHY -LSI̊eMIIWX^lݒ
*----------------------------------------------------------------------------
* Include     : 
*----------------------------------------------------------------------------
* Declaration : static void mii_reg_write(unsigned short data)
*----------------------------------------------------------------------------
* Function    : PHY-LSI̊eMIIWX^lPrbgݒ肵܂B
*----------------------------------------------------------------------------
* Argument    : unsigned short data : I : WX^ɐݒ肷l
*---------------------------------------------------------------------------- 
* Return Value: void
*----------------------------------------------------------------------------
* Notice      : 
*""FUNC COMMENT END""*********************************************************/
static void	mii_reg_write(unsigned short data)
{
	int	i;

	/* 1rbgf[^ށB*/
	for(i=16; i>0; i--){
		if( (data & 0x8000) == 0 ) {
			mii_write_0();
		}
		else {
			mii_write_1();
		}
		data <<= 1;
	}
}

/*""FUNC COMMENT""*************************************************************
* Outline     : MII oXJ
*----------------------------------------------------------------------------
* Include     : 
*----------------------------------------------------------------------------
* Declaration : static void mii_z(void)
*----------------------------------------------------------------------------
* Function    : MII ւ̃ANZXoXJɐݒ肵܂
*----------------------------------------------------------------------------
* Argument    : 
*---------------------------------------------------------------------------- 
* Return Value: void
*----------------------------------------------------------------------------
* Notice      : 
*""FUNC COMMENT END""*********************************************************/
static void	mii_z(void)
{
#ifdef	NO_WAIT
	MAC0.PIR.LONG = 0x00000000;
	MAC0.PIR.LONG = 0x00000001;
	MAC0.PIR.LONG = 0x00000001;
	MAC0.PIR.LONG = 0x00000001;
	MAC0.PIR.LONG = 0x00000000;
#else
	int	j;
	for(j=0; j<3; j++)	MAC0.PIR.LONG = 0x00000000;
	for(j=0; j<3; j++)	MAC0.PIR.LONG = 0x00000001;
	for(j=0; j<3; j++)	MAC0.PIR.LONG = 0x00000001;
	for(j=0; j<3; j++)	MAC0.PIR.LONG = 0x00000001;
	for(j=0; j<3; j++)	MAC0.PIR.LONG = 0x00000000;
#endif
}

/*""FUNC COMMENT""*************************************************************
* Outline     :  MII TA(1,0)rbgo
*----------------------------------------------------------------------------
* Include     : 
*----------------------------------------------------------------------------
* Declaration : static void mii_ta_10(void)
*----------------------------------------------------------------------------
* Function    : MII 1,0o͂܂
*----------------------------------------------------------------------------
* Argument    : 
*---------------------------------------------------------------------------- 
* Return Value: void
*----------------------------------------------------------------------------
* Notice      : 
*""FUNC COMMENT END""*********************************************************/
static void	mii_ta_10(void)
{
	mii_write_1();
	mii_write_0();
}

/*""FUNC COMMENT""*************************************************************
* Outline     : MII 1rbg(1) o
*----------------------------------------------------------------------------
* Include     :
*----------------------------------------------------------------------------
* Declaration : static void mii_write_1(void)
*----------------------------------------------------------------------------
* Function    : MII  1 o͂܂
*----------------------------------------------------------------------------
* Argument    : 
*---------------------------------------------------------------------------- 
* Return Value: void
*----------------------------------------------------------------------------
* Notice      :
*""FUNC COMMENT END""*********************************************************/
static void	mii_write_1(void)
{
#ifdef	NO_WAIT
	MAC0.PIR.LONG = 0x00000006;
	MAC0.PIR.LONG = 0x00000007;
	MAC0.PIR.LONG = 0x00000007;
	MAC0.PIR.LONG = 0x00000007;
	MAC0.PIR.LONG = 0x00000006;
#else
	int	j;
	for(j=0; j<3; j++)	MAC0.PIR.LONG = 0x00000006;
	for(j=0; j<3; j++)	MAC0.PIR.LONG = 0x00000007;
	for(j=0; j<3; j++)	MAC0.PIR.LONG = 0x00000007;
	for(j=0; j<3; j++)	MAC0.PIR.LONG = 0x00000007;
	for(j=0; j<3; j++)	MAC0.PIR.LONG = 0x00000006;
#endif
}

/*""FUNC COMMENT""*************************************************************
* Outline     :  MII 1rbg(0) o
*----------------------------------------------------------------------------
* Include     : 
*----------------------------------------------------------------------------
* Declaration : static void mii_write_0(void)
*----------------------------------------------------------------------------
* Function    : MII  0 o͂܂
*----------------------------------------------------------------------------
* Argument    : 
*---------------------------------------------------------------------------- 
* Return Value: void
*----------------------------------------------------------------------------
* Notice      : 
*""FUNC COMMENT END""*********************************************************/
static void	mii_write_0(void)
{
#ifdef	NO_WAIT
	MAC0.PIR.LONG = 0x00000002;
	MAC0.PIR.LONG = 0x00000003;
	MAC0.PIR.LONG = 0x00000003;
	MAC0.PIR.LONG = 0x00000003;
	MAC0.PIR.LONG = 0x00000002;
#else
	int	j;
	for(j=0; j<3; j++)	MAC0.PIR.LONG = 0x00000002;
	for(j=0; j<3; j++)	MAC0.PIR.LONG = 0x00000003;
	for(j=0; j<3; j++)	MAC0.PIR.LONG = 0x00000003;
	for(j=0; j<3; j++)	MAC0.PIR.LONG = 0x00000003;
	for(j=0; j<3; j++)	MAC0.PIR.LONG = 0x00000002;
#endif
}

/* End of File */
