/* Copyright 2005, RENESAS TECHNOLOGY CORPORATION */

/*------------ INCLUDE -------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <itcpip.h>

/*------------- DEFINE ------------------*/

#define RESTYPE_NON		0x00
#define RESTYPE_CGI		0x01
#define RESTYPE_FILE	0x02
#define QUERY_PARAM_SIZE	(80)
#define HTTP_SRV
#if defined(__R8C__) || defined(__M16C80__) || defined(__M32C80__) || defined(__M32R__) \
	|| defined(__H8__)
#define CONST	const		/* ROMɔzu */
#elif defined(__M16C__)
#define CONST				/* RAMɔzu */
#endif
/* ^CAEgݒl */
#define TMO_RCV				30*100		/* 30sec */
#define TMO_SND				30*100		/* 30sec */
//#define TMO_CLS			50*1		/* 500msec */
#define TMO_CLS				1			/* 10msec */

#define DHCP_ON 0x01

/*------------- STRUCTURE ------------------*/

typedef struct drv_info_{
	unsigned long	rcv_cnt;
	unsigned long	snd_cnt;
	unsigned long	rcv_byte;
	unsigned long	snd_byte;
}DRV_INFO;

typedef struct httpd_resource_type {
	const UB *uri;			/* URI: Uniform Resource Identifier */
	UB		 type;			/* 0: ݒ薳C1: CGI, 2:TEXT */
	const UB *hdr;			/* X|XEwb_ */
	INT		 hdr_size;		/* X|XEwb_̃TCY */
	const UB *body;			/* X|XE{fB */
	INT		 body_size;		/* X|XE{fB̃TCY */
	ER		 (*cgi_func)(ID cepid, void *res_info);
} HTTPD_RESOURCE;

typedef struct httpd_resource_info_type {
	HTTPD_RESOURCE	far *res;
	UB		 param[QUERY_PARAM_SIZE+1];		/* "?"ȍ~̃p[^ */
} HTTPD_RESOURCE_INFO;

/*------------- FUNCTION ------------------*/

void httpd(void);
ER httpd_rcv_request(ID cepid, UB *buf, INT buf_len, HTTPD_RESOURCE_INFO *res_info);
ER httpd_parse_request(UB *buf, HTTPD_RESOURCE_INFO *res_info);
ER httpd_snd_response(ID cepid, HTTPD_RESOURCE_INFO *res_info);
void UpdateIpInfomation(T_IPV4EP *dstaddr,CONST UB *contents, UB *buf);
int URLdecode(char *in, char *out);

void led(UB, UB);
void dtmf_start(UB *code);
void dtmf_stop(void);

/*------------- CGI FUNCTION ------------------*/

ER response_body_cgi_ctrl1(ID cepid, HTTPD_RESOURCE_INFO *res_info);
ER response_body_cgi_ctrl2(ID cepid, HTTPD_RESOURCE_INFO *res_info);

/*------------ GLOBAL -----------*/

UB DemoFlag;
extern TCPUDP_ENV tcpudp_env;
DRV_INFO drv_info;
UB ContentsBuffer[2048];
UB rcv_buff[2048];
T_IPV4EP	dstaddr;

/*------------ HTTP SERVER CONTENTS -----------*/


#if defined(HTTP_SRV)
CONST UB response_hdr_cgi_ctrl[] = {
"HTTP/1.1 204 No Content\r\n"
"Cache-Control:no-cache\r\n"
"Content-Length:0\r\n"
"\r\n"
};

CONST UB response_hdr_not_found[] = {
"HTTP/1.1 404 Not Found\r\n"
"\r\n"
};
#if 0	/* not supported */
CONST UB response_hdr_not_implemented[] = {
"HTTP/1.1 501 Not Implemented\r\n"
"\r\n"
};
#endif


#if defined(__R8C__) || defined(__M16C__) || defined(__M16C80__) || defined(__M32C80__) \
	|| defined(__H8__)
/* hdr: 64, body: 2184 */
CONST UB response_hdr_root[] = {
"HTTP/1.1 200 OK\r\n"
"Cache-Control:no-cache\r\n"
"Content-Type:text/html\r\n"
"\r\n"
};

CONST UB response_body_root[]={
	"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\"\r\n"
	"\"http://www.w3.org/TR/REC-html40/loose.dtd\">\r\n"
	"<style type=\"text/css\">\r\n"
	"<!--\r\n"
	"body{font-weight:bold}\r\n"
	"h2{border-bottom-style:solid;border-bottom-color:#FFCC99;padding-right:-90;color:#CC3300;font-size:medium}\r\n"
	"p{color:#008000;margin-left:20px}\r\n"
	"td{font-size:small;align:center;border-width:1px;border-color:#009933}\r\n"
	".col0{color:#008000}\r\n"
	".col1{color:#FFFF00}\r\n"
	".b0{font-size:14pt}\r\n"
	"-->\r\n"
	"</style>\r\n"
	"<html>\r\n"
	"<head>\r\n"
	"<title>Renesas TCP/IP Web Server Demonstration Program</title>\r\n"
	"</head>\r\n"
	"<body bgcolor=\"#FFFFCC\">\r\n"
	"<h1 align=\"center\"style=\"background-color:#D55E2B;padding-top:10px;padding-bottom:10px\">\r\n"
	"<font color=\"#FFFF00\"size=\"5\">Renesas TCP/IP(T2-Tiny) Web Server Demonstration Program</font></h1>\r\n"
	"<h2> \tgEFA̍\</h2>\r\n"
	"<div class=\"col0\"align=\"center\">\r\n"
	"<table border=\"1\"width=\"45%\"cellspacing=\"3\"cellpadding=\"5\"bordercolor=\"#FFFFCC\">\r\n"
	"<tr><td bgcolor=\"#99ff99\">HTTPT[o</td></tr>\r\n"
	"<tr><td bgcolor=\"#FFFF00\"><p style=\"margin:0\"><font size=\"+1\">T2</font></p>\r\n"
	"<table border=\"1\"width=\"88%\"bordercolor=\"#FFFF00\"cellspacing=\"4\"cellpadding=\"2\"height=\"85\">\r\n"
	"<colgroup span=\"4\"bgcolor=\"#0000FF\"class=\"col1\">\r\n"
	"<tr><td>TCP</td></tr><tr><td>IP</td></tr><tr><td>PPP or Ethernet</td></tr><tr><td>PPPhCo or EthernethCo</td></tr>\r\n"
	"</table></td></tr>\r\n"
	"<tr><td bgcolor=\"ff8080\">RENESAS R8C/Tiny,H8/Tiny,M16C/Tiny</td></tr>\r\n"
	"</table></div>\r\n"
	"<h2> T2(T2-Tiny)<p></h2>\r\n"
	" gݍ݃VXeɓRpNgȐ݌v<br>\r\n"
	" ŃvgR\<br>\r\n"
	"@@ROMF9.5KBCRAMF0.7KB@(hCo܂)<br></p>\r\n"
	"<h2 align=\"left\"> TCP/IP</h2>\r\n"
	"<a align=\"center\" href=\"/cgi-bin/ipinfo.html?\">ݒ</a><br><br>\r\n"
	"</body>\r\n"
	"</html>\r\n"
};

CONST UB response_body[] = {

	"<html>\r\n"
	"<head>\r\n"
	"<title>Renesas TCP/IP(T2-Tiny) Web Server Demonstration Program</title>\r\n"
	"</head>\r\n"
	"<body bgcolor=\"#FFFFCC\">\r\n"
	"<h1 align=\"center\"style=\"background-color:#D55E2B;padding-top:10px;padding-bottom:10px\">\r\n"

};

CONST UB html_start_ipinfo[] ={
	"<font color=\"#FFFF00\"size=\"5\">TCP/IP</font></h1>\r\n"
	"<p align=\"center\">\r\n"
	"<table border=\"3\" sellpadding=\"5\">\r\n"
	"<caption>HTTPT[o</caption>\r\n"
};

CONST UB html_start_nslookup[] ={
	"<font color=\"#FFFF00\"size=\"5\">nslookup</font></h1>\r\n"
	"<p align=\"center\">\r\n"
	"<form method=\"GET\"action=\"/cgi-bin/nslookup.cgi\">\r\n"
	"zXg<br><input type=\"text\"name=\"message\" size=\"100\">\r\n"
	"<input type=\"submit\" value=\"M\" name=\"submit\">\r\n"
	"</form>\r\n"
};

CONST UB html_end_ipinfo[]={
	"</table><br>\r\n"
	"<a href=\"/\">߂</a>\r\n"
	"</p>\r\n"
	"</body>\r\n"
	"</html>\r\n"
};

CONST UB html_end_nslookup[]={
	"<a href=\"/\">߂</a>\r\n"
	"</p>\r\n"
	"</body>\r\n"
	"</html>\r\n"
};

#endif
#endif


HTTPD_RESOURCE httpd_resource_tbl[] = {
	{"/",	RESTYPE_FILE,
			response_hdr_root,  sizeof(response_hdr_root)  - 1,
			response_body_root, sizeof(response_body_root) - 1,
			NULL
	},
	{"/cgi-bin/ipinfo.html?", RESTYPE_CGI,
			response_hdr_root,	sizeof(response_hdr_root) - 1,
			ContentsBuffer,	sizeof(ContentsBuffer) - 1,
			(void*)response_body_cgi_ctrl1
	},
};


HTTPD_RESOURCE const httpd_resource_not_found = {
	NULL,	RESTYPE_FILE,
			response_hdr_not_found,  sizeof(response_hdr_not_found)  - 1,
			NULL, 0,
			NULL
};

#if 0	/* not supported */
HTTPD_RESOURCE const httpd_resource_not_implemented = {
	{NULL,	RESTYPE_FILE,
			response_hdr_not_implemented,  sizeof(response_hdr_not_implemented)  - 1,
			NULL, 0,
			NULL}
};
#endif


/*------------ PROCESS -----------*/

void httpd()
{
	ID			cepid, repid;
	ER			ercd;
	HTTPD_RESOURCE_INFO	res_info;

	repid = 1;
	cepid = 1;
	while (1) {
		/* 󓮃I[v҂ */
		ercd = tcp_acp_cep(cepid, repid, &dstaddr, TMO_FEVR);
		if (ercd != E_OK) {
			return;
		}
	
		/* NGXg̎M */
		ercd = httpd_rcv_request(cepid, rcv_buff, sizeof(rcv_buff), &res_info);

		/* X|X̑M */
		if (ercd == 0 && res_info.res != NULL) {
			ercd = httpd_snd_response(cepid, &res_info);
		}

		tcp_sht_cep(cepid);
		tcp_cls_cep(cepid, TMO_CLS);
//		tcp_cls_cep(cepid, TMO_FEVR);

	}
}


/* flag */
#define REQUEST_START	0x00		/* NGXg̎MJn */
#define REQUEST_END		0x01		/* NGXg̏I[M */
#define	PARSE_NEED		0x02		/* ͕Kv */
#define PARSE_CMPLT		0x04		/* ͊ */

ER	httpd_rcv_request(ID cepid, UB *buf, INT buf_len, HTTPD_RESOURCE_INFO *res_info)
{
	UB		flag;
	INT		len;					/* obt@ɓĂf[^̃TCY */
	ER		ercd;

	buf_len--;						/* '\0'i[p̗̈m */
	flag = 0;
	len  = 0;
	while (1) {
		/* f[^M҂ */
		ercd = tcp_rcv_dat(cepid, buf + len, buf_len - len, TMO_RCV);
		if (ercd <= 0) {	/* G[/^CAEg, FINMH */
			return (-1);			/* NGXgMG[ */
		}
		len += ercd;				/* len = obt@ɓĂf[^̃TCY */

		/* NGXg̍Ō? */
		if (len >= 4) {
			if (strncmp((char*)buf + len - 4, "\r\n\r\n", 4) == 0) {
				if ((flag & PARSE_CMPLT) == 0) flag |= PARSE_NEED;
				flag |= REQUEST_END;
			}
		}

		/* obt@tH */
		if (len == buf_len) {
			if ((flag & PARSE_CMPLT) == 0) flag |= PARSE_NEED;
		}

		/* NGXg̉ */
		if (flag & PARSE_NEED) {
			buf[len] = '\0';		/* NULL} */
			httpd_parse_request(buf, res_info);
			flag &= (~PARSE_NEED);
			flag |= PARSE_CMPLT;	/* NGXg͍ς */		
		}

		/* NGXg͍ς݁H */
		if (flag & REQUEST_END) return (0);

		/* NGXg͍ς݁H */
		if (flag & PARSE_CMPLT) {
			if (len >= 4) {
				/* NGXg̏I[o邽߁AŌ3oCg͎c */
				strncpy((char*)buf, (char*)buf + len - 3, 3);
				len = 3;
			}
		}
	}
}


ER httpd_parse_request(UB *buf, HTTPD_RESOURCE_INFO *res_info)
{
	INT		i;
	UB		*p, *q;
	UB		ch = 0;			/* Warning}邽 */
	INT		res_num;
	HTTPD_RESOURCE far *res;

	res_info->res = NULL;

	/* t\ȃ\bhGET̂ */
	if (strncmp((char*)buf, "GET ", 4) != 0) {
#if 0	/* not supported */
		/* T|[gĂȂ\bh */
		res_info->res = (HTTPD_RESOURCE far *)&httpd_resource_not_implemented;
#endif
		return (-1);
	}
	buf += (sizeof("GET ") - 1);
	
	/* GETŗvꂽ\[X̏I[f''\0'} (ȍ~̃tB[h͖) */
	p = buf;					/* 4 = sizeof("GET ") - 1 */	
	q = NULL;
	while (1) {
		ch = *p++;
		if (ch == ' ' || ch == '&') {		/* ?ȍ~ɕ̃p[^ꍇłA1̂ݗLɂ */
			*(p - 1) = '\0';
			break;
		}
		else if (ch == '?') {	/* ?܂܂ĂꍇA̕ւ̃|C^qɊi[ */ 
			q = p;
		}
		else if (ch == '\0') {
			/* \[X̃TCỸI[o[t[ */
			goto __httpd_parse_request_not_found;
		}
	}
	if (q != NULL) {			/* '?'܂܂ĂꍇA?̌1ޔANULLݒ */
		ch = *q;
		*q = '\0';
	}

	/* vꂽ\[X邩 */
	res = (HTTPD_RESOURCE far *)httpd_resource_tbl;
	res_num = sizeof(httpd_resource_tbl)/sizeof(HTTPD_RESOURCE);
	for (i = 0; i < res_num; i++) {
		if (strcmp((char*)buf, (char*)res->uri) == 0) {
			res_info->res = (HTTPD_RESOURCE far *)res;
			if (res->type == RESTYPE_CGI) {
				p = buf + strlen((char*)res->uri);			/* ?̌܂Ń|C^i߂ */
				*p = ch;							/* NULLɒu̕A */
				if (strlen((char*)p) > QUERY_PARAM_SIZE) {
					break;
				}
				strcpy((char*)res_info->param, (char*)p);
			}
			return (0);
		}
		res++;
	}

__httpd_parse_request_not_found:
	/* vꂽ\[XȂꍇA"Not Found"ݒ */
	res_info->res = (HTTPD_RESOURCE far *)&httpd_resource_not_found;
	return (-1);
}



ER httpd_snd_response(ID cepid, HTTPD_RESOURCE_INFO *res_info)
{
	ER  ercd = -1;
	HTTPD_RESOURCE	far *res;

	res = res_info->res;

	/* CGI */
	if (res->type == RESTYPE_CGI) {
		ercd = (*res->cgi_func)(cepid, res_info);
	}

	/* X|XM */
	/* CGIvOŃX|X𑗐Mꍇɂ́A
	   e[ures->hdr, res->bodyNULLɐݒ肷 */
	if (res->hdr != NULL) {
		ercd = tcp_snd_dat(cepid, (VP)res->hdr, res->hdr_size, TMO_SND);
		if (ercd != res->hdr_size) return (-1);
	}
	if (res->body != NULL) {
		ercd = tcp_snd_dat(cepid, (VP)res->body, res->body_size, TMO_SND);
		if (ercd != res->body_size) return (-1);
	}

	return (ercd);
}

char TmpBuffer[512];

void UpdateIpInfomation(T_IPV4EP *dstaddr,CONST UB *contents, UB *buf)
{
	
	UB ip1 = (UB)((dstaddr->ipaddr&0xff000000)>>24);
	UB ip2 = (UB)((dstaddr->ipaddr&0x00ff0000)>>16);
	UB ip3 = (UB)((dstaddr->ipaddr&0x0000ff00)>>8);
	UB ip4 = (UB)((dstaddr->ipaddr&0x000000ff));

	*buf = 0;

	strcpy((char*)buf,(char*)contents);
	strcat((char*)buf,(char*)html_start_ipinfo);

/* DHCP */
	if(DemoFlag & DHCP_ON){
		sprintf((char*)TmpBuffer,"\
		<tr>\n	\
			<td>DHCP</td>\n\
			<td>IPAhX擾ς</td>\n\
		</tr>\n\0");
	}
	else{
		sprintf((char*)TmpBuffer,"\
		<tr>\n	\
			<td>DHCP</td>\n\
			<td>DHCP</td>\n\
		</tr>\n\0");
	}

	strcat((char*)buf,(char*)TmpBuffer);
/* IPAhXf[^Rs[ */
	sprintf((char*)TmpBuffer,"\
	<tr>\n	\
		<td>IPAhX</td>\n\
		<td>%d.%d.%d.%d</td>\n\
	</tr>\n\0",\
		tcpudp_env.ipaddr[0],tcpudp_env.ipaddr[1],\
		tcpudp_env.ipaddr[2],tcpudp_env.ipaddr[3]);
	strcat((char*)buf,(char*)TmpBuffer);
	
/* Tulbg}XNf[^Rs[ */
	sprintf((char*)TmpBuffer,"\
	<tr>\n\
		<td>Tulbg}XN</td>\n\
		<td>%3d.%3d.%3d.%3d</td>\n\
	</tr>\n\0",\
		tcpudp_env.maskaddr[0],tcpudp_env.maskaddr[1],\
		tcpudp_env.maskaddr[2],tcpudp_env.maskaddr[3]);
	strcat((char*)buf,(char*)TmpBuffer);
	
/* Q[gEFCAhXf[^Rs[ */	
	sprintf((char*)TmpBuffer,"\
	<tr>\n\
		<td>Q[gEFCAhX</td>\n\
		<td>%3d.%3d.%3d.%3d</td>\n\
	</tr>\n\0",\
		tcpudp_env.gwaddr[0],tcpudp_env.gwaddr[1],\
		tcpudp_env.gwaddr[2],tcpudp_env.gwaddr[3]);
	strcat((char*)buf,(char*)TmpBuffer);
	
/* ڑf[^Rs[ */	
	sprintf((char*)TmpBuffer,"\
	<tr>\n\
		<td>ڑIPAhX</td>\n\
		<td>%3d.%3d.%3d.%3d</td>\n\
	</tr>\n\0",ip1,ip2,ip3,ip4);

	strcat((char*)buf,(char*)TmpBuffer);

/* Mt[f[^Rs[ */	
	sprintf((char*)TmpBuffer,"\
	<tr>\n\
		<td>Mt[</td>\n\
		<td>%ld</td>\n\
	</tr>\n\0",\
		drv_info.rcv_cnt);
	strcat((char*)buf,(char*)TmpBuffer);
	
/* Mf[^ʃf[^Rs[ */
	sprintf((char*)TmpBuffer,"\
	<tr>\n\
		<td>Mf[^(byte)</td>\n\
		<td>%ld</td>\n\
	</tr>\n\0",\
		drv_info.rcv_byte);
	strcat((char*)buf,(char*)TmpBuffer);

/* Mt[f[^Rs[ */	
	sprintf((char*)TmpBuffer,"\
	<tr>\n\
		<td>Mt[</td>\n\
		<td>%ld</td>\n\
	</tr>\n\0",\
		drv_info.snd_cnt);
	strcat((char*)buf,(char*)TmpBuffer);
	
/* Mf[^ʃf[^Rs[ */
	sprintf((char*)TmpBuffer,"\
	<tr>\n\
		<td>Mf[^(byte)</td>\n\
		<td>%ld</td>\n\
	</tr>\n\0",\
		drv_info.snd_byte);
	strcat((char*)buf,(char*)TmpBuffer);

	strcat((char*)buf,(char*)html_end_ipinfo);
	buf[strlen((char*)buf)]=0;
	httpd_resource_tbl[1].body_size = strlen((char*)buf)-1;


}

ER response_body_cgi_ctrl1(ID cepid, HTTPD_RESOURCE_INFO *res_info)
{

	/* TCP/IP̍XV */
	UpdateIpInfomation(&dstaddr,response_body,ContentsBuffer);
	return (0);
}



/* Copyright 2005, RENESAS TECHNOLOGY CORPORATION */







