/*""FILE COMMENT""**********************************************************************
*  
*  	System Name  : H8S/2472 Sample Program                                                                   
*  	FILE Name    : ether.c
*  	Version      : 1.00.00
*  	Contents     : EthernetM  
*  	Model        :                                                                                                                         
*  	CPU          : H8S/2472                                                
*  	Compiler     :  
*  	OS           : None
*  
*  	note         : EthernetM̎QlvOłB
*                    <ӎ>
*@@@    @@@@@{TvvOׂ͂ĎQlł
*                    ̓ۏ؂̂ł͂܂B
*@@@@@@@@    {TvvO͂ql̃\tgEGAJ
*A@@@@@@    @ZpQlƂĂpB
*                                                                      
* 
* 	Copyright  (C)  2007 Renesas Technology Corp. All Rights Reserved
* @ 	AND Renesas Solutions Corp. All Rights Reserved
*                                                                    
*  	history      : 2007.05.15 ver 1.00.00
*""FILE COMMENT END""*******************************************************************/
#include <machine.h>
#include <string.h>
#include "iodefine2472.h"
#include "ether.h"
#include "phy.h"

#define	BIT_SET
//#undef	BIT_SET

//#define	ETHER_LOOP_BACK


/* ==== vg^Cv錾 ==== */
static void lan_reg_reset(void);
static void lan_reg_set(int link);
static void lan_desc_create(void);

/* ==== ϐ錾 ==== */
volatile static int tx_flag0;
static int	rx_flag0 = 0;
extern unsigned char _myethaddr[6];	// add : ishiguro(071219)

/*static*/  EDMAC_SEND_DESC  *psenddesc0;
/*static*/  EDMAC_RECV_DESC	 *precvdesc0;
/* fBXNv^16oCgEɔzuKv邽߁Ap̃ZNVƂ܂B */
#pragma section TXRXBUFFDESC
static 	TXRX_BUFFER_SET	 buffer0;
static  TXRX_DESCRIPTOR_SET	 descriptor0;
#pragma section
/*""FUNC COMMENT""*********************************************************************************
* ID              :
* W[Tv  : LANI[v֐
*-------------------------------------------------------------------------------------------------
* Include         : #include  "iodefine.h"
*-------------------------------------------------------------------------------------------------
* 錾            : int lan_open(void) 
*-------------------------------------------------------------------------------------------------
* @\			  : E-DMAC,EtherC,/MfBXNv^A/Mobt@̏s܂B
*                 : PHY-LSI̎ʂ擾AŝƂ̓G[Ԃ܂B
*-------------------------------------------------------------------------------------------------
* 			  : 
*-------------------------------------------------------------------------------------------------
* ߂l	  	  :  0(OPEN_OK) : I[v
*				  : -1(OPEN_NG) : I[vs
*-------------------------------------------------------------------------------------------------
* ӎ	      : 
*		          : 
*                 : 
*		          : 
*""FUNC COPMMENT END""****************************************************************************/
int lan_open(void)
{
	unsigned int physts;
	
	/* ==== EtherC/E-DMAC̃Zbg ==== */	
	lan_reg_reset();

	/* ==== MfBXNv^̏ ==== */
	lan_desc_create();

#ifdef ETHER_LOOP_BACK
#ifdef BIT_SET
		MAC0.ECMR.BIT.ILB =1;	/*  */
#else
		MAC0.ECMR.LONG = MAC0.ECMR.LONG | 0x00000008;
#endif
	physts = FULL_TX;	

#endif

	/* ==== PHY-LSIʂ̎擾 ==== */	
   	physts = phy_autonego();

	/* ====  ==== */	
	if(physts != NEGO_FAIL){

		/* ==== EtherC/E-DMACWX^ݒ ==== */
		lan_reg_set(physts);
	}
/*
	else{
		while(1);
	}
*/
	return OPEN_OK;
}


/*""FUNC COMMENT""*********************************************************************************
* ID              :
* W[Tv  : LANN[Y֐
*-------------------------------------------------------------------------------------------------
* Include         : #include  "iodefine.h"
*-------------------------------------------------------------------------------------------------
* 錾            : int lan_close(void) 
*-------------------------------------------------------------------------------------------------
* @\			  : Ether@\~đM֎~܂B
*-------------------------------------------------------------------------------------------------
* 			  : void
*-------------------------------------------------------------------------------------------------
* ߂l	  	  : 0(CLOSE_OK) : N[Y 
*				  : -1(CLOSE_NG) : N[Ys
*-------------------------------------------------------------------------------------------------
* ӎ	      : 
*		          : 
*                 : 
*		          : 
*""FUNC COPMMENT END""****************************************************************************/
int lan_close(void)
{
	/* ==== EtherC,E-DMAC֘AWX^̃Zbg ==== */
	lan_reg_reset();

	/* ==== 荞ݗD惌xݒ背WX^(IPRG)̐ݒ ==== */
//	INTX.IPRG.BIT._EDMAC1 = 0x0;	/* E-DMAC0̗D惌x0ɐݒ */
	INT.ICRD.BIT.ICRD5 = 0;

	return CLOSE_OK;
}

/*""FUNC COMMENT""*********************************************************************************
* ID              :
* W[Tv  : EtherC/E-DMACZbg֐
*-------------------------------------------------------------------------------------------------
* Include         : #include  "iodefine.h"
*-------------------------------------------------------------------------------------------------
* 錾            : static void lan_reg_reset(void) 
*-------------------------------------------------------------------------------------------------
* @\			  : E-DMAC,EtherC̃\tgEGAZbgs܂B
*                 : 
*-------------------------------------------------------------------------------------------------
* 			  : 
*-------------------------------------------------------------------------------------------------
* ߂l	  	  :  Ȃ
*				  : 
*-------------------------------------------------------------------------------------------------
* ӎ	      : 
*		          : 
*                 : 
*		          : 
*""FUNC COPMMENT END""****************************************************************************/
static void lan_reg_reset(void)
{
	volatile int t = 200;	/* 1usEGCgJEg @198MHz */

	/* ==== E-DMAC[hWX^(EDMR)̐ݒ ==== */
	EDMAC0.EDMR.BIT.SWR =1;

	/* ==== Bӂ64TCN(970ns@B=66MHz)҂KvB}jA19-4Q ==== */
	while(--t){
		/* wait */
	}
}

/*""FUNC COMMENT""*********************************************************************************
* ID              :
* W[Tv  : EtherC/E-DMACWX^̏ݒ
*-------------------------------------------------------------------------------------------------
* Include         : #include  "iodefine.h"
*-------------------------------------------------------------------------------------------------
* 錾            : static void lan_reg_set(int link) 
*-------------------------------------------------------------------------------------------------
* @\			  : E-DMAC,EtherCWX^̐ݒsAM\Ԃɂ܂B
*                 : M̐ݒ͂Ă܂AMN͍sĂ܂B
*                 : MCAMSEN0,1[q̐MQƂȂ悤TSU_FWSLC̏l
*                 : ύXĂ܂B
*-------------------------------------------------------------------------------------------------
* 			  : int link: I : PHY 
*				  :               HALF_10M(1), FULL_10M(2), HALF_TX(3), FULL_TX(4)
*				  :
*-------------------------------------------------------------------------------------------------
* ߂l	  	  :  Ȃ
*				  : 
*-------------------------------------------------------------------------------------------------
* ӎ	      : OCAMgpȂƂOƂĂ܂B
*		          : T3pMACAhXOϐ_myethaddrĂ悤ɕύX܂B
*                 : (by ishiguro 071219)
*		          : 
*""FUNC COPMMENT END""****************************************************************************/
static void lan_reg_set(int link)
{
	unsigned long mac_addr_high=0;
	unsigned long mac_addr_low=0;
	
	mac_addr_high  = (unsigned long)_myethaddr[0] << 24;
	mac_addr_high |= (unsigned long)_myethaddr[1] << 16;
	mac_addr_high |= (unsigned long)_myethaddr[2] << 8;
	mac_addr_high |= (unsigned long)_myethaddr[3];
	mac_addr_low   = (unsigned long)_myethaddr[4] << 8;
	mac_addr_low  |= (unsigned long)_myethaddr[5];
	
	/* ==== EtherCXe[^XWX^(ECSR)̃NA ==== */
	MAC0.ECSR.LONG = 0x00000007; /* 1CgNA */ 

	/* ==== EtherC/E-DMACXe[^XWX^(EESR)̃NA ==== */
	EDMAC0.EESR.LONG = 0x47FF0F9F;	 /* 1CgNA */

	/* ==== MfBXNv^擪AhXWX^(TDLAR)̐ݒ ==== */
	EDMAC0.TDLAR = descriptor0.send_desc;

	/* ==== fBXNv^擪AhXWX^(RDLAR)̐ݒ ==== */
	EDMAC0.RDLAR = descriptor0.recv_desc;

	/* ==== MXe[^XRs[wWX^(TRSCER)̐ݒ ==== */
	EDMAC0.TRSCER.LONG = 0x00000000;

	/* ==== MFIFOlw背WX^(TFTR)̐ݒ ==== */
//	EDMAC0.TFTR = 0x00000000;	/* XgAtH[h[h */
	EDMAC0.TFTR.LONG = 0x00000000;	/* XgAtH[h[h */
	                            /* eNjJAbvf[guTN-SH7-A583A/Jv̑΍ */

	/* ==== FIFOeʎw背WX^(FDR)̐ݒ ==== */
	EDMAC0.FDR.LONG = 0x00000707;	/* MFIFOeʂ2KBɐݒ */
	                                /* eNjJAbvf[guTN-SH7-A583A/Jv̑΍ */

//	MAC0.RFLR.LONG = 0x00000800;

   	/* ==== M䃌WX^(RMCR)̐ݒ ==== */
//	EDMAC0.RCR.BIT.RNC = 0x1;	/* AM */
#ifdef BIT_SET
	EDMAC0.RMCR.BIT.RNC = 0x1;	/* AM */
#else
	EDMAC0.RMCR.LONG = 0x00000001;
#endif

	/* ==== MACAhX/ʐݒ背WX^(MAHR,MALR)̐ݒ ==== */
//	MAC0.MAHR = MAC_ADDRESS_HIGH0;
//	MAC0.MALR = MAC_ADDRESS_LOW0;
//	MAC0.MAHR.LONG = MAC_ADDRESS_HIGH0;
//	MAC0.MALR.LONG = MAC_ADDRESS_LOW0;
	MAC0.MAHR.LONG = mac_addr_high;
	MAC0.MALR.LONG = mac_addr_low;
	
	/* ====]@\ʐݒ背WX^(TSU_FWSLC)̐ݒ ==== */
//	TSU.TSU_FWSLC.LONG = 0x00000000;	/* CAMSEN0,1[qgȂƂ0ɐݒ肵Ă */

	/* ==== 荞ݗD惌xݒ背WX^(IPRG)̐ݒ ==== */	
//	INTX.IPRG.BIT._EDMAC1 = EDMAC0_PRIORITY;	/* E-DMAC0̗D惌xݒ */
	INT.ICRD.BIT.ICRD5 = 1;

	/* ==== EtherC荞݋WX^(ECSIPR)̐ݒ ==== */
	MAC0.ECSIPR.LONG = 0x0000;	/* Ss(NMω 
									Magic Packeto
									sLAo) */

	/* ==== EtherC/E-DMACXe[^X荞݋WX^(EESIPR)̐ݒ ==== */		
	EDMAC0.EESIPR.LONG = 0x073c039f;	/* M֘Av̂݋ */
//	EDMAC0.EESIPR.LONG = 0x04380300;	/* M֘Av̂݋ */
//	EDMAC0.EESIPR.LONG = 0x0304009f;	/* M֘Av̂݋ */
											/* AMfBXNv^͊
											@ MFIFOI[ot[܂ */

	/* ==== EtherC[hWX^(ECMR)̐ݒ ==== */
	if(link == FULL_TX || link == FULL_10M){
#ifdef BIT_SET
		MAC0.ECMR.BIT.DM =1;	/* Sd */
#else
		MAC0.ECMR.LONG = MAC0.ECMR.LONG | 0x00000002;
#endif
	}
	else {
#ifdef BIT_SET
		MAC0.ECMR.BIT.DM =0;	/* d */
#else
		MAC0.ECMR.LONG = MAC0.ECMR.LONG & ~0x00000002;
#endif
	}

	if(link == FULL_TX || link == HALF_TX){
#ifdef BIT_SET
		EDMAC0.ECBRR.BIT.RTM =1;	/* 100Mbps */
#else
		EDMAC0.ECBRR.BYTE = EDMAC0.ECBRR.BYTE | 0x01;
#endif
	}
	else {
#ifdef BIT_SET
		EDMAC0.ECBRR.BIT.RTM =0;	/* 10Mbps */
#else
		MAC0.ECBRR.BYTE = EDMAC0.ECBRR.BYTE & ~0x01;
#endif
	}

#ifdef BIT_SET
	MAC0.ECMR.BIT.RE = 1;	/* M */
	MAC0.ECMR.BIT.TE = 1;	/* M */
#else
	MAC0.ECMR.LONG = MAC0.ECMR.LONG | 0x00000060;
#endif

	/* ==== E-DMACMvWX^(EDRRR)̐ݒ ==== */		
	EDMAC0.EDRRR.LONG = 0x00000001;	/* M\ */
}

/*""FUNC COMMENT""*************************************************************************************
* ID              :
* W[Tv  : MfBXNv^̏
*-----------------------------------------------------------------------------------------------------
* Include         : #include  "iodefine.h"
*-----------------------------------------------------------------------------------------------------
* 錾            : static void lan_desc_create(void) 
*-----------------------------------------------------------------------------------------------------
* @\			  : MfBXNv^̏yёMobt@܂B
*                 : fBXNv^O\ɂ܂B
*-----------------------------------------------------------------------------------------------------
* 			  : 
*				  : 
*-----------------------------------------------------------------------------------------------------
* ߂l	  	  :  Ȃ
*				  : 
*-----------------------------------------------------------------------------------------------------
* ӎ	      : TACTTDL0ŏ܂Blan_send֐Őݒ肵Ă܂B
*		          : 
*                 : 
*		          : 
*""FUNC COPMMENT END""********************************************************************************/
static void lan_desc_create(void)
{
	int i;
	EDMAC_SEND_DESC *psnd;
	EDMAC_RECV_DESC *prcv;

	/* ==== MfBXNv^0NA ==== */
	memset(&descriptor0,0x0,sizeof(descriptor0));

	/* ==== MfBXNv^ݒ ==== */
	psnd = descriptor0.send_desc;
	for(i = 0; i<NUM_OF_TX_DESCRIPTOR ;i++){
		psnd->td2.TBA = &buffer0.send_buf[i][0];
		psnd->td0.BIT.TFP =0x3;	/* 1t[/1fBXNv^ */
		psnd->pNext = psnd +1;
		psnd++;
	}
	psnd--;
	psnd->td0.BIT.TDLE = 1;
	psnd->pNext = descriptor0.send_desc;

	/* ==== MfBXNv^ݒ ==== */
	prcv = descriptor0.recv_desc;
	for(i = 0; i<NUM_OF_RX_DESCRIPTOR ;i++){
		prcv->rd0.BIT.RFP =0x3;	/* 1t[/1fBXNv^ */
		prcv->rd0.BIT.RACT =0x1;	/* MfBXNv^L */
		prcv->rd1.RBL = 0x05f0;
		prcv->rd2.RBA = &buffer0.recv_buf[i][0];
		prcv->pNext = prcv +1;
		prcv++;
	}
	prcv--;
	prcv->rd0.BIT.RDLE = 1;
	prcv->pNext = descriptor0.recv_desc;

	/* ==== Mobt@0NA ==== */
	memset(&buffer0,0x0,sizeof(buffer0));

	/* ==== MfBXNv^ւ̃|C^ݒ ==== */
	psenddesc0 = descriptor0.send_desc;
	precvdesc0 = descriptor0.recv_desc;

}

/*""FUNC COMMENT""*************************************************************************************
* ID              :
* W[Tv  : C[Tlbgt[M֐
*-----------------------------------------------------------------------------------------------------
* Include         : #include  "iodefine.h"
*-----------------------------------------------------------------------------------------------------
* 錾            : int lan_send(unsigned char *addr, int flen) 
*-----------------------------------------------------------------------------------------------------
* @\			  : Ŏw肳ꂽf[^𑗐Mobt@ɃRs[܂B
*                 : MfBXNv^ݒ肵AMN܂B
*                 : "MtO"mFAOFFłΑMƔf܂B
*                 : eNjJAbvf[guTN-SH7-A575B/JvyсuTN-SH7-A583A/JvɂA
*                 : s΍Ă܂B
*-----------------------------------------------------------------------------------------------------
* 			  : unsigned char *addr : I : MEthert[̐擪AhX
*				  : int flen : I   : t[TCY(oCg)
*				  :
*-----------------------------------------------------------------------------------------------------
* ߂l	  	  : 0(SEND_OK) : M
*				  : -1(SEND_NG): Ms
*-----------------------------------------------------------------------------------------------------
* ӎ	      :uTN-SH7-A575B/JvF荞݂ĂEESRWX^ɔfȂꍇs
*                 : ΍FTACTrbgmFACgobN(TACT=0)ĂΑMƔfĂ܂B
*		          : 
*                 :uTN-SH7-A583A/JvFMA_t[ɂfbhbN\s
*		          : ΍FTFTRWX^ŃXgA&tH[h[hɂ܂BȂƂ́A
*                 :       MA_t[ɂfbhbN\܂B{vOł́A
*                 :       đ15񎸔sɂő及vԂ҂(400ms)A܂łTACT0ɂȂȂ
*                 :       ꍇ͖߂lSEND_NGԂ܂B
*""FUNC COPMMENT END""********************************************************************************/
int lan_send(unsigned char *addr, int flen)
{
	volatile int    w;
	volatile int	t1ms = 100;	/* 1msJE^ */
	volatile int	t400ms = 400;	/* 400msJE^ */
	int             value;

	/* ==== MfBXNv^TACTrbg0ɂȂ܂ő҂ ==== */
	while(psenddesc0->td0.BIT.TACT == 1){
		/* wait */
	}			

	/* ==== MtOON ==== */
	tx_flag0 = TX_FLAG_ON;

	/* ==== Mobt@Ɉw̑Mpf[^Rs[ ==== */
	memcpy(psenddesc0->td2.TBA,addr,flen);

	/* ==== MfBXNv^̐ݒ==== */
	psenddesc0->td1.TDL = flen;
	psenddesc0->td0.BIT.TACT = 1;

	/* ==== MN ==== */
	/* }jA19-36  19.4.1 E-DMACMvWX^(EDTRR)gp̒ӎ */
//	if(EDMAC0.EDTRR.BIT.TR == 0){
	if((EDMAC0.EDTRR.LONG & 0x00000001) == 0){
#ifdef BIT_SET
		EDMAC0.EDTRR.BIT.TR = 1;
#else
		EDMAC0.EDTRR.LONG = 0x00000001;
#endif
	}
#if 0		// T3͊荞݂̒lan_send()ĂԂ̂ŁAƂ肠Mŝ͖ƂĈȉ̏͏Ȃ
			// ^C}荞݂LANRg[荞݂̗DxグāAd荞݂OKۂłB
			// changed by ishiguro(071219)
	/* ==== M̊mF  ==== */
	while(tx_flag0 == TX_FLAG_ON){	/* MtOI */

		/* ==== 10us wait ==== */
		for(w=0;w<2000;w++){
			;
		}

		/* ==== eNjJAbvf[guTN-SH7-A575B/Jv̑΍ ==== */
		if((--t1ms) <= 0){	/* 1msoߎ */
			t1ms = 100;	/* 1msJE^̏ */
			if(psenddesc0->td0.BIT.TACT == 0){
				tx_flag0 = TX_FLAG_OFF; 
				break;
			}
			/* ==== eNjJAbvf[guTN-SH7-A583A/Jv̑΍ ==== */
			else if((--t400ms) <= 0){	/* 400msoߎ */
				return SEND_NG;
			}
			else{
				/* DO NOTHING */
			}
		}
	}
#endif
	/* ==== MfBXNv^̐ݒ==== */
	psenddesc0 = psenddesc0->pNext;	/* fBXNv^Ǘp|C^̍XV */

	return SEND_OK;
}

/*""FUNC COMMENT""*************************************************************************************
* ID              :
* W[Tv  : C[Tlbgt[M֐
*-----------------------------------------------------------------------------------------------------
* Include         : #include  "iodefine.h"
*-----------------------------------------------------------------------------------------------------
* 錾            : int lan_recv(unsigned char *addr) 
*-----------------------------------------------------------------------------------------------------
* @\			  : C[Tlbgt[1t[M܂B
*                 : M邽т"MʒmJE^"̒l1fNg܂B
*		          : Mt[ɃG[ȂƂ͈Ŏw肵[Uobt@ɃRs[܂B
*-----------------------------------------------------------------------------------------------------
* 			  : unsigned char *addr : O : MEthert[̃Rs[擪AhX
*				  :
*				  :
*-----------------------------------------------------------------------------------------------------
* ߂l	  	  : Mt[̃oCg : M
*				  :
*-----------------------------------------------------------------------------------------------------
* ӎ	      :  
*                 : 
*		          : 
*""FUNC COPMMENT END""********************************************************************************/
int lan_recv(unsigned char *addr)
{
    int i;
    int dsize = 0;	/* MoCg */

    /* ==== Mf[^̗L`FbNMf[^Ζ߂==== */
    if(precvdesc0->rd0.BIT.RACT == 0x1){/* Mf[^ */
         return -1;
    }
    else if(precvdesc0->rd0.BIT.RACT == 0x0){/* Mf[^ */
		
        /* ==== Mt[G[̊mF ==== */
        if(precvdesc0->rd0.BIT.RFE == 0){/* Mt[G[ */
            memcpy(addr,precvdesc0->rd2.RBA,precvdesc0->rd1.RDL);
            dsize = precvdesc0->rd1.RDL;
        }

        /* ==== MfBXNv^̏ ==== */
        precvdesc0->rd0.LONG &= 0x40000000;	/* RDLEȊO0NA */
        precvdesc0->rd0.BIT.RFP =0x3;/* 1t[/1fBXNv^ */
        precvdesc0->rd0.BIT.RACT =0x1;	/* MfBXNv^L */
        precvdesc0->rd1.RDL = 0x0000;
        precvdesc0 = precvdesc0->pNext;

	/* ==== MN ==== */
	/* }jA19-36  19.4.1 E-DMACMvWX^(EDRRR)gp̒ӎ */
//	if(EDMAC0.EDRRR.BIT.RR == 0){
	if((EDMAC0.EDRRR.LONG & 0x00000001) == 0){
#ifdef BIT_SET
	    EDMAC0.EDRRR.BIT.RR = 1;
#else
	    EDMAC0.EDRRR.LONG = 0x00000001;
#endif
	}
        return dsize;
    }
}
	
/*""FUNC COMMENT""*************************************************************************************
* ID              :
* W[Tv  : E-DMACM荞ݏ(ch0)
*-----------------------------------------------------------------------------------------------------
* Include         : #include  "iodefine.h"
*-----------------------------------------------------------------------------------------------------
* 錾            : void INT_EDMAC_EINT0(void) 
*-----------------------------------------------------------------------------------------------------
* @\			  : t[M荞ݏs܂B
*                 : t[MA"MtO"OFFɂ܂B
* @\			  : t[M(G[t[܂)ƂA
*                 : "MʒmJE^"̒l1CNg܂B
*-----------------------------------------------------------------------------------------------------
* 			  : Ȃ
*				  :
*-----------------------------------------------------------------------------------------------------
* ߂l	  	  : Ȃ 
*				  : 
*-----------------------------------------------------------------------------------------------------
* ӎ	      : M֘A荞ݗv̂AE-DMACɂt[M𔺂Ȃ
*		          : MfBXNv^͊(RDE)ƎMFIFOI[ot[(RFOF)
*                 : rx_flag0CNgv珜܂B
*""FUNC COPMMENT END""********************************************************************************/
	unsigned long status2;
#pragma section IntPRG
__interrupt(vect=119) void INT_EDMAC_EINT0(void)
{
	unsigned long status;
	

	status2 = EDMAC0.EESR.LONG;

	/* ==== 荞݃Xe[^Xǂݏo ==== */
	status = EDMAC0.EESR.LONG & EDMAC0.EESIPR.LONG;
	
	/* ==== 荞ݗvNA ==== */
	EDMAC0.EESR.LONG = status;	/* 1CgNA */
	
	/* ==== t[M ==== */
	if(status & FRAME_TRANSMIT_COMPLETE){
		tx_flag0 = TX_FLAG_OFF;
	}

	/* ==== M֘A荞ݎ ==== */
	if(status & 0x0304009f){
			/* L0x0304009f̓e */	
			/* Mfo */
			/* Mt[JE^I[ot[ */
			/* t[M */
			/* }`LXgAhXt[M */
			/* [rbgt[M */
			/* Ot[M */
			/* V[gt[M */
			/* PHY-LSIMG[ */
			/* Mt[CRCG[ */

		rx_flag0++;
	}
}
#pragma section
/* End of File */
