/***********************************************************************/
/* IO_2472_Rev00 Include File                           Beta ver.1.0   */
/***********************************************************************/
struct st_ether {                                      /* struct ETHER */
       union {                                         /* ECMR         */
             unsigned long LONG;                       /*  Long Access */
             struct {                                  /*  Word Access */
                    unsigned short H;                  /*   High       */
                    unsigned short L;                  /*   Low        */
                    } WORD;                            /*              */
             struct {                                  /*  Bit Access  */
                    unsigned long :12;                 /*              */
                    unsigned long ZPF:1;               /*   ZPF        */
                    unsigned long PFR:1;               /*   PFR        */
                    unsigned long RXF:1;               /*   RXF        */
                    unsigned long TXF:1;               /*   TXF        */
                    unsigned long :3;                  /*              */
                    unsigned long PRCEF:1;             /*   PRCEF      */
                    unsigned long :2;                  /*              */
                    unsigned long MPDE:1;              /*   MPDE       */
                    unsigned long :2;                  /*              */
                    unsigned long RE:1;                /*   RE         */
                    unsigned long TE:1;                /*   TE         */
                    unsigned long :1;                  /*              */
                    unsigned long ILB:1;               /*   ILB        */
                    unsigned long ELB:1;               /*   ELB        */
                    unsigned long DM:1;                /*   DM         */
                    unsigned long PRM:1;               /*   PRM        */
                    } BIT;                             /*              */
             } ECMR;                                   /*              */
       union {                                         /* ECSR         */
             unsigned long LONG;                       /*  Long Access */
             struct {                                  /*  Word Access */
                    unsigned short H;                  /*   High       */
                    unsigned short L;                  /*   Low        */
                    } WORD;                            /*              */
             struct {                                  /*  Bit Access  */
                    unsigned long :27;                 /*              */
                    unsigned long PSRTO:1;             /*   PSRTO      */
                    unsigned long :1;                  /*              */
                    unsigned long LCHNG:1;             /*   LCHNG      */
                    unsigned long MPD:1;               /*   MPD        */
                    unsigned long ICD:1;               /*   ICD        */
                    } BIT;                             /*              */
             } ECSR;                                   /*              */
       union {                                         /* ECSIPR       */
             unsigned long LONG;                       /*  Long Access */
             struct {                                  /*  Word Access */
                    unsigned short H;                  /*   High       */
                    unsigned short L;                  /*   Low        */
                    } WORD;                            /*              */
             struct {                                  /*  Bit Access  */
                    unsigned long :27;                 /*              */
                    unsigned long PSRTOIP:1;           /*   PSRTOIP    */
                    unsigned long :1;                  /*              */
                    unsigned long LCHNGIP:1;           /*   LCHNGIP    */
                    unsigned long MPDIP:1;             /*   MPDIP      */
                    unsigned long ICDIP:1;             /*   ICDIP      */
                    } BIT;                             /*              */
             } ECSIPR;                                 /*              */
       union {                                         /* PIR          */
             unsigned long LONG;                       /*  Long Access */
             struct {                                  /*  Word Access */
                    unsigned short H;                  /*   High       */
                    unsigned short L;                  /*   Low        */
                    } WORD;                            /*              */
             struct {                                  /*  Bit Access  */
                    unsigned long :28;                 /*              */
                    unsigned long MDI:1;               /*   MDI        */
                    unsigned long MDO:1;               /*   MDO        */
                    unsigned long MMD:1;               /*   MMD        */
                    unsigned long MDC:1;               /*   MDC        */
                    } BIT;                             /*              */
             } PIR;                                    /*              */
       union {                                         /* MAHR         */
             unsigned long LONG;                       /*  Long Access */
             struct {                                  /*  Word Access */
                    unsigned short H;                  /*   High       */
                    unsigned short L;                  /*   Low        */
                    } WORD;                            /*              */
             struct {                                  /*  Bit Access  */
                    unsigned long MA47:1;              /*   MA47       */
                    unsigned long MA46:1;              /*   MA46       */
                    unsigned long MA45:1;              /*   MA45       */
                    unsigned long MA44:1;              /*   MA44       */
                    unsigned long MA43:1;              /*   MA43       */
                    unsigned long MA42:1;              /*   MA42       */
                    unsigned long MA41:1;              /*   MA41       */
                    unsigned long MA40:1;              /*   MA40       */
                    unsigned long MA39:1;              /*   MA39       */
                    unsigned long MA38:1;              /*   MA38       */
                    unsigned long MA37:1;              /*   MA37       */
                    unsigned long MA36:1;              /*   MA36       */
                    unsigned long MA35:1;              /*   MA35       */
                    unsigned long MA34:1;              /*   MA34       */
                    unsigned long MA33:1;              /*   MA33       */
                    unsigned long MA32:1;              /*   MA32       */
                    unsigned long MA31:1;              /*   MA31       */
                    unsigned long MA30:1;              /*   MA30       */
                    unsigned long MA29:1;              /*   MA29       */
                    unsigned long MA28:1;              /*   MA28       */
                    unsigned long MA27:1;              /*   MA27       */
                    unsigned long MA26:1;              /*   MA26       */
                    unsigned long MA25:1;              /*   MA25       */
                    unsigned long MA24:1;              /*   MA24       */
                    unsigned long MA23:1;              /*   MA23       */
                    unsigned long MA22:1;              /*   MA22       */
                    unsigned long MA21:1;              /*   MA21       */
                    unsigned long MA20:1;              /*   MA20       */
                    unsigned long MA19:1;              /*   MA19       */
                    unsigned long MA18:1;              /*   MA18       */
                    unsigned long MA17:1;              /*   MA17       */
                    unsigned long MA16:1;              /*   MA16       */
                    } BIT;                             /*              */
             } MAHR;                                   /*              */
       union {                                         /* MALR         */
             unsigned long LONG;                       /*  Long Access */
             struct {                                  /*  Bit Access  */
                    unsigned long :16;                 /*              */
                    unsigned long MA:16;               /*   MA         */
                    } BIT;                             /*              */
             } MALR;                                   /*              */
       union {                                         /* RFLR         */
             unsigned long LONG;                       /*  Long Access */
             struct {                                  /*  Word Access */
                    unsigned short H;                  /*   High       */
                    unsigned short L;                  /*   Low        */
                    } WORD;                            /*              */
             struct {                                  /*  Bit Access  */
                    unsigned long :20;                 /*              */
                    unsigned long RFL:12;              /*   RFL        */
                    } BIT;                             /*              */
             } RFLR;                                   /*              */
       union {                                         /* PSR          */
             unsigned long LONG;                       /*  Long Access */
             struct {                                  /*  Word Access */
                    unsigned short H;                  /*   High       */
                    unsigned short L;                  /*   Low        */
                    } WORD;                            /*              */
             struct {                                  /*  Bit Access  */
                    unsigned long :31;                 /*              */
                    unsigned long LMON:1;              /*   LMON       */
                    } BIT;                             /*              */
             } PSR;                                    /*              */
       unsigned long TROCR;                            /* TROCR        */
       unsigned long CDCR;                             /* CDCR         */
       unsigned long LCCR;                             /* LCCR         */
       unsigned long CNDCR;                            /* CNDCR        */
       unsigned char wk0[4];                           /*              */
       unsigned long CEFCR;                            /* CEFCR        */
       unsigned long FRECR;                            /* FRECR        */
       unsigned long TSFRCR;                           /* TSFRCR       */
       unsigned long TLFRCR;                           /* TLFRCR       */
       unsigned long RFCR;                             /* RFCR         */
       unsigned long MAFCR;                            /* MAFCR        */
       unsigned char wk1[8];                           /*              */
       union {                                         /* IPGR         */
             unsigned long LONG;                       /*  Long Access */
             struct {                                  /*  Word Access */
                    unsigned short H;                  /*   High       */
                    unsigned short L;                  /*   Low        */
                    } WORD;                            /*              */
             struct {                                  /*  Bit Access  */
                    unsigned long :27;                 /*              */
                    unsigned long IPG:5;               /*   IPG        */
                    } BIT;                             /*              */
             } IPGR;                                   /*              */
       union {                                         /* APR          */
             unsigned long LONG;                       /*  Long Access */
             struct {                                  /*  Bit Access  */
                    unsigned long :16;                 /*              */
                    unsigned long AP:16;               /*   AP         */
                    } BIT;                             /*              */
             } APR;                                    /*              */
       union {                                         /* MPR          */
             unsigned long LONG;                       /*  Long Access */
             struct {                                  /*  Bit Access  */
                    unsigned long :16;                 /*              */
                    unsigned long MP:16;               /*   MP         */
                    } BIT;                             /*              */
             } MPR;                                    /*              */
       unsigned char wk2[4];                           /*              */
       union {                                         /* TPAUSER      */
             unsigned long LONG;                       /*  Long Access */
             struct {                                  /*  Bit Access  */
                    unsigned long :16;                 /*              */
                    unsigned long TPAUSE:16;           /*   TPAUSE     */
                    } BIT;                             /*              */
             } TPAUSER;                                /*              */
};                                                     /*              */
struct st_edmac {                                      /* struct EDMAC */
       union {                                         /* EDMR         */
             unsigned long LONG;                       /*  Long Access */
             struct {                                  /*  Word Access */
                    unsigned short H;                  /*   High       */
                    unsigned short L;                  /*   Low        */
                    } WORD;                            /*              */
             struct {                                  /*  Bit Access  */
                    unsigned long :25;                 /*              */
                    unsigned long DE:1;                /*   DE         */
                    unsigned long DL:2;                /*   DL         */
                    unsigned long :3;                  /*              */
                    unsigned long SWR:1;               /*   SWR        */
                    } BIT;                             /*              */
             } EDMR;                                   /*              */
       union {                                         /* EDTRR        */
             unsigned long LONG;                       /*  Long Access */
             struct {                                  /*  Bit Access  */
                    unsigned long :31;                 /*              */
                    unsigned long TR:1;                /*   TR         */
                    } BIT;                             /*              */
             } EDTRR;                                  /*              */
       union {                                         /* EDRRR        */
             unsigned long LONG;                       /*  Long Access */
             struct {                                  /*  Bit Access  */
                    unsigned long :31;                 /*              */
                    unsigned long RR:1;                /*   RR         */
                    } BIT;                             /*              */
             } EDRRR;                                  /*              */
//       unsigned long TDLAR;                            /* TDLAR        */
//       unsigned long RDLAR;                            /* RDLAR        */
       void           *TDLAR;                  /* TDLAR        */
       void           *RDLAR;                  /* RDLAR        */
       union {                                         /* EESR         */
             unsigned long LONG;                       /*  Long Access */
             struct {                                  /*  Word Access */
                    unsigned short H;                  /*   High       */
                    unsigned short L;                  /*   Low        */
                    } WORD;                            /*              */
             struct {                                  /*  Bit Access  */
                    unsigned long :1;                  /*              */
                    unsigned long TWB:1;               /*   TWB        */
                    unsigned long :3;                  /*              */
                    unsigned long TABT:1;              /*   TABT       */
                    unsigned long RABT:1;              /*   RABT       */
                    unsigned long RFCOF:1;             /*   RFCOF      */
                    unsigned long ADE:1;               /*   ADE        */
                    unsigned long ECI:1;               /*   ECI        */
                    unsigned long TC:1;                /*   TC         */
                    unsigned long TDE:1;               /*   TDE        */
                    unsigned long TFUF:1;              /*   TFUF       */
                    unsigned long FR:1;                /*   FR         */
                    unsigned long RDE:1;               /*   RDE        */
                    unsigned long RFOF:1;              /*   RFOF       */
                    unsigned long :4;                  /*              */
                    unsigned long CND:1;               /*   CND        */
                    unsigned long DLC:1;               /*   DLC        */
                    unsigned long CD:1;                /*   CD         */
                    unsigned long TRO:1;               /*   TRO        */
                    unsigned long RMAF:1;              /*   RMAF       */
                    unsigned long :2;                  /*              */
                    unsigned long RRF:1;               /*   RRF        */
                    unsigned long RTLF:1;              /*   RTLF       */
                    unsigned long RTSF:1;              /*   RTSF       */
                    unsigned long PRE:1;               /*   PRE        */
                    unsigned long CERF:1;              /*   CERF       */
                    } BIT;                             /*              */
             } EESR;                                   /*              */
       union {                                         /* EESIPR       */
             unsigned long LONG;                       /*  Long Access */
             struct {                                  /*  Word Access */
                    unsigned short H;                  /*   High       */
                    unsigned short L;                  /*   Low        */
                    } WORD;                            /*              */
             struct {                                  /*  Bit Access  */
                    unsigned long :1;                  /*              */
                    unsigned long TWBIP:1;             /*   TWBIP      */
                    unsigned long :3;                  /*              */
                    unsigned long TABTIP:1;            /*   TABTIP     */
                    unsigned long RABTIP:1;            /*   RABTIP     */
                    unsigned long RFCOFIP:1;           /*   RFCOFIP    */
                    unsigned long ADEIP:1;             /*   ADEIP      */
                    unsigned long ECIIP:1;             /*   ECIIP      */
                    unsigned long TCIP:1;              /*   TCIP       */
                    unsigned long TDEIP:1;             /*   TDEIP      */
                    unsigned long TFUFIP:1;            /*   TFUFIP     */
                    unsigned long FRIP:1;              /*   FRIP       */
                    unsigned long RDEIP:1;             /*   RDEIP      */
                    unsigned long RFOFIP:1;            /*   RFOFIP     */
                    unsigned long :4;                  /*              */
                    unsigned long CNDIP:1;             /*   CNDIP      */
                    unsigned long DLCIP:1;             /*   DLCIP      */
                    unsigned long CDIP:1;              /*   CDIP       */
                    unsigned long TROIP:1;             /*   TROIP      */
                    unsigned long RMAFIP:1;            /*   RMAFIP     */
                    unsigned long :2;                  /*              */
                    unsigned long RRFIP:1;             /*   RRFIP      */
                    unsigned long RTLFIP:1;            /*   RTLFIP     */
                    unsigned long RTSFIP:1;            /*   RTSFIP     */
                    unsigned long PREIP:1;             /*   PREIP      */
                    unsigned long CERFIP:1;            /*   CERFIP     */
                    } BIT;                             /*              */
             } EESIPR;                                 /*              */
       union {                                         /* TRSCER       */
             unsigned long LONG;                       /*  Long Access */
             struct {                                  /*  Word Access */
                    unsigned short H;                  /*   High       */
                    unsigned short L;                  /*   Low        */
                    } WORD;                            /*              */
             struct {                                  /*  Bit Access  */
                    unsigned long :20;                 /*              */
                    unsigned long CNDCE:1;             /*   CNDCE      */
                    unsigned long DLCCE:1;             /*   DLCCE      */
                    unsigned long CDCE:1;              /*   CDCE       */
                    unsigned long TROCE:1;             /*   TROCE      */
                    unsigned long RMAFCE:1;            /*   RMAFCE     */
                    unsigned long :2;                  /*              */
                    unsigned long RRFCE:1;             /*   RRFCE      */
                    unsigned long RTLFCE:1;            /*   RTLFCE     */
                    unsigned long RTSFCE:1;            /*   RTSFCE     */
                    unsigned long PRECE:1;             /*   PRECE      */
                    unsigned long CERFCE:1;            /*   CERFCE     */
                    } BIT;                             /*              */
             } TRSCER;                                 /*              */
       union {                                         /* RMFCR        */
             unsigned long LONG;                       /*  Long Access */
             struct {                                  /*  Bit Access  */
                    unsigned long :16;                 /*              */
                    unsigned long MFC:16;              /*   MFC        */
                    } BIT;                             /*              */
             } RMFCR;                                  /*              */
       union {                                         /* TFTR         */
             unsigned long LONG;                       /*  Long Access */
             struct {                                  /*  Bit Access  */
                    unsigned long :21;                 /*              */
                    unsigned long TFT:11;              /*   TFT        */
                    } BIT;                             /*              */
             } TFTR;                                   /*              */
       union {                                         /* FDR          */
             unsigned long LONG;                       /*  Long Access */
             struct {                                  /*  Word Access */
                    unsigned short H;                  /*   High       */
                    unsigned short L;                  /*   Low        */
                    } WORD;                            /*              */
             struct {                                  /*  Bit Access  */
                    unsigned long :21;                 /*              */
                    unsigned long TFD:3;               /*   TFD        */
                    unsigned long :5;                  /*              */
                    unsigned long RFD:3;               /*   RFD        */
                    } BIT;                             /*              */
             } FDR;                                    /*              */
       union {                                         /* RMCR         */
             unsigned long LONG;                       /*  Long Access */
             struct {                                  /*  Bit Access  */
                    unsigned long :31;                 /*              */
                    unsigned long RNC:1;               /*   RNC        */
                    } BIT;                             /*              */
             } RMCR;                                   /*              */
       unsigned char wk0[4];                           /*              */
       union {                                         /* FCFTR        */
             unsigned long LONG;                       /*  Long Access */
             struct {                                  /*  Word Access */
                    unsigned short H;                  /*   High       */
                    unsigned short L;                  /*   Low        */
                    } WORD;                            /*              */
             struct {                                  /*  Bit Access  */
                    unsigned long :13;                 /*              */
                    unsigned long RFF:3;               /*   RFF        */
                    unsigned long :13;                 /*              */
                    unsigned long RFD:3;               /*   RFD        */
                    } BIT;                             /*              */
             } FCFTR;                                  /*              */
       unsigned char wk1[8];                           /*              */
       unsigned long RBWAR;                            /* RBWAR        */
       unsigned long RDFAR;                            /* RDFAR        */
       unsigned char wk2[4];                           /*              */
       unsigned long TBRAR;                            /* TBRAR        */
       unsigned long TDFAR;                            /* TDFAR        */
       union {                                         /* ECBRR        */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char :7;                  /*              */
                    unsigned char RTM:1;               /*   RTM        */
                    } BIT;                             /*              */
             } ECBRR;                                  /*              */
};                                                     /*              */
struct st_usb {                                        /* struct USB   */
       union {                                         /* IFR0         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char BRST:1;              /*   BRST       */
                    unsigned char EP1FULL:1;           /*   EP1FULL    */
                    unsigned char EP2TR:1;             /*   EP2TR      */
                    unsigned char EP2EMPTY:1;          /*   EP2EMPTY   */
                    unsigned char SETUPTS:1;           /*   SETUPTS    */
                    unsigned char EP0OTS:1;            /*   EP0OTS     */
                    unsigned char EP0ITR:1;            /*   EP0ITR     */
                    unsigned char EP0ITS:1;            /*   EP0ITS     */
                    } BIT;                             /*              */
             } IFR0;                                   /*              */
       union {                                         /* IFR1         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char :4;                  /*              */
                    unsigned char VBUSMN:1;            /*   VBUSMN     */
                    unsigned char EP3TR:1;             /*   EP3TR      */
                    unsigned char EP3TS:1;             /*   EP3TS      */
                    unsigned char VBUSF:1;             /*   VBUSF      */
                    } BIT;                             /*              */
             } IFR1;                                   /*              */
       union {                                         /* IFR2         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char :2;                  /*              */
                    unsigned char SURSS:1;             /*   SURSS      */
                    unsigned char SURSF:1;             /*   SURSF      */
                    unsigned char CFDN:1;              /*   CFDN       */
                    unsigned char :1;                  /*              */
                    unsigned char SETC:1;              /*   SETC       */
                    unsigned char SETI:1;              /*   SETI       */
                    } BIT;                             /*              */
             } IFR2;                                   /*              */
       unsigned char wk0[1];                           /*              */
       union {                                         /* IER0         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char BRST:1;              /*   BRST       */
                    unsigned char EP1FULL:1;           /*   EP1FULL    */
                    unsigned char EP2TR:1;             /*   EP2TR      */
                    unsigned char EP2EMPTY:1;          /*   EP2EMPTY   */
                    unsigned char SETUPTS:1;           /*   SETUPTS    */
                    unsigned char EP0OTS:1;            /*   EP0OTS     */
                    unsigned char EP0ITR:1;            /*   EP0ITR     */
                    unsigned char EP0ITS:1;            /*   EP0ITS     */
                    } BIT;                             /*              */
             } IER0;                                   /*              */
       union {                                         /* IER1         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char :5;                  /*              */
                    unsigned char EP3TR:1;             /*   EP3TR      */
                    unsigned char EP3TS:1;             /*   EP3TS      */
                    unsigned char VBUSF:1;             /*   VBUSF      */
                    } BIT;                             /*              */
             } IER1;                                   /*              */
       union {                                         /* IER2         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char :3;                  /*              */
                    unsigned char SURSE:1;             /*   SURSE      */
                    unsigned char CFDN:1;              /*   CFDN       */
                    unsigned char :1;                  /*              */
                    unsigned char SETCE:1;             /*   SETCE      */
                    unsigned char SETIE:1;             /*   SETIE      */
                    } BIT;                             /*              */
             } IER2;                                   /*              */
       unsigned char wk1[1];                           /*              */
       union {                                         /* ISR0         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char BRST:1;              /*   BRST       */
                    unsigned char EP1FULL:1;           /*   EP1FULL    */
                    unsigned char EP2TR:1;             /*   EP2TR      */
                    unsigned char EP2EMPTY:1;          /*   EP2EMPTY   */
                    unsigned char SETUPTS:1;           /*   SETUPTS    */
                    unsigned char EP0OTS:1;            /*   EP0OTS     */
                    unsigned char EP0ITR:1;            /*   EP0ITR     */
                    unsigned char EP0ITS:1;            /*   EP0ITS     */
                    } BIT;                             /*              */
             } ISR0;                                   /*              */
       union {                                         /* ISR1         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char :5;                  /*              */
                    unsigned char EP3TR:1;             /*   EP3TR      */
                    unsigned char EP3TS:1;             /*   EP3TS      */
                    unsigned char VBUSF:1;             /*   VBUSF      */
                    } BIT;                             /*              */
             } ISR1;                                   /*              */
       union {                                         /* ISR2         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char SSRSME:1;            /*   SSRSME     */
                    unsigned char :2;                  /*              */
                    unsigned char SURSE:1;             /*   SURSE      */
                    unsigned char CFDN:1;              /*   CFDN       */
                    unsigned char :1;                  /*              */
                    unsigned char SETCE:1;             /*   SETCE      */
                    unsigned char SETIE:1;             /*   SETIE      */
                    } BIT;                             /*              */
             } ISR2;                                   /*              */
       unsigned char wk2[1];                           /*              */
       unsigned char EPDR0I;                           /* EPDR0I       */
       unsigned char EPDR0O;                           /* EPDR0O       */
       unsigned char EPDR0S;                           /* EPDR0S       */
       unsigned char wk3[1];                           /*              */
       unsigned char EPDR1;                            /* EPDR1        */
       unsigned char wk4[3];                           /*              */
       unsigned char EPDR2;                            /* EPDR2        */
       unsigned char wk5[3];                           /*              */
       unsigned char EPDR3;                            /* EPDR3        */
       unsigned char wk6[11];                          /*              */
       unsigned char EPSZ0O;                           /* EPSZ0O       */
       unsigned char EPSZ1;                            /* EPSZ1        */
       unsigned char wk7[1];                           /*              */
       union {                                         /* DASTS        */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char :2;                  /*              */
                    unsigned char EP3DE:1;             /*   EP3DE      */
                    unsigned char EP2DE:1;             /*   EP2DE      */
                    unsigned char :3;                  /*              */
                    unsigned char EP0IDE:1;            /*   EP0IDE     */
                    } BIT;                             /*              */
             } DASTS;                                  /*              */
       union {                                         /* FCLR         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char :1;                  /*              */
                    unsigned char EP3CLR:1;            /*   EP3CLR     */
                    unsigned char EP1CLR:1;            /*   EP1CLR     */
                    unsigned char EP2CLR:1;            /*   EP2CLR     */
                    unsigned char :2;                  /*              */
                    unsigned char EP0OCLR:1;           /*   EP0OCLR    */
                    unsigned char EP0ICLR:1;           /*   EP0ICLR    */
                    } BIT;                             /*              */
             } FCLR;                                   /*              */
       unsigned char wk8[1];                           /*              */
       union {                                         /* EPSTL        */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char :4;                  /*              */
                    unsigned char EP3STL:1;            /*   EP3STL     */
                    unsigned char EP2STL:1;            /*   EP2STL     */
                    unsigned char EP1STL:1;            /*   EP1STL     */
                    unsigned char EP0STL:1;            /*   EP0STL     */
                    } BIT;                             /*              */
             } EPSTL;                                  /*              */
       unsigned char wk9[1];                           /*              */
       union {                                         /* TRG          */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char :1;                  /*              */
                    unsigned char EP3KTE:1;            /*   EP3KTE     */
                    unsigned char EP1RDFN:1;           /*   EP1RDFN    */
                    unsigned char EP2PKTE:1;           /*   EP2PKTE    */
                    unsigned char :1;                  /*              */
                    unsigned char EP0SRDFN:1;          /*   EP0SRDFN   */
                    unsigned char EP0ORDFN:1;          /*   EP0ORDFN   */
                    unsigned char EP0IPKTE:1;          /*   EP0IPKTE   */
                    } BIT;                             /*              */
             } TRG;                                    /*              */
       union {                                         /* DMA          */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char :5;                  /*              */
                    unsigned char PULLUP_E:1;          /*   PULLUP_E   */
                    unsigned char EP2DMAE:1;           /*   EP2DMAE    */
                    unsigned char EP1DMAE:1;           /*   EP1DMAE    */
                    } BIT;                             /*              */
             } DMA;                                    /*              */
       union {                                         /* CVR          */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char CNFV:2;              /*   CNFV       */
                    unsigned char INTV:2;              /*   INTV       */
                    unsigned char :1;                  /*              */
                    unsigned char ALTV:3;              /*   ALTV       */
                    } BIT;                             /*              */
             } CVR;                                    /*              */
       unsigned char wk10[1];                          /*              */
       union {                                         /* CTLR         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char :3;                  /*              */
                    unsigned char RWUPS:1;             /*   RWUPS      */
                    unsigned char RSME:1;              /*   RSME       */
                    unsigned char RWMD:1;              /*   RWMD       */
                    unsigned char ASCE:1;              /*   ASCE       */
                    unsigned char :1;                  /*              */
                    } BIT;                             /*              */
             } CTLR;                                   /*              */
       unsigned char wk11[1];                          /*              */
       unsigned char EPIR;                             /* EPIR         */
       unsigned char wk12[17];                         /*              */
       union {                                         /* TRNTREG0     */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char PTSTE:1;             /*   PTSTE      */
                    unsigned char :3;                  /*              */
                    unsigned char SUSPEND:1;           /*   SUSPEND    */
                    unsigned char TXENL:1;             /*   TXENL      */
                    unsigned char TXSE0:1;             /*   TXSE0      */
                    unsigned char TXDATA:1;            /*   TXDATA     */
                    } BIT;                             /*              */
             } TRNTREG0;                               /*              */
       union {                                         /* TRNTREG1     */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char :5;                  /*              */
                    unsigned char XVERDATA:1;          /*   XVERDATA   */
                    unsigned char DPLS:1;              /*   DPLS       */
                    unsigned char DMNS:1;              /*   DMNS       */
                    } BIT;                             /*              */
             } TRNTREG1;                               /*              */
};                                                     /*              */
struct st_peci {                                       /* struct PECI  */
       union {                                         /* PECR         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char PESRES:1;            /*   PESRES     */
                    unsigned char PECIE:1;             /*   PECIE      */
                    unsigned char ABTE:1;              /*   ABTE       */
                    unsigned char :1;                  /*              */
                    unsigned char STOPE:1;             /*   STOPE      */
                    unsigned char PEWFCEIE:1;          /*   PEWFCEIE   */
                    unsigned char PERFCEIE:1;          /*   PERFCEIE   */
                    unsigned char PETEIE:1;            /*   PETEIE     */
                    } BIT;                             /*              */
             } PECR;                                   /*              */
       union {                                         /* PESTR        */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char PEBUSY:1;            /*   PEBUSY     */
                    unsigned char WFCSER:1;            /*   WFCSER     */
                    unsigned char RFCER:1;             /*   RFCER      */
                    unsigned char PETEND:1;            /*   PETEND     */
                    unsigned char NEGA:1;              /*   NEGA       */
                    unsigned char NEGM:1;              /*   NEGM       */
                    unsigned char RDRF:1;              /*   RDRF       */
                    unsigned char PECIR:1;             /*   PECIR      */
                    } BIT;                             /*              */
             } PESTR;                                  /*              */
       unsigned char  PECNT0PRE;                       /* PECNT0PRE    */
       unsigned char wk0[1];                           /*              */
       unsigned char  PECNT0GR;                        /* PECNT0GR     */
       unsigned char wk1[1];                           /*              */	   
       unsigned char  PECNT0GRA;                       /* PECNT0GRA    */
       unsigned char wk2[1];                           /*              */	   
       unsigned char  PEADD;                           /* PEADD        */
       unsigned char  PEWBNR;                          /* PEWBNR       */
       unsigned char  PERBNR;                          /* PERBNR       */
       unsigned char  PEWCRCR;                         /* PEWCRCR      */
       unsigned char  PERCRCR;                         /* PERCRCR      */
       unsigned char  PECWFCSR;                        /* PECWFCSR     */
       unsigned char  PECRFCSR;                        /* PECRFCSR     */
       unsigned char  PEFIFO;                          /* PEFIFO       */
};                                                     /*              */
struct st_scif {                                       /* struct SCIF  */
       unsigned char FRBR;                             /* FRBR FDHR FDLL */
       union {                                         /* FIER FDLH    */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char :4;                  /*              */
                    unsigned char EDSSI:1;             /*   EDSSI      */
                    unsigned char ELSI:1;              /*   ELSI       */
                    unsigned char ETBEI:1;             /*   ETBEI      */
                    unsigned char ERBFI:1;             /*   ERBFI      */
                    } BIT;                             /*              */
             } FIER;                                   /*              */
       union {                                         /* FIIR  FFCR   */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char FIFOE:2;             /*   FIFOE      */
                    unsigned char :2;                  /*              */
                    unsigned char INTID:3;             /*   INTID      */
                    unsigned char INTPEND:1;           /*   INTPEND    */
                    } FIIRBIT;                         /*              */
             struct {                                  /*  Bit Access  */
                    unsigned char RCVRTRIG:2;          /*   RCVRTRIG   */
                    unsigned char :2;                  /*              */
                    unsigned char DMAMODE:1;           /*   DMAMODE    */
					unsigned char XMITFRST:1;          /*   XMITFRST   */
					unsigned char RCVRFRST:1;          /*   RCVRFRST   */
                    unsigned char FIFOE:1;             /*   FIFOE      */
                    } FFCRBIT;                         /*              */
             } FIIRFFCR;                               /*              */
       union {                                         /* FLCR         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char DLAB:1;              /*   DLAB       */
                    unsigned char BREAK:1;             /*   BREAK      */
                    unsigned char STICKPARITY:1;       /*   STICKPARITY */
                    unsigned char EPS:1;               /*   EPS        */
                    unsigned char PEN:1;               /*   PEN        */
                    unsigned char STOP:1;              /*   STOP       */
                    unsigned char CLS:2;               /*   CLS        */
                    } BIT;                             /*              */
             } FLCR;                                   /*              */
       union {                                         /* FMCR         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char :3;                  /*              */
                    unsigned char LOOPBACK:1;          /*   LOOPBACK   */
                    unsigned char OUT2:1;              /*   OUT2       */
                    unsigned char OUT1:1;              /*   OUT1       */
                    unsigned char RTS:1;               /*   RTS        */
                    unsigned char DTR:1;               /*   DTR        */
                    } BIT;                             /*              */
             } FMCR;                                   /*              */
       union {                                         /* FLSR         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char RXFIFOERR:1;         /*   RXFIFOERR  */
                    unsigned char TEMT:1;              /*   TEMT       */
                    unsigned char THRE:1;              /*   THRE       */
                    unsigned char BI:1;                /*   BI         */
                    unsigned char FE:1;                /*   FE         */
                    unsigned char PE:1;                /*   PE         */
                    unsigned char OE:1;                /*   OE         */
                    unsigned char DR:1;                /*   DR         */
                    } BIT;                             /*              */
             } FLSR;                                   /*              */
       union {                                         /* FMSR         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char DCD:1;               /*   DCD        */
                    unsigned char RI:1;                /*   RI         */
                    unsigned char DSR:1;               /*   DSR        */
                    unsigned char CTS:1;               /*   CTS        */
                    unsigned char DDCD:1;              /*   DDCD       */
                    unsigned char TERI:1;              /*   TERI       */
                    unsigned char DDSR:1;              /*   DDSR       */
                    unsigned char DCTS:1;              /*   DCTS       */
                    } BIT;                             /*              */
             } FMSR;                                   /*              */
       unsigned char FSCR;                             /* FSCR         */
       union {                                         /* SCIFCR       */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char SCIFOE:2;            /*   SCIFOE     */
                    unsigned char :1;                  /*              */
                    unsigned char OUT2LOOP:1;          /*   OUT2LOOP   */
                    unsigned char CKSEL:2;             /*   CKSEL      */
                    unsigned char SCIFRST:1;           /*   SCIFRST    */
                    unsigned char REGRST:1;            /*   REGRST     */
                    } BIT;                             /*              */
             } SCIFCR;                                 /*              */
};                                                     /*              */
struct st_ssu {                                        /* struct SSU   */
       union {                                         /* SSCRH        */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char MSS:1;               /*   MSS        */
                    unsigned char BIDE:1;              /*   BIDE       */
                    unsigned char :1;                  /*              */
                    unsigned char SOL:1;               /*   SOL        */
                    unsigned char SOLP:1;              /*   SOLP       */
                    unsigned char SCKS:1;              /*   SCKS       */
                    unsigned char CSS:2;               /*   CSS        */
                    } BIT;                             /*              */
             } SSCRH;                                  /*              */
       union {                                         /* SSCRL        */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char :1;                  /*              */
                    unsigned char SSUMS:1;             /*   SSUMS      */
                    unsigned char SRES:1;              /*   SRES       */
                    unsigned char :3;                  /*              */
                    unsigned char DATS:2;              /*   DATS       */
                    } BIT;                             /*              */
             } SSCRL;                                  /*              */
       union {                                         /* SSMR         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char MLS:1;               /*   MLS        */
                    unsigned char CPOS:1;              /*   CPOS       */
                    unsigned char CPHS:1;              /*   CPHS       */
                    unsigned char :2;                  /*              */
                    unsigned char CKS:3;               /*   CKS        */
                    } BIT;                             /*              */
             } SSMR;                                   /*              */
       union {                                         /* SSER         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char TE:1;                /*   TE         */
                    unsigned char RE:1;                /*   RE         */
                    unsigned char :2;                  /*              */
                    unsigned char TEIE:1;              /*   TEIE       */
                    unsigned char TIE:1;               /*   TIE        */
                    unsigned char RIE:1;               /*   RIE        */
                    unsigned char CEIE:1;              /*   CEIE       */
                    } BIT;                             /*              */
             } SSER;                                   /*              */
       union {                                         /* SSSR         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char :1;                  /*              */
                    unsigned char ORER:1;              /*   ORER       */
                    unsigned char :2;                  /*              */
                    unsigned char TEND:1;              /*   TEND       */
                    unsigned char TDRE:1;              /*   TDRE       */
                    unsigned char RDRF:1;              /*   RDRF       */
                    unsigned char CE:1;                /*   CE         */
                    } BIT;                             /*              */
             } SSSR;                                   /*              */
       union {                                         /* SSCR2        */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char SDOS:1;              /*   SDOS       */
                    unsigned char SSCKOS:1;            /*   SSCKOS     */
                    unsigned char SCSOS:1;             /*   SCSOS      */
                    unsigned char TENDSTS:1;           /*   TENDSTS    */
                    unsigned char SCSATS:1;            /*   SCSATS     */
                    unsigned char SSODTS:1;            /*   SSODTS     */
                    unsigned char :2;                  /*              */
                    } BIT;                             /*              */
             } SSCR2;                                  /*              */
       unsigned char SSTDR0;                           /* SSTDR0       */
       unsigned char SSTDR1;                           /* SSTDR1       */
       unsigned char SSTDR2;                           /* SSTDR2       */
       unsigned char SSTDR3;                           /* SSTDR3       */
       unsigned char SSRDR0;                           /* SSRDR0       */
       unsigned char SSRDR1;                           /* SSRDR1       */
       unsigned char SSRDR2;                           /* SSRDR2       */
       unsigned char SSRDR3;                           /* SSRDR3       */
       unsigned char SSTRSR;                           /* SSTRSR       */
};                                                     /*              */
struct st_lpc {                                        /* struct LPC   */
       union {                                         /* HICR4        */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char LADR12SEL:1;         /*   LADR12SEL  */
                    unsigned char :3;                  /*              */
                    unsigned char SWENBL:1;            /*   SWENBL     */
                    unsigned char KCSENBL:1;           /*   KCSENBL    */
                    unsigned char SMCENBL:1;           /*   SMCENBL    */
                    unsigned char BTENBL:1;            /*   BTENBL     */
                    } BIT;                             /*              */
             } HICR4;                                  /*              */
       unsigned char wk0[1];                           /*              */
       union {                                         /* BTSR0        */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char :3;                  /*              */
                    unsigned char FRDI:1;              /*   FRDI       */
                    unsigned char HRDI:1;              /*   HRDI       */
                    unsigned char HWRI:1;              /*   HWRI       */
                    unsigned char HBTWI:1;             /*   HBTWI      */
                    unsigned char HBTRI:1;             /*   HBTRI      */
                    } BIT;                             /*              */
             } BTSR0;                                  /*              */
       union {                                         /* BTSR1        */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char :1;                  /*              */
                    unsigned char HRSTI:1;             /*   HRSTI      */
                    unsigned char IRQCRI:1;            /*   IRQCRI     */
                    unsigned char BEVTI:1;             /*   BEVTI      */
                    unsigned char B2HI:1;              /*   B2HI       */
                    unsigned char H2BI:1;              /*   H2BI       */
                    unsigned char CRRPI:1;             /*   CRRPI      */
                    unsigned char CRWPI:1;             /*   CRWPI      */
                    } BIT;                             /*              */
             } BTSR1;                                  /*              */
       union {                                         /* BTCSR0       */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char :1;                  /*              */
                    unsigned char FSEL:2;              /*   FSEL       */
                    unsigned char FRDIE:1;             /*   FRDIE      */
                    unsigned char HRDIE:1;             /*   HRDIE      */
                    unsigned char HWRIE:1;             /*   HWRIE      */
                    unsigned char HBTWIE:1;            /*   HBTWIE     */
                    unsigned char HBTRIE:1;            /*   HBTRIE     */
                    } BIT;                             /*              */
             } BTCSR0;                                 /*              */
       union {                                         /* BTCSR1       */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char RSTRENBL:1;          /*   RSTRENBL   */
                    unsigned char HRSTIE:1;            /*   HRSTIE     */
                    unsigned char IRQCRIE:1;           /*   IRQCRIE    */
                    unsigned char BEVTIE:1;            /*   BEVTIE     */
                    unsigned char B2HIE:1;             /*   B2HIE      */
                    unsigned char H2BIE:1;             /*   H2BIE      */
                    unsigned char CRRPIE:1;            /*   CRRPIE     */
                    unsigned char CRWPIE:1;            /*   CRWPIE     */
                    } BIT;                             /*              */
             } BTCSR1;                                 /*              */
       union {                                         /* BTCR         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char BBUSY:1;             /*   BBUSY      */
                    unsigned char HBUSY:1;             /*   HBUSY      */
                    unsigned char OEM0:1;              /*   OEM0       */
                    unsigned char BEVTATN:1;           /*   BEVTATN    */
                    unsigned char B2HATN:1;            /*   B2HATN     */
                    unsigned char H2BATN:1;            /*   H2BATN     */
                    unsigned char CLRRDPTR:1;          /*   CLRRDPTR   */
                    unsigned char CLRWRPTR:1;          /*   CLRWRPTR   */
                    } BIT;                             /*              */
             } BTCR;                                   /*              */
       union {                                         /* BTIMSR       */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char BMCHWRST:1;          /*   BMCHWRST   */
                    unsigned char :2;                  /*              */
                    unsigned char OEM3:1;              /*   OEM3       */
                    unsigned char OEM2:1;              /*   OEM2       */
                    unsigned char OEM1:1;              /*   OEM1       */
                    unsigned char B2HIRQ:1;            /*   B2HIRQ     */
                    unsigned char B2HIRQEN:1;          /*   B2HIRQEN   */
                    } BIT;                             /*              */
             } BTIMSR;                                 /*              */
       union {                                         /* SMICFLG      */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char RXDATARDY:1;         /*   RXDATARDY  */
                    unsigned char TXDATARDY:1;         /*   TXDATARDY  */
                    unsigned char :1;                  /*              */
                    unsigned char SMI:1;               /*   SMI        */
                    unsigned char SEVTATN:1;           /*   SEVTATN    */
                    unsigned char SMSATN:1;            /*   SMSATN     */
                    unsigned char :1;                  /*              */
                    unsigned char BUSY:1;              /*   BUSY       */
                    } BIT;                             /*              */
             } SMICFLG;                                /*              */
       union {                                         /* HICR5        */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char :6;                  /*              */
                    unsigned char SCIFE:1;             /*   SCIFE      */
                    unsigned char :1;                  /*              */
                    } BIT;                             /*              */
             } HICR5;                                  /*              */
       unsigned char  SMICCSR;                         /* SMICCSR      */
       unsigned char  SMICDTR;                         /* SMICDTR      */
       union {                                         /* SMICIR0      */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char :3;                  /*              */
                    unsigned char HDTWI:1;             /*   HDTWI      */
                    unsigned char HDTRI:1;             /*   HDTRI      */
                    unsigned char STARI:1;             /*   STARI      */
                    unsigned char CTLWI:1;             /*   CTLWI      */
                    unsigned char BUSYI:1;             /*   BUSYI      */
                    } BIT;                             /*              */
             } SMICIR0;                                /*              */
       unsigned char wk1[1];                           /*              */
       union {                                         /* SMICIR1      */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char :3;                  /*              */
                    unsigned char HDTWIE:1;            /*   HDTWIE     */
                    unsigned char HDTRIE:1;            /*   HDTRIE     */
                    unsigned char STARIE:1;            /*   STARIE     */
                    unsigned char CTLWIE:1;            /*   CTLWIE     */
                    unsigned char BUSYIE:1;            /*   BUSYIE     */
                    } BIT;                             /*              */
             } SMICIR1;                                /*              */
       union {                                         /* SIRQCR3      */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char :4;                  /*              */
                    unsigned char SCSIRQ:4;            /*   SCSIRQ     */
                    } BIT;                             /*              */
             } SIRQCR3;                                /*              */
       unsigned char TWR0MW;                           /* TWR0MW TWR0SW*/
       unsigned char TWR1;                             /* TWR1         */
       unsigned char TWR2;                             /* TWR2         */
       unsigned char TWR3;                             /* TWR3         */
       unsigned char TWR4;                             /* TWR4         */
       unsigned char TWR5;                             /* TWR5         */
       unsigned char TWR6;                             /* TWR6         */
       unsigned char TWR7;                             /* TWR7         */
       unsigned char TWR8;                             /* TWR8         */
       unsigned char TWR9;                             /* TWR9         */
       unsigned char TWR10;                            /* TWR10        */
       unsigned char TWR11;                            /* TWR11        */
       unsigned char TWR12;                            /* TWR12        */
       unsigned char TWR13;                            /* TWR13        */
       unsigned char TWR14;                            /* TWR14        */
       unsigned char TWR15;                            /* TWR15        */
       unsigned char IDR3;                             /* IDR3         */
       unsigned char ODR3;                             /* ODR3         */ 
       union {                                         /* STR3         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char IBF3B:1;             /*   IBF3B      */
                    unsigned char OBF3B:1;             /*   OBF3B      */
                    unsigned char MWMF:1;              /*   MWMF       */
                    unsigned char SWMF:1;              /*   SWMF       */
                    unsigned char CD3:1;               /*   CD3        */
                    unsigned char DBU32:1;             /*   DBU32      */
                    unsigned char IBF3A:1;             /*   IBF3A      */
                    unsigned char OBF3A:1;             /*   OBF3A      */
                    } BIT;                             /*              */
             } STR3;                                   /*              */
       union {                                         /* SIRQCR4      */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char IRQ15E:1;            /*   IRQ15E     */
                    unsigned char IRQ14E:1;            /*   IRQ14E     */
                    unsigned char IRQ13E:1;            /*   IRQ13E     */
                    unsigned char IRQ8E:1;             /*   IRQ8E      */
                    unsigned char IRQ7E:1;             /*   IRQ7E      */
                    unsigned char IRQ5E:1;             /*   IRQ5E      */
                    unsigned char IRQ4E:1;             /*   IRQ4E      */
                    unsigned char IRQ3E:1;             /*   IRQ3E      */
                    } BIT;                             /*              */
             } SIRQCR4;                                /*              */
       union {                                         /* LADR3H       */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char BIT15:1;             /*   BIT15      */
                    unsigned char BIT14:1;             /*   BIT14      */
                    unsigned char BIT13:1;             /*   BIT13      */
                    unsigned char BIT12:1;             /*   BIT12      */
                    unsigned char BIT11:1;             /*   BIT11      */
                    unsigned char BIT10:1;             /*   BIT10      */
                    unsigned char BIT9:1;              /*   BIT9       */
                    unsigned char BIT8:1;              /*   BIT8       */
                    } BIT;                             /*              */
             } LADR3H;                                 /*              */
       union {                                         /* LADR3L       */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char BIT7:1;              /*   BIT7       */
                    unsigned char BIT6:1;              /*   BIT6       */
                    unsigned char BIT5:1;              /*   BIT5       */
                    unsigned char BIT4:1;              /*   BIT4       */
                    unsigned char BIT3:1;              /*   BIT3       */
                    unsigned char :1;                  /*              */
                    unsigned char BIT1:1;              /*   BIT1       */
                    unsigned char TWRE:1;              /*   TWRE       */
                    } BIT;                             /*              */
             } LADR3L;                                 /*              */
       union {                                         /* SIRQCR0      */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char QC:1;                /*   QC         */
                    unsigned char SELREQ:1;            /*   SELREQ     */
                    unsigned char IEDIR:1;             /*   IEDIR      */
                    unsigned char SMIE3B:1;            /*   SMIE3B     */
                    unsigned char SMIE3A:1;            /*   SMIE3A     */
                    unsigned char SMIE2:1;             /*   SMIE2      */
                    unsigned char IRQ12E1:1;           /*   IRQ12E1    */
                    unsigned char IRQ1E1:1;            /*   IRQ1E1     */
                    } BIT;                             /*              */
             } SIRQCR0;                                /*              */
       union {                                         /* SIRQCR1      */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char IRQ11E3:1;           /*   IRQ11E3    */
                    unsigned char IRQ10E3:1;           /*   IRQ10E3    */
                    unsigned char IRQ9E3:1;            /*   IRQ9E3     */
                    unsigned char IRQ6E3:1;            /*   IRQ6E3     */
                    unsigned char IRQ11E2:1;           /*   IRQ11E2    */
                    unsigned char IRQ10E2:1;           /*   IRQ10E2    */
                    unsigned char IRQ9E2:1;            /*   IRQ9E2     */
                    unsigned char IRQ6E2:1;            /*   IRQ6E2     */
                    } BIT;                             /*              */
             } SIRQCR1;                                /*              */
       unsigned char IDR1;                             /* IDR1         */
       unsigned char ODR1;                             /* ODR1         */
       union {                                         /* STR1         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char DBU17:1;             /*   DBU17      */
                    unsigned char DBU16:1;             /*   DBU16      */
                    unsigned char DBU15:1;             /*   DBU15      */
                    unsigned char DBU14:1;             /*   DBU14      */
                    unsigned char CD1:1;               /*   CD1        */
                    unsigned char DBU12:1;             /*   DBU12      */
                    unsigned char IBF1:1;              /*   IBF1       */
                    unsigned char OBF1:1;              /*   OBF1       */
                    } BIT;                             /*              */
             } STR1;                                   /*              */
       union {                                         /* SIRQCR5      */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char SELIRQ15:1;          /*   SELIRQ15   */
                    unsigned char SELIRQ14:1;          /*   SELIRQ14   */
                    unsigned char SELIRQ13:1;          /*   SELIRQ13   */
                    unsigned char SELIRQ8:1;           /*   SELIRQ8    */
                    unsigned char SELIRQ7:1;           /*   SELIRQ7    */
                    unsigned char SELIRQ5:1;           /*   SELIRQ5    */
                    unsigned char SELIRQ4:1;           /*   SELIRQ4    */
                    unsigned char SELIRQ3:1;           /*   SELIRQ3    */
                    } BIT;                             /*              */
             } SIRQCR5;                                /*              */
       unsigned char IDR2;                             /* IDR2         */
       unsigned char ODR2;                             /* ODR2         */
       union {                                         /* STR2         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char DBU27:1;             /*   DBU27      */
                    unsigned char DBU26:1;             /*   DBU26      */
                    unsigned char DBU25:1;             /*   DBU25      */
                    unsigned char DBU24:1;             /*   DBU24      */
                    unsigned char CD2:1;               /*   CD2        */
                    unsigned char DBU22:1;             /*   DBU22      */
                    unsigned char IBF2:1;              /*   IBF2       */
                    unsigned char OBF2:1;              /*   OBF2       */
                    } BIT;                             /*              */
             } STR2;                                   /*              */
       union {                                         /* HISEL        */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char SELSTR3:1;           /*   SELSTR3    */
                    unsigned char SELIRQ11:1;          /*   SELIRQ11   */
                    unsigned char SELIRQ10:1;          /*   SELIRQ10   */
                    unsigned char SELIRQ9:1;           /*   SELIRQ9    */
                    unsigned char SELIRQ6:1;           /*   SELIRQ6    */
                    unsigned char SELSMI:1;            /*   SELSMI     */
                    unsigned char SELIRQ12:1;          /*   SELIRQ12   */
                    unsigned char SELIRQ1:1;           /*   SELIRQ1    */
                    } BIT;                             /*              */
             } HISEL;                                  /*              */
       union {                                         /* HICR0        */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char LPC3E:1;             /*   LPC3E      */
                    unsigned char LPC2E:1;             /*   LPC2E      */
                    unsigned char LPC1E:1;             /*   LPC1E      */
                    unsigned char FGA20E:1;            /*   FGA20E     */
                    unsigned char SDWNE:1;             /*   SDWNE      */
                    unsigned char PMEE:1;              /*   PMEE       */
                    unsigned char LSMIE:1;             /*   LSMIE      */
                    unsigned char LSCIE:1;             /*   LSCIE      */
                    } BIT;                             /*              */
             } HICR0;                                  /*              */
       union {                                         /* HICR1        */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char LPCBSY:1;            /*   LPCBSY     */
                    unsigned char CLKREQ:1;            /*   CLKREQ     */
                    unsigned char IRQBSY:1;            /*   IRQBSY     */
                    unsigned char LRSTB:1;             /*   LRSTB      */
                    unsigned char SDWNB:1;             /*   SDWNB      */
                    unsigned char PMEB:1;              /*   PMEB       */
                    unsigned char LSMIB:1;             /*   LSMIB      */
                    unsigned char LSCIB:1;             /*   LSCIB      */
                    } BIT;                             /*              */
             } HICR1;                                  /*              */
       union {                                         /* HICR2        */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char GA20:1;              /*   GA20       */
                    unsigned char LRST:1;              /*   LRST       */
                    unsigned char SDWN:1;              /*   SDWN       */
                    unsigned char ABRT:1;              /*   ABRT       */
                    unsigned char IBFIE3:1;            /*   IBFIE3     */
                    unsigned char IBFIE2:1;            /*   IBFIE2     */
                    unsigned char IBFIE1:1;            /*   IBFIE1     */
                    unsigned char ERRIE:1;             /*   ERRIE      */
                    } BIT;                             /*              */
             } HICR2;                                  /*              */
       union {                                         /* HICR3        */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char LFRAME:1;            /*   LFRAME     */
                    unsigned char CLKRUN:1;            /*   CLKRUN     */
                    unsigned char SERIRQ:1;            /*   SERIRQ     */
                    unsigned char LRESET:1;            /*   LRESET     */
                    unsigned char LPCPD:1;             /*   LPCPD      */
                    unsigned char PME:1;               /*   PME        */
                    unsigned char LSMI:1;              /*   LSMI       */
                    unsigned char LSCI:1;              /*   LSCI       */
                    } BIT;                             /*              */
             } HICR3;                                  /*              */
       union {                                         /* SIRQCR2      */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char IEDIR3:1;            /*   IEDIR3     */
                    unsigned char :7;                  /*              */
                    } BIT;                             /*              */
             } SIRQCR2;                                /*              */
       unsigned char BTDTR;                            /* BTDTR        */
       unsigned char BTFVSR0;                          /* BTFVSR0      */
       unsigned char BTFVSR1;                          /* BTFVSR1      */
       union {                                         /* LADR12H      */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char BIT15:1;             /*   BIT15      */
                    unsigned char BIT14:1;             /*   BIT14      */
                    unsigned char BIT13:1;             /*   BIT13      */
                    unsigned char BIT12:1;             /*   BIT12      */
                    unsigned char BIT11:1;             /*   BIT11      */
                    unsigned char BIT10:1;             /*   BIT10      */
                    unsigned char BIT9:1;              /*   BIT9       */
                    unsigned char BIT8:1;              /*   BIT8       */
                    } BIT;                             /*              */
             } LADR12H;                                /*              */
       union {                                         /* LADR12L      */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char BIT7:1;              /*   BIT7       */
                    unsigned char BIT6:1;              /*   BIT6       */
                    unsigned char BIT5:1;              /*   BIT5       */
                    unsigned char BIT4:1;              /*   BIT4       */
                    unsigned char BIT3:1;              /*   BIT3       */
                    unsigned char :1;                  /*              */
                    unsigned char BIT:2;               /*   BIT        */
                    } BIT;                             /*              */
             } LADR12L;                                /*              */
       union {                                         /* SCIFADRH     */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char BIT15:1;             /*   BIT15      */
                    unsigned char BIT14:1;             /*   BIT14      */
                    unsigned char BIT13:1;             /*   BIT13      */
                    unsigned char BIT12:1;             /*   BIT12      */
                    unsigned char BIT11:1;             /*   BIT11      */
                    unsigned char BIT10:1;             /*   BIT10      */
                    unsigned char BIT9:1;              /*   BIT9       */
                    unsigned char BIT8:1;              /*   BIT8       */
                    } BIT;                             /*              */
             } SCIFADRH;                               /*              */
       union {                                         /* SCIFADRL     */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char BIT7:1;              /*   BIT7       */
                    unsigned char BIT6:1;              /*   BIT6       */
                    unsigned char BIT5:1;              /*   BIT5       */
                    unsigned char BIT4:1;              /*   BIT4       */
                    unsigned char BIT3:1;              /*   BIT3       */
                    unsigned char :3;                  /*              */
                    } BIT;                             /*              */
             } SCIFADRL;                               /*              */
};                                                     /*              */
struct st_system {                                     /* struct SYSTEM */
       union {                                         /* SUBMSTPAH    */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char SMSTPA15:1;          /*   SMSTPA15   */
                    unsigned char EtherC:1;            /*   EtherC     */
                    unsigned char EDMAC:1;             /*   EDMAC      */
                    unsigned char USB:1;               /*   USB        */
                    unsigned char SMSTPA11:1;          /*   SMSTPA11   */
                    unsigned char SMSTPA10:1;          /*   SMSTPA10   */
                    unsigned char SMSTPA9:1;           /*   SMSTPA9    */
                    unsigned char SMSTPA8:1;           /*   SMSTPA8    */
                    } BIT;                             /*              */
             } SUBMSTPAH;                              /*              */
       union {                                         /* SUBMSTPAL    */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char SMSTPA7:1;           /*   SMSTPA7    */
                    unsigned char SMSTPA6:1;           /*   SMSTPA6    */
                    unsigned char SMSTPA5:1;           /*   SMSTPA5    */
                    unsigned char PECI:1;              /*   PECI       */
                    unsigned char SCIF:1;              /*   SCIF       */
                    unsigned char SSU:1;               /*   SSU        */
                    unsigned char LPC:1;               /*   LPC        */
                    unsigned char SMSTPA0:1;           /*   SMSTPA0    */
                    } BIT;                             /*              */
             } SUBMSTPAL;                              /*              */
       union {                                         /* SUBMSTPBH    */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char SMSTPB15:1;          /*   SMSTPB15   */
                    unsigned char EtherC:1;            /*   EtherC     */
                    unsigned char EDMAC:1;             /*   EDMAC      */
                    unsigned char USB:1;               /*   USB        */
                    unsigned char SMSTPB11:1;          /*   SMSTPB11   */
                    unsigned char SMSTPB10:1;          /*   SMSTPB10   */
                    unsigned char SMSTPB9:1;           /*   SMSTPB9    */
                    unsigned char SMSTPB8:1;           /*   SMSTPB8    */
                    } BIT;                             /*              */
             } SUBMSTPBH;                              /*              */
       union {                                         /* SUBMSTPBL    */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char SMSTPB7:1;           /*   SMSTPB7    */
                    unsigned char SMSTPB6:1;           /*   SMSTPB6    */
                    unsigned char SMSTPB5:1;           /*   SMSTPB5    */
                    unsigned char PECI:1;              /*   PECI       */
                    unsigned char SCIF:1;              /*   SCIF       */
                    unsigned char SSU:1;               /*   SSU        */
                    unsigned char LPC:1;               /*   LPC        */
                    unsigned char SMSTPB0:1;           /*   SMSTPB0    */
                    } BIT;                             /*              */
             } SUBMSTPBL;                              /*              */
       unsigned char wk0[3];                           /*              */
       unsigned char MSTPCRA;                          /* MSTPCRA      */
       unsigned char wk1[318];                         /*              */
       union {                                         /* PCSR         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char PWCKX1B:1;           /*   PWCKX1B    */
                    unsigned char PWCKX1A:1;           /*   PWCKX1A    */
                    unsigned char PWCKX0B:1;           /*   PWCKX0B    */
                    unsigned char PWCKX0A:1;           /*   PWCKX0A    */
                    unsigned char PWCKX1C:1;           /*   PWCKX1C    */
                    unsigned char PWCKB:1;             /*   PWCKB      */
                    unsigned char PWCKA:1;             /*   PWCKA      */
                    unsigned char PWCKX0C:1;           /*   PWCKX0C    */
                    } BIT;                             /*              */
             } PCSR;                                   /*              */
       union {                                         /* SYSCR2       */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char :4;                  /*              */
                    unsigned char ADMXE:1;             /*   ADMXE      */
                    unsigned char :3;                  /*              */
                    } BIT;                             /*              */
             } SYSCR2;                                 /*              */
       union {                                         /* SBYCR        */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char SSBY:1;              /*   SSBY       */
                    unsigned char STS2:1;              /*   STS2       */
                    unsigned char STS0:2;              /*   STS0       */
                    unsigned char DTSPEED:1;           /*   DTSPEED    */
                    unsigned char SCK:3;               /*   SCK        */
                    } BIT;                             /*              */
             } SBYCR;                                  /*              */
       union {                                         /* LPWRCR       */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char DTON:1;              /*   DTON       */
                    unsigned char LSON:1;              /*   LSON       */
                    unsigned char NESEL:1;             /*   NESEL      */
                    unsigned char EXCLE:1;             /*   EXCLE      */
                    unsigned char :1;                  /*              */
                    unsigned char PNCCS:1;             /*   PNCCS      */
                    unsigned char PNCAH:1;             /*   PNCAH      */
                    unsigned char :1;                  /*              */
                    } BIT;                             /*              */
             } LPWRCR;                                 /*              */
       union {                                         /* MSTPCRH      */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char MSTP15:1;            /*   MSTP15     */
                    unsigned char MSTP14:1;            /*   MSTP14     */
                    unsigned char MSTP13:1;            /*   MSTP13     */
                    unsigned char MSTP12:1;            /*   MSTP12     */
                    unsigned char MSTP11:1;            /*   MSTP11     */
                    unsigned char MSTP10:1;            /*   MSTP10     */
                    unsigned char MSTP9:1;             /*   MSTP9      */
                    unsigned char MSTP8:1;             /*   MSTP8      */
                    } BIT;                             /*              */
             } MSTPCRH;                                /*              */
       unsigned char MSTPCRL;                          /* MSTPCRL      */
       unsigned char wk2[59];                          /*              */
       union {                                         /* STCR         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char IICX:3;              /*   IICX       */
                    unsigned char IICE:1;              /*   IICE       */
                    unsigned char FLSHE:1;             /*   FLSHE      */
                    unsigned char :1;                  /*              */
                    unsigned char ICKS:2;              /*   ICKS       */
                    } BIT;                             /*              */
             } STCR;                                   /*              */
       union {                                         /* SYSCR        */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char CS256E:1;            /*   CS256E     */
                    unsigned char IOSE:1;              /*   IOSE       */
                    unsigned char INTM:2;              /*   INTM       */
                    unsigned char XRST:1;              /*   XRST       */
                    unsigned char NMIEG:1;             /*   NMIEG      */
                    unsigned char :1;                  /*              */
                    unsigned char RAME:1;              /*   RAME       */
                    } BIT;                             /*              */
             } SYSCR;                                  /*              */
       union {                                         /* MDCR         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char EXPE:1;              /*   EXPE       */
                    unsigned char :4;                  /*              */
                    unsigned char MDS:3;               /*   MDS        */
                    } BIT;                             /*              */
             } MDCR;                                   /*              */
};                                                     /*              */
struct st_evc {                                        /* struct EVC   */
       unsigned char ECS;                              /* ECS          */
       unsigned char wk0[1];                           /*              */
       union {                                         /* ECCR         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char EDSB:1;              /*   EDSB       */
                    unsigned char :3;                  /*              */
                    unsigned char ECSB:4;              /*   ECSB       */
                    } BIT;                             /*              */
             } ECCR;                                   /*              */
       unsigned char wk1[161];                         /*              */
       union {                                         /* KBCOMP       */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char EVENTE:1;            /*   EVENTE     */
                    unsigned char :7;                  /*              */
                    } BIT;                             /*              */
             } KBCOMP;                                 /*              */
};                                                     /*              */
struct st_flash {                                      /* struct FLASH */
       union {                                         /* FCCS         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char FWE:1;               /*   FWE        */
                    unsigned char :2;                  /*              */
                    unsigned char FLER:1;              /*   FLER       */
                    unsigned char WEINTE:1;            /*   WEINTE     */
                    unsigned char :2;                  /*              */
                    unsigned char SCO:1;               /*   SCO        */
                    } BIT;                             /*              */
             } FCCS;                                   /*              */
       union {                                         /* FPCS         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char :7;                  /*              */
                    unsigned char PPVS:1;              /*   PPVS       */
                    } BIT;                             /*              */
             } FPCS;                                   /*              */
       union {                                         /* FECS         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char :7;                  /*              */
                    unsigned char EPVB:1;              /*   EPVB       */
                    } BIT;                             /*              */
             } FECS;                                   /*              */
       unsigned char wk0[1];                           /*              */
       unsigned char FKEY;                             /* FKEY         */
       unsigned char FMATS;                            /* FMATS        */
       union {                                         /* FTDAR        */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char TDER:1;              /*   TDER       */
                    unsigned char TDA:7;               /*   TDA        */
                    } BIT;                             /*              */
             } FTDAR;                                  /*              */
};                                                     /*              */
struct st_sci1 {                                       /* struct SCI1  */
       union {                                         /* SMR          */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char CA:1;                /*   CA         */
                    unsigned char CHR:1;               /*   CHR        */
                    unsigned char PE:1;                /*   PE         */
                    unsigned char OE:1;                /*   OE         */
                    unsigned char STOP:1;              /*   STOP       */
                    unsigned char MP:1;                /*   MP         */
                    unsigned char CKS:2;               /*   CKS        */
                    } BIT;                             /*              */
             } SMR;                                    /*              */
       unsigned char BRR;                              /* BRR          */
       union {                                         /* SCR          */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char TIE:1;               /*   TIE        */
                    unsigned char RIE:1;               /*   RIE        */
                    unsigned char TE:1;                /*   TE         */
                    unsigned char RE:1;                /*   RE         */
                    unsigned char MPIE:1;              /*   MPIE       */
                    unsigned char TEIE:1;              /*   TEIE       */
                    unsigned char CKE:2;               /*   CKE        */
                    } BIT;                             /*              */
             } SCR;                                    /*              */
       unsigned char TDR;                              /* TDR          */
       union {                                         /* SSR          */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char TDRE:1;              /*   TDRE       */
                    unsigned char RDRF:1;              /*   RDRF       */
                    unsigned char ORER:1;              /*   ORER       */
                    unsigned char FER:1;               /*   FER        */
                    unsigned char PER:1;               /*   PER        */
                    unsigned char TEND:1;              /*   TEND       */
                    unsigned char MPB:1;               /*   MPB        */
                    unsigned char MPBT:1;              /*   MPBT       */
                    } BIT;                             /*              */
             } SSR;                                    /*              */
       unsigned char RDR;                              /* RDR          */
       union {                                         /* SCMR         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char :4;                  /*              */
                    unsigned char SDIR:1;              /*   SDIR       */
                    unsigned char SINV:1;              /*   SINV       */
                    unsigned char :1;                  /*              */
                    unsigned char SMIF:1;              /*   SMIF       */
                    } BIT;                             /*              */
             } SCMR;                                   /*              */
};                                                     /*              */
struct st_sci3 {                                       /* struct SCI3  */
       union {                                         /* SMR          */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char CA:1;                /*   CA         */
                    unsigned char CHR:1;               /*   CHR        */
                    unsigned char PE:1;                /*   PE         */
                    unsigned char OE:1;                /*   OE         */
                    unsigned char STOP:1;              /*   STOP       */
                    unsigned char MP:1;                /*   MP         */
                    unsigned char CKS:2;               /*   CKS        */
                    } BIT;                             /*              */
             } SMR;                                    /*              */
       unsigned char BRR;                              /* BRR          */
       union {                                         /* SCR          */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char TIE1:1;              /*   TIE1       */
                    unsigned char RIE:1;               /*   RIE        */
                    unsigned char TE:1;                /*   TE         */
                    unsigned char RE:1;                /*   RE         */
                    unsigned char MPIE:1;              /*   MPIE       */
                    unsigned char TIE0:1;              /*   TIE0       */
                    unsigned char CKE:2;               /*   CKE        */
                    } BIT;                             /*              */
             } SCR;                                    /*              */
       unsigned char TDR;                              /* TDR          */
       union {                                         /* SSR          */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char TDRE:1;              /*   TDRE       */
                    unsigned char RDRF:1;              /*   RDRF       */
                    unsigned char ORER:1;              /*   ORER       */
                    unsigned char FER:1;               /*   FER        */
                    unsigned char PER:1;               /*   PER        */
                    unsigned char TEND:1;              /*   TEND       */
                    unsigned char MPB:1;               /*   MPB        */
                    unsigned char MPBT:1;              /*   MPBT       */
                    } BIT;                             /*              */
             } SSR;                                    /*              */
       unsigned char RDR;                              /* RDR          */
       union {                                         /* SCMR         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char :4;                  /*              */
                    unsigned char SDIR:1;              /*   SDIR       */
                    unsigned char SINV:1;              /*   SINV       */
                    unsigned char :1;                  /*              */
                    unsigned char SMIF:1;              /*   SMIF       */
                    } BIT;                             /*              */
             } SCMR;                                   /*              */
};                                                     /*              */
struct st_adc {                                        /* struct ADC   */
       unsigned short ADDRA;                           /* ADDRA        */
       unsigned short ADDRB;                           /* ADDRB        */ 
       unsigned short ADDRC;                           /* ADDRC        */ 
       unsigned short ADDRD;                           /* ADDRD        */  
       unsigned short ADDRE;                           /* ADDRE        */   
       unsigned short ADDRF;                           /* ADDRF        */
       unsigned short ADDRG;                           /* ADDRG        */ 
       unsigned short ADDRH;                           /* ADDRH        */  
       union {                                         /* ADCSR        */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char ADF:1;               /*   ADF        */
                    unsigned char ADIE:1;              /*   ADIE       */
                    unsigned char ADST:1;              /*   ADST       */
                    unsigned char :1;                  /*              */
                    unsigned char CH:4;                /*   CH         */
                    } BIT;                             /*              */
             } ADCSR;                                  /*              */
       union {                                         /* ADCR         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char TRGS:2;              /*   TRGS       */
                    unsigned char SCANE:1;             /*   SCANE      */
                    unsigned char SCANS:1;             /*   SCANS      */
                    unsigned char CKS:2;               /*   CKS        */
                    unsigned char ADSTCLR:1;           /*   ADSTCLR    */
                    unsigned char :1;                  /*              */
                    } BIT;                             /*              */
             } ADCR;                                   /*              */
};                                                     /*              */
struct st_smx {                                        /* struct SMX   */
       union {                                         /* SMR0         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char DCD1:1;              /*   DCD1       */
                    unsigned char RI1:1;               /*   RI1        */
                    unsigned char DSR1:1;              /*   DSR1       */
                    unsigned char SME:1;               /*   SME        */
                    unsigned char :1;                  /*              */
                    unsigned char SM:3;                /*   SM         */
                    } BIT;                             /*              */
             } SMR0;                                   /*              */
       union {                                         /* SMR1         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char CTS1:1;              /*   CTS1       */
                    unsigned char DTR1:1;              /*   DTR1       */
                    unsigned char RTS1:1;              /*   RTS1       */
                    unsigned char CTS3:1;              /*   CTS3       */
                    unsigned char :1;                  /*              */
                    unsigned char RTS3:1;              /*   RTS3       */
                    unsigned char :2;                  /*              */
                    } BIT;                             /*              */
             } SMR1;                                   /*              */
};                                                     /*              */
struct st_pwmx0 {                                      /* struct PWMX0 */
       union {                                         /* DADRA DACR   */
             unsigned short WORD;                      /*  Word Access */
             struct {                                  /*  Byte Access */
                    unsigned char H;                   /*   High       */
                    unsigned char L;                   /*   Low        */
                    } BYTE;                            /*              */
             struct {                                  /*  Bit Access  */
                    unsigned short DA:14;              /*   DA         */
                    unsigned short CFS:1;              /*   CFS        */
                    unsigned short :1;                 /*              */
                    } BIT;                             /*              */
             } DADRA;                                  /*              */
       unsigned char wk0[4];                           /*              */
       union {                                         /* DADRB DACNT  */
             unsigned short WORD;                      /*  Word Access */
             struct {                                  /*  Byte Access */
                    unsigned char H;                   /*   High       */
                    unsigned char L;                   /*   Low        */
                    } BYTE;                            /*              */
             struct {                                  /*  Bit Access  */
                    unsigned short DA:14;              /*   DA         */
                    unsigned short CFS:1;              /*   CFS        */
                    unsigned short REGS:1;             /*   REGS       */
                    } BIT;                             /*              */
             } DADRB;                                  /*              */
};                                                     /*              */
struct st_pwmx1 {                                      /* struct PWMX1 */
       union {                                         /* DADRA DACR   */
             unsigned short WORD;                      /*  Word Access */
             struct {                                  /*  Byte Access */
                    unsigned char H;                   /*   High       */
                    unsigned char L;                   /*   Low        */
                    } BYTE;                            /*              */
             struct {                                  /*  Bit Access  */
                    unsigned short DA:14;              /*   DA         */
                    unsigned short CFS:1;              /*   CFS        */
                    unsigned short :1;                 /*              */
                    } BIT;                             /*              */
             } DADRA;                                  /*              */
       union {                                         /* DADRB DACNT  */
             unsigned short WORD;                      /*  Word Access */
             struct {                                  /*  Byte Access */
                    unsigned char H;                   /*   High       */
                    unsigned char L;                   /*   Low        */
                    } BYTE;                            /*              */
             struct {                                  /*  Bit Access  */
                    unsigned short DA:14;              /*   DA         */
                    unsigned short CFS:1;              /*   CFS        */
                    unsigned short REGS:1;             /*   REGS       */
                    } BIT;                             /*              */
             } DADRB;                                  /*              */
};                                                     /*              */
struct st_crc {                                        /* struct CRC   */
       union {                                         /* CRCCR        */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char DORCLR:1;            /*   DORCLR     */
                    unsigned char :4;                  /*              */
                    unsigned char LMS:1;               /*   LMS        */
                    unsigned char G:2;                 /*   G          */
                    } BIT;                             /*              */
             } CRCCR;                                  /*              */
       unsigned char CRCDIR;                           /* CRCDIR       */
       unsigned short CRCDOR;                          /* CRCDOR       */
};                                                     /*              */
struct st_int {                                        /* struct INT   */
       union {                                         /* ICRD         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char ICRD7:1;             /*   ICRD7      */
                    unsigned char ICRD6:1;             /*   ICRD6      */
                    unsigned char ICRD5:1;             /*   ICRD6      */
                    unsigned char :5;                  /*              */
                    } BIT;                             /*              */
             } ICRD;                                   /*              */
       unsigned char ICRA;                             /* ICRA         */
       union {                                         /* ICRB         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char ICRB7:1;             /*   ICRB7      */
                    unsigned char ICRB6:1;             /*   ICRB6      */
                    unsigned char :1;                  /*              */
                    unsigned char ICRB:5;              /*   ICRB       */
                    } BIT;                             /*              */
             } ICRB;                                   /*              */
       union {                                         /* ICRC         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char ICRC7:1;             /*   ICRC7      */
                    unsigned char ICRC6:1;             /*   ICRC6      */
                    unsigned char ICRC5:1;             /*   ICRC5      */
                    unsigned char ICRC4:1;             /*   ICRC4      */
                    unsigned char ICRC3:1;             /*   ICRC3      */
                    unsigned char ICRC2:1;             /*   ICRC2      */
                    unsigned char ICRC1:1;             /*   ICRC1      */
                    unsigned char :1;                  /*              */
                    } BIT;                             /*              */
             } ICRC;                                   /*              */
       union {                                         /* ISR          */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char IRQ7F:1;             /*   IRQ7F      */
                    unsigned char IRQ6F:1;             /*   IRQ6F      */
                    unsigned char IRQ5F:1;             /*   IRQ5F      */
                    unsigned char IRQ4F:1;             /*   IRQ4F      */
                    unsigned char IRQ3F:1;             /*   IRQ3F      */
                    unsigned char IRQ2F:1;             /*   IRQ2F      */
                    unsigned char IRQ1F:1;             /*   IRQ1F      */
                    unsigned char IRQ0F:1;             /*   IRQ0F      */
                    } BIT;                             /*              */
             } ISR;                                    /*              */
       union {                                         /* ISCRH        */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char IRQ7SCB:1;           /*   IRQ7SCB    */
                    unsigned char IRQ7SCA:1;           /*   IRQ7SCA    */
                    unsigned char IRQ6SCB:1;           /*   IRQ6SCB    */
                    unsigned char IRQ6SCA:1;           /*   IRQ6SCA    */
                    unsigned char IRQ5SCB:1;           /*   IRQ5SCB    */
                    unsigned char IRQ5SCA:1;           /*   IRQ5SCA    */
                    unsigned char IRQ4SCB:1;           /*   IRQ4SCB    */
                    unsigned char IRQ4SCA:1;           /*   IRQ4SCA    */
                    } BIT;                             /*              */
             } ISCRH;                                  /*              */
       union {                                         /* ISCRL        */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char IRQ3SCB:1;           /*   IRQ3SCB    */
                    unsigned char IRQ3SCA:1;           /*   IRQ3SCA    */
                    unsigned char IRQ2SCB:1;           /*   IRQ2SCB    */
                    unsigned char IRQ2SCA:1;           /*   IRQ2SCA    */
                    unsigned char IRQ1SCB:1;           /*   IRQ1SCB    */
                    unsigned char IRQ1SCA:1;           /*   IRQ1SCA    */
                    unsigned char IRQ0SCB:1;           /*   IRQ0SCB    */
                    unsigned char IRQ0SCA:1;           /*   IRQ0SCA    */
                    } BIT;                             /*              */
             } ISCRL;                                  /*              */
       unsigned char wk0[6];                           /*              */
       union {                                         /* ABRKCR       */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char CMF:1;               /*   CMF        */
                    unsigned char :4;                  /*              */
                    unsigned char TESTSEL:2;           /*   TESTSEL    */
                    unsigned char BIE:1;               /*   BIE        */
                    } BIT;                             /*              */
             } ABRKCR;                                 /*              */
       union {                                         /* BARA         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char A23:1;               /*   A23        */
                    unsigned char A22:1;               /*   A22        */
                    unsigned char A21:1;               /*   A21        */
                    unsigned char A20:1;               /*   A20        */
                    unsigned char A19:1;               /*   A19        */
                    unsigned char A18:1;               /*   A18        */
                    unsigned char A17:1;               /*   A17        */
                    unsigned char A16:1;               /*   A16        */
                    } BIT;                             /*              */
             } BARA;                                   /*              */
       union {                                         /* BARB         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char A15:1;               /*   A15        */
                    unsigned char A14:1;               /*   A14        */
                    unsigned char A13:1;               /*   A13        */
                    unsigned char A12:1;               /*   A12        */
                    unsigned char A11:1;               /*   A11        */
                    unsigned char A10:1;               /*   A10        */
                    unsigned char A9:1;                /*   A9         */
                    unsigned char A8:1;                /*   A8         */
                    } BIT;                             /*              */
             } BARB;                                   /*              */
       union {                                         /* BARC         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char A7:1;                /*   A7         */
                    unsigned char A6:1;                /*   A6         */
                    unsigned char A5:1;                /*   A5         */
                    unsigned char A4:1;                /*   A4         */
                    unsigned char A3:1;                /*   A3         */
                    unsigned char A2:1;                /*   A2         */
                    unsigned char A1:1;                /*   A1         */
                    unsigned char :1;                  /*              */
                    } BIT;                             /*              */
             } BARC;                                   /*              */
       union {                                         /* IER16        */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char IRQ15E:1;            /*   IRQ15E     */
                    unsigned char IRQ14E:1;            /*   IRQ14E     */
                    unsigned char IRQ13E:1;            /*   IRQ13E     */
                    unsigned char IRQ12E:1;            /*   IRQ12E     */
                    unsigned char IRQ11E:1;            /*   IRQ11E     */
                    unsigned char IRQ10E:1;            /*   IRQ10E     */
                    unsigned char IRQ9E:1;             /*   IRQ9E      */
                    unsigned char IRQ8E:1;             /*   IRQ8E      */
                    } BIT;                             /*              */
             } IER16;                                  /*              */
       union {                                         /* ISR16        */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char IRQ15F:1;            /*   IRQ15F     */
                    unsigned char IRQ14F:1;            /*   IRQ14F     */
                    unsigned char IRQ13F:1;            /*   IRQ13F     */
                    unsigned char IRQ12F:1;            /*   IRQ12F     */
                    unsigned char IRQ11F:1;            /*   IRQ11F     */
                    unsigned char IRQ10F:1;            /*   IRQ10F     */
                    unsigned char IRQ9F:1;             /*   IRQ9F      */
                    unsigned char IRQ8F:1;             /*   IRQ8F      */
                    } BIT;                             /*              */
             } ISR16;                                  /*              */
       union {                                         /* ISCR16H      */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char IRQ15SCB:1;          /*   IRQ15SCB   */
                    unsigned char IRQ15SCA:1;          /*   IRQ15SCA   */
                    unsigned char IRQ14SCB:1;          /*   IRQ14SCB   */
                    unsigned char IRQ14SCA:1;          /*   IRQ14SCA   */
                    unsigned char IRQ13SCB:1;          /*   IRQ13SCB   */
                    unsigned char IRQ13SCA:1;          /*   IRQ13SCA   */
                    unsigned char IRQ12SCB:1;          /*   IRQ12SCB   */
                    unsigned char IRQ12SCA:1;          /*   IRQ12SCA   */
                    } BIT;                             /*              */
             } ISCR16H;                                /*              */
       union {                                         /* ISCR16L      */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char IRQ11SCB:1;          /*   IRQ11SCB   */
                    unsigned char IRQ11SCA:1;          /*   IRQ11SCA   */
                    unsigned char IRQ10SCB:1;          /*   IRQ10SCB   */
                    unsigned char IRQ10SCA:1;          /*   IRQ10SCA   */
                    unsigned char IRQ9SCB:1;           /*   IRQ9SCB    */
                    unsigned char IRQ9SCA:1;           /*   IRQ9SCA    */
                    unsigned char IRQ8SCB:1;           /*   IRQ8SCB    */
                    unsigned char IRQ8SCA:1;           /*   IRQ8SCA    */
                    } BIT;                             /*              */
             } ISCR16L;                                /*              */
       unsigned char wk1[198];                         /*              */
       union {                                         /* IER          */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char IRQ7E:1;             /*   IRQ7E      */
                    unsigned char IRQ6E:1;             /*   IRQ6E      */
                    unsigned char IRQ5E:1;             /*   IRQ5E      */
                    unsigned char IRQ4E:1;             /*   IRQ4E      */
                    unsigned char IRQ3E:1;             /*   IRQ3E      */
                    unsigned char IRQ2E:1;             /*   IRQ2E      */
                    unsigned char IRQ1E:1;             /*   IRQ1E      */
                    unsigned char IRQ0E:1;             /*   IRQ0E      */
                    } BIT;                             /*              */
             } IER;                                    /*              */
};                                                     /*              */
struct st_dtc {                                        /* struct DTC   */
       union {                                         /* DTCERF       */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char DTCEF7:1;            /*   DTCEF7     */
                    unsigned char DTCEF6:1;            /*   DTCEF6     */
                    unsigned char :6;                  /*              */
                    } BIT;                             /*              */
             } DTCERF;                                 /*              */
       unsigned char wk0[7];                           /*              */
       unsigned char DTCERA;                           /* DTCERA       */
       union {                                         /* DTCERB       */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char DTCEB7:1;            /*   DTCEB7     */
                    unsigned char DTCEB6:1;            /*   DTCEB6     */
                    unsigned char DTCEB5:1;            /*   DTCEB5     */
                    unsigned char :2;                  /*              */
                    unsigned char DTCEB:3;             /*   DTCEB      */
                    } BIT;                             /*              */
             } DTCERB;                                 /*              */
       unsigned char DTCERC;                           /* DTCERC       */
       union {                                         /* DTCERD       */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char DTCED7:1;            /*   DTCED7     */
                    unsigned char DTCED6:1;            /*   DTCED6     */
                    unsigned char DTCED5:1;            /*   DTCED5     */
                    unsigned char DTCED4:1;            /*   DTCED4     */
                    unsigned char DTCED3:1;            /*   DTCED3     */
                    unsigned char :2;                  /*              */
                    unsigned char DTCED0:1;            /*   DTCED0     */
                    } BIT;                             /*              */
             } DTCERD;                                 /*              */
       union {                                         /* DTCERE       */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char :4;                  /*              */
                    unsigned char DTCEE:4;             /*   DTCEE      */
                    } BIT;                             /*              */
             } DTCERE;                                 /*              */
       union {                                         /* DTVECR       */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char SWDTE:1;             /*   SWDTE      */
                    unsigned char DTVEC:7;             /*   DTVEC      */
                    } BIT;                             /*              */
             } DTVECR;                                 /*              */
};                                                     /*              */
struct st_bsc {                                        /* struct BSC   */
       union {                                         /* BCR2         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char :4;                  /*              */
                    unsigned char ADFULLE:1;           /*   ADFULLE    */
                    unsigned char EXCKS:1;             /*   EXCKS      */
                    unsigned char :2;                  /*              */
                    } BIT;                             /*              */
             } BCR2;                                   /*              */
       union {                                         /* WSCR2        */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char WMS10:1;             /*   WMS10      */
                    unsigned char WC11:1;              /*   WC11       */
                    unsigned char WC10:1;              /*   WC10       */
                    unsigned char :5;                  /*              */
                    } BIT;                             /*              */
             } WSCR2;                                  /*              */
       unsigned char wk0[68];                          /*              */
       union {                                         /* BCR          */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char :1;                  /*              */
                    unsigned char ICIS:1;              /*   ICIS       */
                    unsigned char BRSTRM:1;            /*   BRSTRM     */
                    unsigned char BRSTS:2;             /*   BRSTS      */
                    unsigned char :1;                  /*              */
                    unsigned char IOS:2;               /*   IOS        */
                    } BIT;                             /*              */
             } BCR;                                    /*              */
       union {                                         /* WSCR         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char ABW256:1;            /*   ABW256     */
                    unsigned char AST256:1;            /*   AST256     */
                    unsigned char ABW:1;               /*   ABW        */
                    unsigned char AST:1;               /*   AST        */
                    unsigned char WMS:2;               /*   WMS        */
                    unsigned char WC:2;                /*   WC         */
                    } BIT;                             /*              */
             } WSCR;                                   /*              */
};                                                     /*              */
struct st_frt {                                        /* struct FRT   */
       union {                                         /* TIER         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char :4;                  /*              */
                    unsigned char OCIAE:1;             /*   OCIAE      */
                    unsigned char OCIBE:1;             /*   OCIBE      */
                    unsigned char OVIE:1;              /*   OVIE       */
                    unsigned char :1;                  /*              */
                    } BIT;                             /*              */
             } TIER;                                   /*              */
       union {                                         /* TCSR         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char :4;                  /*              */
                    unsigned char OCFA:1;              /*   OCFA       */
                    unsigned char OCFB:1;              /*   OCFB       */
                    unsigned char OVF:1;               /*   OVF        */
                    unsigned char CCLRA:1;             /*   CCLRA      */
                    } BIT;                             /*              */
             } TCSR;                                   /*              */
       unsigned short FRC;                             /* FRC          */
       unsigned short OCRA;                            /* OCRA or OCRB */
       union {                                         /* TCR          */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char :6;                  /*              */
                    unsigned char CKS:2;               /*   CKS        */
                    } BIT;                             /*              */
             } TCR;                                    /*              */
       union {                                         /* TOCR         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char :1;                  /*              */
                    unsigned char OCRAMS:1;            /*   OCRAMS     */
                    unsigned char :1;                  /*              */
                    unsigned char OCRS:1;              /*   OCRS       */
                    unsigned char :4;                  /*              */
                    } BIT;                             /*              */
             } TOCR;                                   /*              */
       union {                                         /* OCRAR        */
             unsigned short WORD;                      /*  Word Access */
             struct {                                  /*  Bit Access  */
                    unsigned short :8;                 /*              */
                    unsigned short BIT:8;              /*   BIT        */
                    } BIT;                             /*              */
             } OCRAR;                                  /*              */
       union {                                         /* OCRAF        */
             unsigned short WORD;                      /*  Word Access */
             struct {                                  /*  Bit Access  */
                    unsigned short :8;                 /*              */
                    unsigned short BIT:8;              /*   BIT        */
                    } BIT;                             /*              */
             } OCRAF;                                  /*              */
};                                                     /*              */
struct st_port {                                       /* struct PORT  */
       union {                                         /* NCCS         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char :5;                  /*              */
                    unsigned char NCCK:3;              /*   NCCK       */
                    } BIT;                             /*              */
             } NCCS;                                   /*              */
       unsigned char wk0[119];                         /*              */
       union {                                         /* PINFNCR      */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char :5;                  /*              */
                    unsigned char SERIRQOFF:1;         /*   SERIRQOFF  */
                    unsigned char LPCPDOFF:1;          /*   LPCPDOFF   */
                    unsigned char CLKRUNOFF:1;         /*   CLKRUNOFF  */
                    } BIT;                             /*              */
             } PINFNCR;                                /*              */
       unsigned char wk1[61];                          /*              */
       union {                                         /* ISSR16       */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char ISS15:1;             /*   ISS15      */
                    unsigned char ISS14:1;             /*   ISS14      */
                    unsigned char ISS13:1;             /*   ISS13      */
                    unsigned char ISS12:1;             /*   ISS12      */
                    unsigned char ISS11:1;             /*   ISS11      */
                    unsigned char ISS10:1;             /*   ISS10      */
                    unsigned char ISS9:1;              /*   ISS9       */
                    unsigned char ISS8:1;              /*   ISS8       */
                    } BIT;                             /*              */
             } ISSR16;                                 /*              */
       union {                                         /* ISSR         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char ISS7:1;              /*   ISS7       */
                    unsigned char ISS6:1;              /*   ISS6       */
                    unsigned char ISS5:1;              /*   ISS5       */
                    unsigned char ISS4:1;              /*   ISS4       */
                    unsigned char ISS3:1;              /*   ISS3       */
                    unsigned char ISS2:1;              /*   ISS2       */
                    unsigned char ISSR:1;              /*   ISS1       */
                    unsigned char ISS0:1;              /*   ISS0       */
                    } BIT;                             /*              */
             } ISSR;                                   /*              */
       union {                                         /* PTCNT0       */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char SCPFSEL1:1;          /*   SCPFSEL1   */
                    unsigned char SCPFSEL3:1;          /*   SCPFSEL3   */
                    unsigned char :3;                  /*              */
                    unsigned char PWMS:1;              /*   PWMS       */
                    unsigned char OBE:1;               /*   OBE        */
                    unsigned char :1;                  /*              */
                    } BIT;                             /*              */
             } PTCNT0;                                 /*              */
};                                                     /*              */
struct st_pa {                                         /* struct PA    */
       union {                                         /* ODR          */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char PA7ODR:1;            /*   PA7ODR     */
                    unsigned char PA6ODR:1;            /*   PA6ODR     */
                    unsigned char PA5ODR:1;            /*   PA5ODR     */
                    unsigned char PA4ODR:1;            /*   PA4ODR     */
                    unsigned char PA3ODR:1;            /*   PA3ODR     */
                    unsigned char PA2ODR:1;            /*   PA2ODR     */
                    unsigned char PA1ODR:1;            /*   PA1ODR     */
                    unsigned char PA0ODR:1;            /*   PA0ODR     */
                    } BIT;                             /*              */
             } ODR;                                    /*              */
       union {                                         /* DDR PAPIN    */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char PA7DDR:1;            /*   PA7DDR     */
                    unsigned char PA6DDR:1;            /*   PA6DDR     */
                    unsigned char PA5DDR:1;            /*   PA5DDR     */
                    unsigned char PA4DDR:1;            /*   PA4DDR     */
                    unsigned char PA3DDR:1;            /*   PA3DDR     */
                    unsigned char PA2DDR:1;            /*   PA2DDR     */
                    unsigned char PA1DDR:1;            /*   PA1DDR     */
                    unsigned char PA0DDR:1;            /*   PA0DDR     */
                    } BIT;                             /*              */
             } DDR;                                    /*              */
};                                                     /*              */
struct st_pb {                                         /* struct PB    */
       union {                                         /* ODR          */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char PB7ODR:1;            /*   PB7ODR     */
                    unsigned char PB6ODR:1;            /*   PB6ODR     */
                    unsigned char PB5ODR:1;            /*   PB5ODR     */
                    unsigned char PB4ODR:1;            /*   PB4ODR     */
                    unsigned char PB3ODR:1;            /*   PB3ODR     */
                    unsigned char PB2ODR:1;            /*   PB2ODR     */
                    unsigned char PB1ODR:1;            /*   PB1ODR     */
                    unsigned char PB0ODR:1;            /*   PB0ODR     */
                    } BIT;                             /*              */
             } ODR;                                    /*              */
       unsigned char wk0[1];                           /*              */
       union {                                         /* DDR P7PIN    */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char PB7DDR:1;            /*   PB7DDR     */
                    unsigned char PB6DDR:1;            /*   PB6DDR     */
                    unsigned char PB5DDR:1;            /*   PB5DDR     */
                    unsigned char PB4DDR:1;            /*   PB4DDR     */
                    unsigned char PB3DDR:1;            /*   PB3DDR     */
                    unsigned char PB2DDR:1;            /*   PB2DDR     */
                    unsigned char PB1DDR:1;            /*   PB1DDR     */
                    unsigned char PB0DDR:1;            /*   PB0DDR     */
                    } BIT;                             /*              */
             } DDR;                                    /*              */
};                                                     /*              */
struct st_pc {                                         /* struct PC    */
       union {                                         /* ODR          */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char PC7ODR:1;            /*   PC7ODR     */
                    unsigned char PC6ODR:1;            /*   PC6ODR     */
                    unsigned char PC5ODR:1;            /*   PC5ODR     */
                    unsigned char PC4ODR:1;            /*   PC4ODR     */
                    unsigned char PC3ODR:1;            /*   PC3ODR     */
                    unsigned char PC2ODR:1;            /*   PC2ODR     */
                    unsigned char PC1ODR:1;            /*   PC1ODR     */
                    unsigned char PC0ODR:1;            /*   PC0ODR     */
                    } BIT;                             /*              */
             } ODR;                                    /*              */
       unsigned char wk0[1];                           /*              */
       union {                                         /* DDR PCPIN    */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char PC7DDR:1;            /*   PC7DDR     */
                    unsigned char PC6DDR:1;            /*   PC6DDR     */
                    unsigned char PC5DDR:1;            /*   PC5DDR     */
                    unsigned char PC4DDR:1;            /*   PC4DDR     */
                    unsigned char PC3DDR:1;            /*   PC3DDR     */
                    unsigned char PC2DDR:1;            /*   PC2DDR     */
                    unsigned char PC1DDR:1;            /*   PC1DDR     */
                    unsigned char PC0DDR:1;            /*   PC0DDR     */
                    } BIT;                             /*              */
             } DDR;                                    /*              */
};                                                     /*              */
struct st_pd {                                         /* struct PD    */
       union {                                         /* ODR          */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char PD7ODR:1;            /*   PD7ODR     */
                    unsigned char PD6ODR:1;            /*   PD6ODR     */
                    unsigned char PD5ODR:1;            /*   PD5ODR     */
                    unsigned char PD4ODR:1;            /*   PD4ODR     */
                    unsigned char PD3ODR:1;            /*   PD3ODR     */
                    unsigned char PD2ODR:1;            /*   PD2ODR     */
                    unsigned char PD1ODR:1;            /*   PD1ODR     */
                    unsigned char PD0ODR:1;            /*   PD0ODR     */
                    } BIT;                             /*              */
             } ODR;                                    /*              */
       unsigned char wk0[1];                           /*              */
       union {                                         /* DDR PDPIN    */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char PD7DDR:1;            /*   PD7DDR     */
                    unsigned char PD6DDR:1;            /*   PD6DDR     */
                    unsigned char PD5DDR:1;            /*   PD5DDR     */
                    unsigned char PD4DDR:1;            /*   PD4DDR     */
                    unsigned char PD3DDR:1;            /*   PD3DDR     */
                    unsigned char PD2DDR:1;            /*   PD2DDR     */
                    unsigned char PD1DDR:1;            /*   PD1DDR     */
                    unsigned char PD0DDR:1;            /*   PD0DDR     */
                    } BIT;                             /*              */
             } DDR;                                    /*              */
};                                                     /*              */
struct st_pe {                                         /* struct PE    */
       union {                                         /* ODR          */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char PE7ODR:1;            /*   PE7ODR     */
                    unsigned char PE6ODR:1;            /*   PE6ODR     */
                    unsigned char PE5ODR:1;            /*   PE5ODR     */
                    unsigned char PE4ODR:1;            /*   PE4ODR     */
                    unsigned char PE3ODR:1;            /*   PE3ODR     */
                    unsigned char PE2ODR:1;            /*   PE2ODR     */
                    unsigned char PE1ODR:1;            /*   PE1ODR     */
                    unsigned char PE0ODR:1;            /*   PE0ODR     */
                    } BIT;                             /*              */
             } ODR;                                    /*              */
       unsigned char wk0[1];                           /*              */
       union {                                         /* DDR PEPIN    */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char PE7DDR:1;            /*   PE7DDR     */
                    unsigned char PE6DDR:1;            /*   PE6DDR     */
                    unsigned char PE5DDR:1;            /*   PE5DDR     */
                    unsigned char PE4DDR:1;            /*   PE4DDR     */
                    unsigned char PE3DDR:1;            /*   PE3DDR     */
                    unsigned char PE2DDR:1;            /*   PE2DDR     */
                    unsigned char PE1DDR:1;            /*   PE1DDR     */
                    unsigned char PE0DDR:1;            /*   PE0DDR     */
                    } BIT;                             /*              */
             } DDR;                                    /*              */
};                                                     /*              */
struct st_pf {                                         /* struct PF    */
       union {                                         /* ODR          */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char :1;                  /*              */
                    unsigned char PF6ODR:1;            /*   PF6ODR     */
                    unsigned char PF5ODR:1;            /*   PF5ODR     */
                    unsigned char PF4ODR:1;            /*   PF4ODR     */
                    unsigned char PF3ODR:1;            /*   PF3ODR     */
                    unsigned char PF2ODR:1;            /*   PF2ODR     */
                    unsigned char PF1ODR:1;            /*   PF1ODR     */
                    unsigned char PF0ODR:1;            /*   PF0ODR     */
                    } BIT;                             /*              */
             } ODR;                                    /*              */
       unsigned char wk0[1];                           /*              */
       union {                                         /* DDR PFPIN    */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char :1;                  /*              */
                    unsigned char PF6DDR:1;            /*   PF6DDR     */
                    unsigned char PF5DDR:1;            /*   PF5DDR     */
                    unsigned char PF4DDR:1;            /*   PF4DDR     */
                    unsigned char PF3DDR:1;            /*   PF3DDR     */
                    unsigned char PF2DDR:1;            /*   PF2DDR     */
                    unsigned char PF1DDR:1;            /*   PF1DDR     */
                    unsigned char PF0DDR:1;            /*   PF0DDR     */
                    } BIT;                             /*              */
             } DDR;                                    /*              */
};                                                     /*              */
struct st_p1 {                                         /* struct P1    */
       union {                                         /* PCR          */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char P17PCR:1;            /*   P17PCR     */
                    unsigned char P16PCR:1;            /*   P16PCR     */
                    unsigned char P15PCR:1;            /*   P15PCR     */
                    unsigned char P14PCR:1;            /*   P14PCR     */
                    unsigned char P13PCR:1;            /*   P13PCR     */
                    unsigned char P12PCR:1;            /*   P12PCR     */
                    unsigned char P11PCR:1;            /*   P11PCR     */
                    unsigned char P10PCR:1;            /*   P10PCR     */
                    } BIT;                             /*              */
             } PCR;                                    /*              */
       unsigned char wk0[3];                           /*              */
       union {                                         /* DDR          */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char P17DDR:1;            /*   P17DDR     */
                    unsigned char P16DDR:1;            /*   P16DDR     */
                    unsigned char P15DDR:1;            /*   P15DDR     */
                    unsigned char P14DDR:1;            /*   P14DDR     */
                    unsigned char P13DDR:1;            /*   P13DDR     */
                    unsigned char P12DDR:1;            /*   P12DDR     */
                    unsigned char P11DDR:1;            /*   P11DDR     */
                    unsigned char P10DDR:1;            /*   P10DDR     */
                    } BIT;                             /*              */
             } DDR;                                    /*              */
       unsigned char wk1[1];                           /*              */
       union {                                         /* DR           */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char P17DR:1;             /*   P17DR      */
                    unsigned char P16DR:1;             /*   P16DR      */
                    unsigned char P15DR:1;             /*   P15DR      */
                    unsigned char P14DR:1;             /*   P14DR      */
                    unsigned char P13DR:1;             /*   P13DR      */
                    unsigned char P12DR:1;             /*   P12DR      */
                    unsigned char P11DR:1;             /*   P11DR      */
                    unsigned char P10DR:1;             /*   P10DR      */
                    } BIT;                             /*              */
             } DR;                                     /*              */
};                                                     /*              */
struct st_p2 {                                         /* struct P2    */
       union {                                         /* PCR          */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char P27PCR:1;            /*   P27PCR     */
                    unsigned char P26PCR:1;            /*   P26PCR     */
                    unsigned char P25PCR:1;            /*   P25PCR     */
                    unsigned char P24PCR:1;            /*   P24PCR     */
                    unsigned char P23PCR:1;            /*   P23PCR     */
                    unsigned char P22PCR:1;            /*   P22PCR     */
                    unsigned char P21PCR:1;            /*   P21PCR     */
                    unsigned char P20PCR:1;            /*   P20PCR     */
                    } BIT;                             /*              */
             } PCR;                                    /*              */
       unsigned char wk0[3];                           /*              */
       union {                                         /* DDR          */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char P27DDR:1;            /*   P27DDR     */
                    unsigned char P26DDR:1;            /*   P26DDR     */
                    unsigned char P25DDR:1;            /*   P25DDR     */
                    unsigned char P24DDR:1;            /*   P24DDR     */
                    unsigned char P23DDR:1;            /*   P23DDR     */
                    unsigned char P22DDR:1;            /*   P22DDR     */
                    unsigned char P21DDR:1;            /*   P21DDR     */
                    unsigned char P20DDR:1;            /*   P20DDR     */
                    } BIT;                             /*              */
             } DDR;                                    /*              */
       unsigned char wk1[1];                           /*              */
       union {                                         /* DR           */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char P27DR:1;             /*   P27DR      */
                    unsigned char P26DR:1;             /*   P26DR      */
                    unsigned char P25DR:1;             /*   P25DR      */
                    unsigned char P24DR:1;             /*   P24DR      */
                    unsigned char P23DR:1;             /*   P23DR      */
                    unsigned char P22DR:1;             /*   P22DR      */
                    unsigned char P21DR:1;             /*   P21DR      */
                    unsigned char P20DR:1;             /*   P20DR      */
                    } BIT;                             /*              */
             } DR;                                     /*              */
};                                                     /*              */
struct st_p3 {                                         /* struct P3    */
       union {                                         /* NCE          */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char P37NCE:1;            /*   P37NCE     */
                    unsigned char P36NCE:1;            /*   P36NCE     */
                    unsigned char P35NCE:1;            /*   P35NCE     */
                    unsigned char P34NCE:1;            /*   P34NCE     */
                    unsigned char P33NCE:1;            /*   P33NCE     */
                    unsigned char P32NCE:1;            /*   P32NCE     */
                    unsigned char P30NCE:2;            /*   P30NCE     */
                    } BIT;                             /*              */
             } NCE;                                    /*              */
       union {                                         /* NCMC         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char P37NCMC:1;           /*   P37NCMC    */
                    unsigned char P36NCMC:1;           /*   P36NCMC    */
                    unsigned char P35NCMC:1;           /*   P35NCMC    */
                    unsigned char P34NCMC:1;           /*   P34NCMC    */
                    unsigned char P33NCMC:1;           /*   P33NCMC    */
                    unsigned char P32NCMC:1;           /*   P32NCMC    */
                    unsigned char P30NCMC:2;           /*   P30NCMC    */
                    } BIT;                             /*              */
             } NCMC;                                   /*              */
       unsigned char wk0[360];                         /*              */
       union {                                         /* PCR          */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char P37PCR:1;            /*   P37PCR     */
                    unsigned char P36PCR:1;            /*   P36PCR     */
                    unsigned char P35PCR:1;            /*   P35PCR     */
                    unsigned char P34PCR:1;            /*   P34PCR     */
                    unsigned char P33PCR:1;            /*   P33PCR     */
                    unsigned char P32PCR:1;            /*   P32PCR     */
                    unsigned char P31PCR:1;            /*   P31PCR     */
                    unsigned char P30PCR:1;            /*   P30PCR     */
                    } BIT;                             /*              */
             } PCR;                                    /*              */
       unsigned char wk1[5];                           /*              */
       union {                                         /* DDR          */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char P37DDR:1;            /*   P37DDR     */
                    unsigned char P36DDR:1;            /*   P36DDR     */
                    unsigned char P35DDR:1;            /*   P35DDR     */
                    unsigned char P34DDR:1;            /*   P34DDR     */
                    unsigned char P33DDR:1;            /*   P33DDR     */
                    unsigned char P32DDR:1;            /*   P32DDR     */
                    unsigned char P31DDR:1;            /*   P31DDR     */
                    unsigned char P30DDR:1;            /*   P30DDR     */
                    } BIT;                             /*              */
             } DDR;                                    /*              */
       unsigned char wk2[1];                           /*              */
       union {                                         /* DR           */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char P37DR:1;             /*   P37DR      */
                    unsigned char P36DR:1;             /*   P36DR      */
                    unsigned char P35DR:1;             /*   P35DR      */
                    unsigned char P34DR:1;             /*   P34DR      */
                    unsigned char P33DR:1;             /*   P33DR      */
                    unsigned char P32DR:1;             /*   P32DR      */
                    unsigned char P31DR:1;             /*   P31DR      */
                    unsigned char P30DR:1;             /*   P30DR      */
                    } BIT;                             /*              */
             } DR;                                     /*              */
};                                                     /*              */
struct st_p4 {                                         /* struct P4    */
       union {                                         /* BNCE         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char P47NCE:1;            /*   P47NCE     */
                    unsigned char P46NCE:1;            /*   P46NCE     */
                    unsigned char P45NCE:1;            /*   P45NCE     */
                    unsigned char P44NCE:1;            /*   P44NCE     */
                    unsigned char PB3NCE:1;            /*   PB3NCE     */
                    unsigned char PB2NCE:1;            /*   PB2NCE     */
                    unsigned char PB1NCE:1;            /*   PB1NCE     */
                    unsigned char PB0NCE:1;            /*   PB0NCE     */
                    } BIT;                             /*              */
             } BNCE;                                   /*              */
       union {                                         /* BNCMC        */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char P47NCMC:1;           /*   P47NCMC    */
                    unsigned char P46NCMC:1;           /*   P46NCMC    */
                    unsigned char P45NCMC:1;           /*   P45NCMC    */
                    unsigned char P44NCMC:1;           /*   P44NCMC    */
                    unsigned char PB3NCMC:1;           /*   PB3NCMC    */
                    unsigned char PB2NCMC:1;           /*   PB2NCMC    */
                    unsigned char PB1NCMC:1;           /*   PB1NCMC    */
                    unsigned char PB0NCMC:1;           /*   PB0NCMC    */
                    } BIT;                             /*              */
             } BNCMC;                                  /*              */
       unsigned char wk0[3];                           /*              */
       union {                                         /* PCR          */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char P47PCR:1;            /*   P47PCR     */
                    unsigned char P46PCR:1;            /*   P46PCR     */
                    unsigned char P45PCR:1;            /*   P45PCR     */
                    unsigned char P44PCR:1;            /*   P44PCR     */
                    unsigned char P43PCR:1;            /*   P43PCR     */
                    unsigned char P42PCR:1;            /*   P42PCR     */
                    unsigned char P41PCR:1;            /*   P41PCR     */
                    unsigned char P40PCR:1;            /*   P40PCR     */
                    } BIT;                             /*              */
             } PCR;                                    /*              */
       unsigned char wk1[245];                         /*              */
       union {                                         /* DDR          */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char P47DDR:1;            /*   P47DDR     */
                    unsigned char P46DDR:1;            /*   P46DDR     */
                    unsigned char P45DDR:1;            /*   P45DDR     */
                    unsigned char P44DDR:1;            /*   P44DDR     */
                    unsigned char P43DDR:1;            /*   P43DDR     */
                    unsigned char P42DDR:1;            /*   P42DDR     */
                    unsigned char P41DDR:1;            /*   P41DDR     */
                    unsigned char P40DDR:1;            /*   P40DDR     */
                    } BIT;                             /*              */
             } DDR;                                    /*              */
       unsigned char wk2[1];                           /*              */
       union {                                         /* DR           */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char P47DR:1;             /*   P47DR      */
                    unsigned char P46DR:1;             /*   P46DR      */
                    unsigned char P45DR:1;             /*   P45DR      */
                    unsigned char P44DR:1;             /*   P44DR      */
                    unsigned char P43DR:1;             /*   P43DR      */
                    unsigned char P42DR:1;             /*   P42DR      */
                    unsigned char P41DR:1;             /*   P41DR      */
                    unsigned char P40DR:1;             /*   P40DR      */
                    } BIT;                             /*              */
             } DR;                                     /*              */
};                                                     /*              */
struct st_p5 {                                         /* struct P5    */
       union {                                         /* DDR          */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char P57DDR:1;            /*   P57DDR     */
                    unsigned char P56DDR:1;            /*   P56DDR     */
                    unsigned char P55DDR:1;            /*   P55DDR     */
                    unsigned char P54DDR:1;            /*   P54DDR     */
                    unsigned char P53DDR:1;            /*   P53DDR     */
                    unsigned char P52DDR:1;            /*   P52DDR     */
                    unsigned char P51DDR:1;            /*   P51DDR     */
                    unsigned char P50DDR:1;            /*   P50DDR     */
                    } BIT;                             /*              */
             } DDR;                                    /*              */
       unsigned char wk0[1];                           /*              */
       union {                                         /* DR           */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char P57DR:1;             /*   P57DR      */
                    unsigned char P56DR:1;             /*   P56DR      */
                    unsigned char P55DR:1;             /*   P55DR      */
                    unsigned char P54DR:1;             /*   P54DR      */
                    unsigned char P53DR:1;             /*   P53DR      */
                    unsigned char P52DR:1;             /*   P52DR      */
                    unsigned char P51DR:1;             /*   P51DR      */
                    unsigned char P50DR:1;             /*   P50DR      */
                    } BIT;                             /*              */
             } DR;                                     /*              */
};                                                     /*              */
struct st_p6 {                                         /* struct P6    */
       union {                                         /* PCR          */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char P67PCR:1;            /*   P67PCR     */
                    unsigned char P66PCR:1;            /*   P66PCR     */
                    unsigned char P65PCR:1;            /*   P65PCR     */
                    unsigned char P64PCR:1;            /*   P64PCR     */
                    unsigned char P63PCR:1;            /*   P63PCR     */
                    unsigned char P62PCR:1;            /*   P62PCR     */
                    unsigned char P61PCR:1;            /*   P61PCR     */
                    unsigned char P60PCR:1;            /*   P60PCR     */
                    } BIT;                             /*              */
             } PCR;                                    /*              */
       unsigned char wk0[252];                         /*              */
       union {                                         /* DDR          */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char P67DDR:1;            /*   P67DDR     */
                    unsigned char P66DDR:1;            /*   P66DDR     */
                    unsigned char P65DDR:1;            /*   P65DDR     */
                    unsigned char P64DDR:1;            /*   P64DDR     */
                    unsigned char P63DDR:1;            /*   P63DDR     */
                    unsigned char P62DDR:1;            /*   P62DDR     */
                    unsigned char P61DDR:1;            /*   P61DDR     */
                    unsigned char P60DDR:1;            /*   P60DDR     */
                    } BIT;                             /*              */
             } DDR;                                    /*              */
       unsigned char wk1[1];                           /*              */
       union {                                         /* DR           */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char P67DR:1;             /*   P67DR      */
                    unsigned char P66DR:1;             /*   P66DR      */
                    unsigned char P65DR:1;             /*   P65DR      */
                    unsigned char P64DR:1;             /*   P64DR      */
                    unsigned char P63DR:1;             /*   P63DR      */
                    unsigned char P62DR:1;             /*   P62DR      */
                    unsigned char P61DR:1;             /*   P61DR      */
                    unsigned char P60DR:1;             /*   P60DR      */
                    } BIT;                             /*              */
             } DR;                                     /*              */
};                                                     /*              */
struct st_p8 {                                         /* struct P8    */
       union {                                         /* DDR PBPIN    */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char P87DDR:1;            /*   P87DDR     */
                    unsigned char P86DDR:1;            /*   P86DDR     */
                    unsigned char P85DDR:1;            /*   P85DDR     */
                    unsigned char P84DDR:1;            /*   P84DDR     */
                    unsigned char P83DDR:1;            /*   P83DDR     */
                    unsigned char P82DDR:1;            /*   P82DDR     */
                    unsigned char P81DDR:1;            /*   P81DDR     */
                    unsigned char P80DDR:1;            /*   P80DDR     */
                    } BIT;                             /*              */
             } DDR;                                    /*              */
       unsigned char wk0[1];                           /*              */
       union {                                         /* DR           */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char P87DR:1;             /*   P87DR      */
                    unsigned char P86DR:1;             /*   P86DR      */
                    unsigned char P85DR:1;             /*   P85DR      */
                    unsigned char P84DR:1;             /*   P84DR      */
                    unsigned char P83DR:1;             /*   P83DR      */
                    unsigned char P82DR:1;             /*   P82DR      */
                    unsigned char P81DR:1;             /*   P81DR      */
                    unsigned char P80DR:1;             /*   P80DR      */
                    } BIT;                             /*              */
             } DR;                                     /*              */
};                                                     /*              */
struct st_p9 {                                         /* struct P9    */
       union {                                         /* DDR          */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char P97DDR:1;            /*   P97DDR     */
                    unsigned char P96DDR:1;            /*   P96DDR     */
                    unsigned char P95DDR:1;            /*   P95DDR     */
                    unsigned char P94DDR:1;            /*   P94DDR     */
                    unsigned char P93DDR:1;            /*   P93DDR     */
                    unsigned char P92DDR:1;            /*   P92DDR     */
                    unsigned char P91DDR:1;            /*   P91DDR     */
                    unsigned char P90DDR:1;            /*   P90DDR     */
                    } BIT;                             /*              */
             } DDR;                                    /*              */
       union {                                         /* DR           */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char P97DR:1;             /*   P97DR      */
                    unsigned char P96DR:1;             /*   P96DR      */
                    unsigned char P95DR:1;             /*   P95DR      */
                    unsigned char P94DR:1;             /*   P94DR      */
                    unsigned char P93DR:1;             /*   P93DR      */
                    unsigned char P92DR:1;             /*   P92DR      */
                    unsigned char P91DR:1;             /*   P91DR      */
                    unsigned char P90DR:1;             /*   P90DR      */
                    } BIT;                             /*              */
             } DR;                                     /*              */
};                                                     /*              */
struct st_iic {                                        /* struct IIC   */
       union {                                         /* ICXR0        */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char STOPIM:1;            /*   STOPIM     */
                    unsigned char HNDS:1;              /*   HNDS       */
                    unsigned char ICDRF:1;             /*   ICDRF      */
                    unsigned char ICDRE:1;             /*   ICDRE      */
                    unsigned char ALIE:1;              /*   ALIE       */
                    unsigned char ALSL:1;              /*   ALSL       */
                    unsigned char FNC:2;               /*   FNC        */
                    } BIT;                             /*              */
             } ICXR0;                                  /*              */
       union {                                         /* ICXR1        */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char STOPIM:1;            /*   STOPIM     */
                    unsigned char HNDS:1;              /*   HNDS       */
                    unsigned char ICDRF:1;             /*   ICDRF      */
                    unsigned char ICDRE:1;             /*   ICDRE      */
                    unsigned char ALIE:1;              /*   ALIE       */
                    unsigned char ALSL:1;              /*   ALSL       */
                    unsigned char FNC:2;               /*   FNC        */
                    } BIT;                             /*              */
             } ICXR1;                                  /*              */
       unsigned char wk0[2];                           /*              */
       union {                                         /* ICXR2        */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char STOPIM:1;            /*   STOPIM     */
                    unsigned char HNDS:1;              /*   HNDS       */
                    unsigned char ICDRF:1;             /*   ICDRF      */
                    unsigned char ICDRE:1;             /*   ICDRE      */
                    unsigned char ALIE:1;              /*   ALIE       */
                    unsigned char ALSL:1;              /*   ALSL       */
                    unsigned char FNC:2;               /*   FNC        */
                    } BIT;                             /*              */
             } ICXR2;                                  /*              */
       union {                                         /* ICXR3        */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char STOPIM:1;            /*   STOPIM     */
                    unsigned char HNDS:1;              /*   HNDS       */
                    unsigned char ICDRF:1;             /*   ICDRF      */
                    unsigned char ICDRE:1;             /*   ICDRE      */
                    unsigned char ALIE:1;              /*   ALIE       */
                    unsigned char ALSL:1;              /*   ALSL       */
                    unsigned char FNC:2;               /*   FNC        */
                    } BIT;                             /*              */
             } ICXR3;                                  /*              */
       unsigned char wk1[1];                           /*              */
       union {                                         /* IICX3        */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char :4;                  /*              */
                    unsigned char TCSS:1;              /*   TCSS       */
                    unsigned char IICX5:1;             /*   IICX5      */
                    unsigned char IICX4:1;             /*   IICX4      */
                    unsigned char IICX3:1;             /*   IICX3      */
                    } BIT;                             /*              */
             } IICX3;                                  /*              */
       union {                                         /* ICXR4        */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char STOPIM:1;            /*   STOPIM     */
                    unsigned char HNDS:1;              /*   HNDS       */
                    unsigned char ICDRF:1;             /*   ICDRF      */
                    unsigned char ICDRE:1;             /*   ICDRE      */
                    unsigned char ALIE:1;              /*   ALIE       */
                    unsigned char ALSL:1;              /*   ALSL       */
                    unsigned char FNC:2;               /*   FNC        */
                    } BIT;                             /*              */
             } ICXR4;                                  /*              */
       union {                                         /* ICXR5        */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char STOPIM:1;            /*   STOPIM     */
                    unsigned char HNDS:1;              /*   HNDS       */
                    unsigned char ICDRF:1;             /*   ICDRF      */
                    unsigned char ICDRE:1;             /*   ICDRE      */
                    unsigned char ALIE:1;              /*   ALIE       */
                    unsigned char ALSL:1;              /*   ALSL       */
                    unsigned char FNC:2;               /*   FNC        */
                    } BIT;                             /*              */
             } ICXR5;                                  /*              */
};                                                     /*              */
struct st_iic0 {                                       /* struct IIC0  */
       union {                                         /* ICCR         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char ICE:1;               /*   ICE        */
                    unsigned char IEIC:1;              /*   IEIC       */
                    unsigned char MST:1;               /*   MST        */
                    unsigned char TRS:1;               /*   TRS        */
                    unsigned char ACKE:1;              /*   ACKE       */
                    unsigned char BBSY:1;              /*   BBSY       */
                    unsigned char IRIC:1;              /*   IRIC       */
                    unsigned char SCP:1;               /*   SCP        */
                    } BIT;                             /*              */
             } ICCR;                                   /*              */
       union {                                         /* ICSR         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char ESTP:1;              /*   ESTP       */
                    unsigned char STOP:1;              /*   STOP       */
                    unsigned char IRTR:1;              /*   IRTR       */
                    unsigned char AASX:1;              /*   AASX       */
                    unsigned char AL:1;                /*   AL         */
                    unsigned char AAS:1;               /*   AAS        */
                    unsigned char ADZ:1;               /*   ADZ        */
                    unsigned char ACKB:1;              /*   ACKB       */
                    } BIT;                             /*              */
             } ICSR;                                   /*              */
       unsigned char wk0[4];                           /*              */
       unsigned char ICDR;                             /* ICDR         */
       union {                                         /* ICMR         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char MLS:1;               /*   MLS        */
                    unsigned char WAIT:1;              /*   WAIT       */
                    unsigned char CKS:3;               /*   CKS        */
                    unsigned char BC:3;                /*   BC         */
                    } BIT;                             /*              */
             } ICMR;                                   /*              */
};                                                     /*              */
struct st_iic1 {                                       /* struct IIC1  */
       union {                                         /* ICCR         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char ICE:1;               /*   ICE        */
                    unsigned char IEIC:1;              /*   IEIC       */
                    unsigned char MST:1;               /*   MST        */
                    unsigned char TRS:1;               /*   TRS        */
                    unsigned char ACKE:1;              /*   ACKE       */
                    unsigned char BBSY:1;              /*   BBSY       */
                    unsigned char IRIC:1;              /*   IRIC       */
                    unsigned char SCP:1;               /*   SCP        */
                    } BIT;                             /*              */
             } ICCR;                                   /*              */
       union {                                         /* ICSR         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char ESTP:1;              /*   ESTP       */
                    unsigned char STOP:1;              /*   STOP       */
                    unsigned char IRTR:1;              /*   IRTR       */
                    unsigned char AASX:1;              /*   AASX       */
                    unsigned char AL:1;                /*   AL         */
                    unsigned char AAS:1;               /*   AAS        */
                    unsigned char ADZ:1;               /*   ADZ        */
                    unsigned char ACKB:1;              /*   ACKB       */
                    } BIT;                             /*              */
             } ICSR;                                   /*              */
       unsigned char wk0[4];                           /*              */
       unsigned char ICDR;                             /* ICDR         */
       union {                                         /* ICMR         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char MLS:1;               /*   MLS        */
                    unsigned char WAIT:1;              /*   WAIT       */
                    unsigned char CKS:3;               /*   CKS        */
                    unsigned char BC:3;                /*   BC         */
                    } BIT;                             /*              */
             } ICMR;                                   /*              */
};                                                     /*              */
struct st_iic2 {                                       /* struct IIC2  */
       union {                                         /* ICCR         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char ICE:1;               /*   ICE        */
                    unsigned char IEIC:1;              /*   IEIC       */
                    unsigned char MST:1;               /*   MST        */
                    unsigned char TRS:1;               /*   TRS        */
                    unsigned char ACKE:1;              /*   ACKE       */
                    unsigned char BBSY:1;              /*   BBSY       */
                    unsigned char IRIC:1;              /*   IRIC       */
                    unsigned char SCP:1;               /*   SCP        */
                    } BIT;                             /*              */
             } ICCR;                                   /*              */
       union {                                         /* ICSR         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char ESTP:1;              /*   ESTP       */
                    unsigned char STOP:1;              /*   STOP       */
                    unsigned char IRTR:1;              /*   IRTR       */
                    unsigned char AASX:1;              /*   AASX       */
                    unsigned char AL:1;                /*   AL         */
                    unsigned char AAS:1;               /*   AAS        */
                    unsigned char ADZ:1;               /*   ADZ        */
                    unsigned char ACKB:1;              /*   ACKB       */
                    } BIT;                             /*              */
             } ICSR;                                   /*              */
       unsigned char ICDR;                             /* ICDR         */
       union {                                         /* ICMR         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char MLS:1;               /*   MLS        */
                    unsigned char WAIT:1;              /*   WAIT       */
                    unsigned char CKS:3;               /*   CKS        */
                    unsigned char BC:3;                /*   BC         */
                    } BIT;                             /*              */
             } ICMR;                                   /*              */
};                                                     /*              */
struct st_iic3 {                                       /* struct IIC3  */
       union {                                         /* ICCR         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char ICE:1;               /*   ICE        */
                    unsigned char IEIC:1;              /*   IEIC       */
                    unsigned char MST:1;               /*   MST        */
                    unsigned char TRS:1;               /*   TRS        */
                    unsigned char ACKE:1;              /*   ACKE       */
                    unsigned char BBSY:1;              /*   BBSY       */
                    unsigned char IRIC:1;              /*   IRIC       */
                    unsigned char SCP:1;               /*   SCP        */
                    } BIT;                             /*              */
             } ICCR;                                   /*              */
       union {                                         /* ICSR         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char ESTP:1;              /*   ESTP       */
                    unsigned char STOP:1;              /*   STOP       */
                    unsigned char IRTR:1;              /*   IRTR       */
                    unsigned char AASX:1;              /*   AASX       */
                    unsigned char AL:1;                /*   AL         */
                    unsigned char AAS:1;               /*   AAS        */
                    unsigned char ADZ:1;               /*   ADZ        */
                    unsigned char ACKB:1;              /*   ACKB       */
                    } BIT;                             /*              */
             } ICSR;                                   /*              */
       union {                                         /* ICDR         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char MLS:1;               /*   MLS        */
                    unsigned char WAIT:1;              /*   WAIT       */
                    unsigned char CKS:3;               /*   CKS        */
                    unsigned char BC:3;                /*   BC         */
                    } BIT;                             /*              */
             } ICDR;                                   /*              */
       union {                                         /* ICMR         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char SVA:7;               /*   SVA        */
                    unsigned char FS:1;                /*   FS         */
                    } BIT;                             /*              */
             } ICMR;                                   /*              */
};                                                     /*              */
struct st_iic4 {                                       /* struct IIC4  */
       union {                                         /* ICCR         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char ICE:1;               /*   ICE        */
                    unsigned char IEIC:1;              /*   IEIC       */
                    unsigned char MST:1;               /*   MST        */
                    unsigned char TRS:1;               /*   TRS        */
                    unsigned char ACKE:1;              /*   ACKE       */
                    unsigned char BBSY:1;              /*   BBSY       */
                    unsigned char IRIC:1;              /*   IRIC       */
                    unsigned char SCP:1;               /*   SCP        */
                    } BIT;                             /*              */
             } ICCR;                                   /*              */
       union {                                         /* ICSR         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char ESTP:1;              /*   ESTP       */
                    unsigned char STOP:1;              /*   STOP       */
                    unsigned char IRTR:1;              /*   IRTR       */
                    unsigned char AASX:1;              /*   AASX       */
                    unsigned char AL:1;                /*   AL         */
                    unsigned char AAS:1;               /*   AAS        */
                    unsigned char ADZ:1;               /*   ADZ        */
                    unsigned char ACKB:1;              /*   ACKB       */
                    } BIT;                             /*              */
             } ICSR;                                   /*              */
       unsigned char ICDR;                             /* ICDR         */
       union {                                         /* ICMR         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char MLS:1;               /*   MLS        */
                    unsigned char WAIT:1;              /*   WAIT       */
                    unsigned char CKS:3;               /*   CKS        */
                    unsigned char BC:3;                /*   BC         */
                    } BIT;                             /*              */
             } ICMR;                                   /*              */
};                                                     /*              */
struct st_iic5 {                                       /* struct IIC5  */
       union {                                         /* ICCR         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char ICE:1;               /*   ICE        */
                    unsigned char IEIC:1;              /*   IEIC       */
                    unsigned char MST:1;               /*   MST        */
                    unsigned char TRS:1;               /*   TRS        */
                    unsigned char ACKE:1;              /*   ACKE       */
                    unsigned char BBSY:1;              /*   BBSY       */
                    unsigned char IRIC:1;              /*   IRIC       */
                    unsigned char SCP:1;               /*   SCP        */
                    } BIT;                             /*              */
             } ICCR;                                   /*              */
       union {                                         /* ICSR         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char ESTP:1;              /*   ESTP       */
                    unsigned char STOP:1;              /*   STOP       */
                    unsigned char IRTR:1;              /*   IRTR       */
                    unsigned char AASX:1;              /*   AASX       */
                    unsigned char AL:1;                /*   AL         */
                    unsigned char AAS:1;               /*   AAS        */
                    unsigned char ADZ:1;               /*   ADZ        */
                    unsigned char ACKB:1;              /*   ACKB       */
                    } BIT;                             /*              */
             } ICSR;                                   /*              */
       unsigned char ICDR;                             /* ICDR         */
       union {                                         /* ICMR         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char MLS:1;               /*   MLS        */
                    unsigned char WAIT:1;              /*   WAIT       */
                    unsigned char CKS:3;               /*   CKS        */
                    unsigned char BC:3;                /*   BC         */
                    } BIT;                             /*              */
             } ICMR;                                   /*              */
};                                                     /*              */
struct st_iics {                                       /* struct IIC   */
       union {                                         /* SARX         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char SVAX:7;              /*   SVAX       */
                    unsigned char FSX:1;               /*   FSX        */
                    } BIT;                             /*              */
             } SARX;                                   /*              */
       union {                                         /* SAR          */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char SVA:7;               /*   SVA        */
                    unsigned char FS:1;                /*   FS         */
                    } BIT;                             /*              */
             } SAR;                                    /*              */
};                                                     /*              */
struct st_wdt {                                        /* struct WDT   */
             struct {                                  /* Read Access  */ 
			        union {                            /* TCSR         */
                        unsigned char BYTE;            /*  Byte Access */
                        struct {                       /*  Bit Access  */
                                unsigned char OVF:1;   /*   OVF        */
                                unsigned char WTIT:1;  /*   WTIT       */
                                unsigned char TME:1;   /*   TME        */
                                unsigned char :1;      /*              */
                                unsigned char RSTNMI:1;/*   RSTNMI     */
                                unsigned char CKS:3;   /*   CKS        */
								} BIT;                 /*              */
						} TCSR;                        /*              */
                    unsigned char TCNT;                /* TCNT         */
					} READ;                            /*              */
			 union {                                   /* Write Access */
                   unsigned int TCSR;                  /* TCSR         */
                   unsigned int TCNT;                  /* TCNT         */
             } WRITE;                                  /*              */
};                                                     /*              */
struct st_tmr0 {                                       /* struct TMR0  */
       union {                                         /* TCR          */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char CMIEB:1;             /*   CMIEB      */
                    unsigned char CMIEA:1;             /*   CMIEA      */
                    unsigned char OVIE:1;              /*   OVIE       */
                    unsigned char :2;                  /*              */
                    unsigned char CKS:3;               /*   CKS        */
                    } BIT;                             /*              */
             } TCR;                                    /*              */
       unsigned char wk0[1];                           /*              */
       union {                                         /* TCSR         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char CMFB:1;              /*   CMFB       */
                    unsigned char CMFA:1;              /*   CMFA       */
                    unsigned char OVF:1;               /*   OVF        */
                    unsigned char :5;                  /*              */
                    } BIT;                             /*              */
             } TCSR;                                   /*              */
       unsigned char wk1[1];                           /*              */
       unsigned char TCORA;                            /* TCORA        */
       unsigned char wk2[1];                           /*              */
       unsigned char TCORB;                            /* TCORB        */
       unsigned char wk3[1];                           /*              */
       unsigned char TCNT;                             /* TCNT         */
};                                                     /*              */
struct st_tmr1 {                                       /* struct TMR1  */
       union {                                         /* TCR          */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char CMIEB:1;             /*   CMIEB      */
                    unsigned char CMIEA:1;             /*   CMIEA      */
                    unsigned char OVIE:1;              /*   OVIE       */
                    unsigned char :2;                  /*              */
                    unsigned char CKS:3;               /*   CKS        */
                    } BIT;                             /*              */
             } TCR;                                    /*              */
       unsigned char wk0[1];                           /*              */
       union {                                         /* TCSR         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char CMFB:1;              /*   CMFB       */
                    unsigned char CMFA:1;              /*   CMFA       */
                    unsigned char OVF:1;               /*   OVF        */
                    unsigned char :5;                  /*              */
                    } BIT;                             /*              */
             } TCSR;                                   /*              */
       unsigned char wk1[1];                           /*              */
       unsigned char TCORA;                            /* TCORA        */
       unsigned char wk2[1];                           /*              */
       unsigned char TCORB;                            /* TCORB        */
       unsigned char wk3[1];                           /*              */
       unsigned char TCNT;                             /* TCNT         */
};                                                     /*              */
struct st_tmrx {                                       /* struct TMRX  */
       union {                                         /* TCR          */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char CMIEB:1;             /*   CMIEB      */
                    unsigned char CMIEA:1;             /*   CMIEA      */
                    unsigned char OVIE:1;              /*   OVIE       */
                    unsigned char :2;                  /*              */
                    unsigned char CKS:3;               /*   CKS        */
                    } BIT;                             /*              */
             } TCR;                                    /*              */
       union {                                         /* TCSR         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char CMFB:1;              /*   CMFB       */
                    unsigned char CMFA:1;              /*   CMFA       */
                    unsigned char OVF:1;               /*   OVF        */
                    unsigned char :5;                  /*              */
                    } BIT;                             /*              */
             } TCSR;                                   /*              */
       unsigned char wk1[2];                           /*              */
       unsigned char TCNT;                             /* TCNT         */
       unsigned char wk2[1];                           /*              */
       unsigned char TCORA;                            /* TCORA        */
       unsigned char TCORB;                            /* TCORB        */
};                                                     /*              */
struct st_tmry {                                       /* struct TMRY  */
       union {                                         /* TCR          */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char CMIEB:1;             /*   CMIEB      */
                    unsigned char CMIEA:1;             /*   CMIEA      */
                    unsigned char OVIE:1;              /*   OVIE       */
                    unsigned char :2;                  /*              */
                    unsigned char CKS:3;               /*   CKS        */
                    } BIT;                             /*              */
             } TCR;                                    /*              */
       union {                                         /* TCSR         */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char CMFB:1;              /*   CMFB       */
                    unsigned char CMFA:1;              /*   CMFA       */
                    unsigned char OVF:1;               /*   OVF        */
                    unsigned char :5;                  /*              */
                    } BIT;                             /*              */
             } TCSR;                                   /*              */
       unsigned char TCORA;                            /* TCORA        */
       unsigned char TCORB;                            /* TCORB        */
       unsigned char TCNT;                             /* TCNT         */
       unsigned char wk1[1];                           /*              */
};                                                     /*              */
struct st_tmr {                                        /* struct TMR   */
       union {                                         /* TCONRS       */
             unsigned char BYTE;                       /*  Byte Access */
             struct {                                  /*  Bit Access  */
                    unsigned char TMRXY:1;             /*   TMRXY      */
                    unsigned char :7;                  /*              */
                    } BIT;                             /*              */
             } TCONRS;                                 /*              */
};                                                     /*              */
//#define ETHER (*(volatile struct st_ether *)0xFFF900)    /* ETHER Address */
//#define MAC0 (*(volatile struct st_ether *)0xFFF900)    /* ETHER Address */
#define MAC0 (*(volatile struct st_ether __evenaccess *)0xFFF900)    /* ETHER Address */
//#define EDMAC (*(volatile struct st_edmac *)0xFFF980)    /* EDMAC Address */
//#define EDMAC0 (*(volatile struct st_edmac *)0xFFF980)    /* EDMAC Address */
#define EDMAC0 (*(volatile struct st_edmac __evenaccess *)0xFFF980)    /* EDMAC Address */
#define USB (*(volatile struct st_usb *)0xFFFA00)        /* USB Address  */
#define PECI (*(volatile struct st_peci *)0xFFFC40)      /* PECI Address */
#define SCIF (*(volatile struct st_scif *)0xFFFC80)      /* SCIF Address */
#define SSU (*(volatile struct st_ssu *)0xFFFCC0)        /* SSU Address  */
#define LPC (*(volatile struct st_lpc *)0xFFFD00)        /* LPC Address  */
#define SYSTEM (*(volatile struct st_system *)0xFFFE3C)  /* SYSTEM Address */
#define EVC (*(volatile struct st_evc *)0xFFFE40)        /* EVC Address  */
#define FLASH (*(volatile struct st_flash *)0xFFFE88)    /* FLASH Address */
#define SCI1 (*(volatile struct st_sci1 *)0xFFFE98)      /* SCI1 Address */
#define SCI3 (*(volatile struct st_sci3 *)0xFFFFE0)      /* SCI3 Address */
#define ADC (*(volatile struct st_adc *)0xFFFEA0)        /* ADC Address  */
#define SMX (*(volatile struct st_smx *)0xFFFEB8)        /* SMX Address  */
#define PWMX0 (*(volatile struct st_pwmx0 *)0xFFFFA0)    /* PWMX0 Address */
#define PWMX1 (*(volatile struct st_pwmx1 *)0xFFFECC)    /* PWMX1 Address */
#define CRC (*(volatile struct st_crc *)0xFFFED4)        /* CRC Address  */
#define INT (*(volatile struct st_int *)0xFFFEE7)        /* INT Address  */
#define DTC (*(volatile struct st_dtc *)0xFFFEE6)        /* DTC Address  */
#define BSC (*(volatile struct st_bsc *)0xFFFF80)        /* BSC Address  */
#define FRT (*(volatile struct st_frt *)0xFFFF90)        /* FRT Address  */
#define PORT (*(volatile struct st_port *)0xFFFE46)      /* PORT Address */
#define PA (*(volatile struct st_pa *)0xFFFFAA)          /* PA Address   */
#define PB (*(volatile struct st_pb *)0xFFFFBC)          /* PB Address   */
#define PC (*(volatile struct st_pc *)0xFFFE4C)          /* PC Address   */
#define PD (*(volatile struct st_pd *)0xFFFE4D)          /* PD Address   */
#define PE (*(volatile struct st_pe *)0xFFFE48)          /* PE Address   */
#define PF (*(volatile struct st_pf *)0xFFFE49)          /* PF Address   */
#define P1 (*(volatile struct st_p1 *)0xFFFFAC)          /* P1 Address   */
#define P2 (*(volatile struct st_p2 *)0xFFFFAD)          /* P2 Address   */
#define P3 (*(volatile struct st_p3 *)0xFFFE44)          /* P3 Address   */
#define P4 (*(volatile struct st_p4 *)0xFFFEBA)          /* P4 Address   */
#define P5 (*(volatile struct st_p5 *)0xFFFFB8)          /* P5 Address   */
#define P6 (*(volatile struct st_p6 *)0xFFFEBC)          /* P6 Address   */
#define P8 (*(volatile struct st_p8 *)0xFFFFBD)          /* P8 Address   */
#define P9 (*(volatile struct st_p9 *)0xFFFFC0)          /* P9 Address   */
#define IIC (*(volatile struct st_iic *)0xFFFED8)        /* IIC Address  */
#define IIC0 (*(volatile struct st_iic0 *)0xFFFFD8)      /* IIC0 Address */
#define IIC1 (*(volatile struct st_iic1 *)0xFFFF88)      /* IIC1 Address */
#define IIC2 (*(volatile struct st_iic2 *)0xFFFEC8)      /* IIC2 Address */
#define IIC3 (*(volatile struct st_iic3 *)0xFFFEC0)      /* IIC3 Address */
#define IIC4 (*(volatile struct st_iic4 *)0xFFFE90)      /* IIC4 Address */
#define IIC5 (*(volatile struct st_iic5 *)0xFFFE94)      /* IIC5 Address */
#define IIC0S (*(volatile struct st_iics *)0xFFFFDE)    /* IIC0S Address */
#define IIC1S (*(volatile struct st_iics *)0xFFFF8E)    /* IIC1S Address */
#define IIC2S (*(volatile struct st_iics *)0xFFFECA)    /* IIC2S Address */
#define IIC3S (*(volatile struct st_iics *)0xFFFEC2)    /* IIC3S Address */
#define IIC4S (*(volatile struct st_iics *)0xFFFE92)    /* IIC4S Address */
#define IIC5S (*(volatile struct st_iics *)0xFFFE96)    /* IIC5S Address */
#define WDT0 (*(volatile struct st_wdt *)0xFFFFA8)       /* WDT0 Address */
#define WDT1 (*(volatile struct st_wdt *)0xFFFFEA)       /* WDT1 Address */
#define TMR0 (*(volatile struct st_tmr0 *)0xFFFFC8)      /* TMR0 Address */
#define TMR1 (*(volatile struct st_tmr1 *)0xFFFFC9)      /* TMR1 Address */
#define TMRX (*(volatile struct st_tmrx *)0xFFFFF0)      /* TMRX Address */
#define TMRY (*(volatile struct st_tmry *)0xFFFFF0)      /* TMRY Address */
#define TMR (*(volatile struct st_tmr *)0xFFFFFE)        /* TMR Address  */

