/***********************************************************************/
/*                                                                     */
/*  FILE        :iodefine.h                                            */
/*  DATE        :Tue, Sep 30, 2008                                     */
/*  DESCRIPTION :Definition of I/O Register                            */
/*  CPU TYPE    :H8S/2676F                                             */
/*                                                                     */
/*  This file is generated by Renesas Project Generator (Ver.4.9).     */
/*                                                                     */
/***********************************************************************/
                  



/************************************************************************/
/*      H8S/2678 Series Include File                       Ver 2.2      */
/************************************************************************/
struct st_exdmac {                                      /* struct EXDMAC*/
                 void          *EDSAR;                  /* EDSAR        */
                 void          *EDDAR;                  /* EDDAR        */
                 unsigned long  EDTCR;                  /* EDTCR        */
                 union {                                /* EDMDR        */
                       unsigned int WORD;               /*  Word Access */
                       struct {                         /*  Byte Access */
                              unsigned char EDA   :1;   /*    EDA       */
                              unsigned char BEF   :1;   /*    BEF       */
                              unsigned char EDRAKE:1;   /*    EDRAKE    */
                              unsigned char ETENDE:1;   /*    ETENDE    */
                              unsigned char EDREQS:1;   /*    EDREQS    */
                              unsigned char AMS   :1;   /*    AMS       */
                              unsigned char MDS   :2;   /*    MDS       */
                              unsigned char EDIE  :1;   /*    EDIE      */
                              unsigned char IRF   :1;   /*    IRF       */
                              unsigned char TCEIE :1;   /*    TCEIE     */
                              unsigned char SDIR  :1;   /*    SDIR      */
                              unsigned char DTSIZE:1;   /*    DTSIZE    */
                              unsigned char BGUP  :1;   /*    BGUP      */
                              }     BIT;                /*              */
                       }        EDMDR;                  /*              */
                 union {                                /* EDACR        */
                       unsigned int WORD;               /*  Word Access */
                       struct {                         /*  Byte Access */
                              unsigned char SAT  :2;    /*    SAT       */
                              unsigned char SARIE:1;    /*    SARIE     */
                              unsigned char SARA :5;    /*    SARA      */
                              unsigned char DAT  :2;    /*    DAT       */
                              unsigned char DARIE:1;    /*    DARIE     */
                              unsigned char DARA :5;    /*    DARA      */
                              }     BIT;                /*              */
                       }        EDACR;                  /*              */
};                                                      /*              */
struct st_tpu {                                         /* struct TPU   */
              union {                                   /* TSTR         */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char     :2;        /*              */
                           unsigned char CST5:1;        /*    CST5      */
                           unsigned char CST4:1;        /*    CST4      */
                           unsigned char CST3:1;        /*    CST3      */
                           unsigned char CST2:1;        /*    CST2      */
                           unsigned char CST1:1;        /*    CST1      */
                           unsigned char CST0:1;        /*    CST0      */
                           }      BIT;                  /*              */
                    }           TSTR;                   /*              */
              union {                                   /* TSYR         */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char      :2;       /*              */
                           unsigned char SYNC5:1;       /*    SYNC5     */
                           unsigned char SYNC4:1;       /*    SYNC4     */
                           unsigned char SYNC3:1;       /*    SYNC3     */
                           unsigned char SYNC2:1;       /*    SYNC2     */
                           unsigned char SYNC1:1;       /*    SYNC1     */
                           unsigned char SYNC0:1;       /*    SYNC0     */
                           }      BIT;                  /*              */
                    }           TSYR;                   /*              */
};                                                      /*              */
struct st_tpu0 {                                        /* struct TPU0  */
               union {                                  /* TCR          */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char CCLR:3;       /*    CCLR      */
                            unsigned char CKEG:2;       /*    CKEG      */
                            unsigned char TPSC:3;       /*    TPSC      */
                            }      BIT;                 /*              */
                     }          TCR;                    /*              */
               union {                                  /* TMDR         */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char    :2;        /*              */
                            unsigned char BFB:1;        /*    BFB       */
                            unsigned char BFA:1;        /*    BFA       */
                            unsigned char MD :4;        /*    MD        */
                            }      BIT;                 /*              */
                     }          TMDR;                   /*              */
               union {                                  /* TIOR         */
                     unsigned int WORD;                 /*  Word Access */
                     struct {                           /*  Byte Access */
                            unsigned char H;            /*    TIORH     */
                            unsigned char L;            /*    TIORL     */
                            }     BYTE;                 /*              */
                     struct {                           /*  Bit  Access */
                            unsigned char IOB:4;        /*    IOB       */
                            unsigned char IOA:4;        /*    IOA       */
                            unsigned char IOD:4;        /*    IOD       */
                            unsigned char IOC:4;        /*    IOC       */
                            }     BIT;                  /*              */
                     }          TIOR;                   /*              */
               union {                                  /* TIER         */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char TTGE :1;      /*    TTGE      */
                            unsigned char      :2;      /*              */
                            unsigned char TCIEV:1;      /*    TCIEV     */
                            unsigned char TGIED:1;      /*    TGIED     */
                            unsigned char TGIEC:1;      /*    TGIEC     */
                            unsigned char TGIEB:1;      /*    TGIEB     */
                            unsigned char TGIEA:1;      /*    TGIEA     */
                            }      BIT;                 /*              */
                     }          TIER;                   /*              */
               union {                                  /* TSR          */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char     :3;       /*              */
                            unsigned char TCFV:1;       /*    TCFV      */
                            unsigned char TGFD:1;       /*    TGFD      */
                            unsigned char TGFC:1;       /*    TGFC      */
                            unsigned char TGFB:1;       /*    TGFB      */
                            unsigned char TGFA:1;       /*    TGFA      */
                            }      BIT;                 /*              */
                     }          TSR;                    /*              */
               unsigned int     TCNT;                   /* TCNT         */
               unsigned int     TGRA;                   /* TGRA         */
               unsigned int     TGRB;                   /* TGRB         */
               unsigned int     TGRC;                   /* TGRC         */
               unsigned int     TGRD;                   /* TGRD         */
};                                                      /*              */
struct st_tpu1 {                                        /* struct TPU1  */
               union {                                  /* TCR          */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char     :1;       /*              */
                            unsigned char CCLR:2;       /*    CCLR      */
                            unsigned char CKEG:2;       /*    CKEG      */
                            unsigned char TPSC:3;       /*    TPSC      */
                            }      BIT;                 /*              */
                     }          TCR;                    /*              */
               union {                                  /* TMDR         */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char   :4;         /*              */
                            unsigned char MD:4;         /*    MD        */
                            }      BIT;                 /*              */
                     }          TMDR;                   /*              */
               union {                                  /* TIOR         */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char IOB:4;        /*    IOB       */
                            unsigned char IOA:4;        /*    IOA       */
                            }      BIT;                 /*              */
                     }          TIOR;                   /*              */
               char             wk;                     /*              */
               union {                                  /* TIER         */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char TTGE :1;      /*    TTGE      */
                            unsigned char      :1;      /*              */
                            unsigned char TCIEU:1;      /*    TCIEU     */
                            unsigned char TCIEV:1;      /*    TCIEV     */
                            unsigned char      :2;      /*              */
                            unsigned char TGIEB:1;      /*    TGIEB     */
                            unsigned char TGIEA:1;      /*    TGIEA     */
                            }      BIT;                 /*              */
                     }          TIER;                   /*              */
               union {                                  /* TSR          */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char TCFD:1;       /*    TCFD      */
                            unsigned char     :1;       /*              */
                            unsigned char TCFU:1;       /*    TCFU      */
                            unsigned char TCFV:1;       /*    TCFV      */
                            unsigned char     :2;       /*              */
                            unsigned char TGFB:1;       /*    TGFB      */
                            unsigned char TGFA:1;       /*    TGFA      */
                            }      BIT;                 /*              */
                     }          TSR;                    /*              */
               unsigned int     TCNT;                   /* TCNT         */
               unsigned int     TGRA;                   /* TGRA         */
               unsigned int     TGRB;                   /* TGRB         */
};                                                      /*              */
struct st_p1 {                                          /* struct P1    */
             unsigned char      DDR;                    /* P1DDR        */
             char               wk1[303];               /*              */
             union {                                    /* P1PORT       */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PORT;                   /*              */
             char               wk2[15];                /*              */
             union {                                    /* P1DR         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            DR;                     /*              */
};                                                      /*              */
struct st_p2 {                                          /* struct P2    */
             unsigned char      DDR;                    /* P2DDR        */
             char               wk1[303];               /*              */
             union {                                    /* P2PORT       */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PORT;                   /*              */
             char               wk2[15];                /*              */
             union {                                    /* P2DR         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            DR;                     /*              */
};                                                      /*              */
struct st_p3 {                                          /* struct P3    */
             unsigned char      DDR;                    /* P3DDR        */
             char               wk1[25];                /*              */
             union {                                    /* P3ODR        */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char   :2;           /*    Bit 7,6   */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            ODR;                    /*              */
             char               wk2[277];               /*              */
             union {                                    /* P3PORT       */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char   :2;           /*    Bit 7,6   */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PORT;                   /*              */
             char               wk3[15];                /*              */
             union {                                    /* P3DR         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char   :2;           /*    Bit 7,6   */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            DR;                     /*              */
};                                                      /*              */
struct st_p4 {                                          /* struct P4    */
             union {                                    /* P4PORT       */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PORT;                   /*              */
};                                                      /*              */
struct st_p5 {                                          /* struct P5    */
             unsigned char      DDR;                    /* P5DDR        */
             char               wk1[303];               /*              */
             union {                                    /* P5PORT       */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PORT;                   /*              */
             char               wk2[15];                /*              */
             union {                                    /* P5DR         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char   :4;           /*    Bit 7-4   */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            DR;                     /*              */
};                                                      /*              */
struct st_p6 {                                          /* struct P6    */
             unsigned char      DDR;                    /* P6DDR        */
             char               wk1[303];               /*              */
             union {                                    /* P6PORT       */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char   :2;           /*    Bit 7,6   */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PORT;                   /*              */
             char               wk2[15];                /*              */
             union {                                    /* P6DR         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char   :2;           /*    Bit 7,6   */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            DR;                     /*              */
};                                                      /*              */
struct st_p7 {                                          /* struct P7    */
             unsigned char      DDR;                    /* P7DDR        */
             char               wk1[303];               /*              */
             union {                                    /* P7PORT       */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char   :2;           /*    Bit 7,6   */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PORT;                   /*              */
             char               wk2[15];                /*              */
             union {                                    /* P7DR         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char   :2;           /*    Bit 7,6   */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            DR;                     /*              */
};                                                      /*              */
struct st_p8 {                                          /* struct P8    */
             unsigned char      DDR;                    /* P8DDR        */
             char               wk1[303];               /*              */
             union {                                    /* P8PORT       */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char   :2;           /*    Bit 7,6   */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PORT;                   /*              */
             char               wk2[15];                /*              */
             union {                                    /* P8DR         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char   :2;           /*    Bit 7,6   */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            DR;                     /*              */
};                                                      /*              */
struct st_pa {                                          /* struct PA    */
             unsigned char      DDR;                    /* PADDR        */
             char               wk1[12];                /*              */
             union {                                    /* PAPCR        */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PCR;                    /*              */
             char               wk2[6];                 /*              */
             union {                                    /* PAODR        */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            ODR;                    /*              */
             char               wk3[283];               /*              */
             union {                                    /* PAPORT       */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PORT;                   /*              */
             char               wk4[15];                /*              */
             union {                                    /* PADR         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            DR;                     /*              */
};                                                      /*              */
struct st_pb {                                          /* struct PB    */
             unsigned char      DDR;                    /* PBDDR        */
             char               wk1[12];                /*              */
             union {                                    /* PBPCR        */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PCR;                    /*              */
             char               wk2[290];               /*              */
             union {                                    /* PBPORT       */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PORT;                   /*              */
             char               wk3[15];                /*              */
             union {                                    /* PBDR         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            DR;                     /*              */
};                                                      /*              */
struct st_pc {                                          /* struct PC    */
             unsigned char      DDR;                    /* PCDDR        */
             char               wk1[12];                /*              */
             union {                                    /* PCPCR        */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PCR;                    /*              */
             char               wk2[290];               /*              */
             union {                                    /* PCPORT       */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PORT;                   /*              */
             char               wk3[15];                /*              */
             union {                                    /* PCDR         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            DR;                     /*              */
};                                                      /*              */
struct st_pd {                                          /* struct PD    */
             unsigned char      DDR;                    /* PDDDR        */
             char               wk1[12];                /*              */
             union {                                    /* PDPCR        */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PCR;                    /*              */
             char               wk2[290];               /*              */
             union {                                    /* PDPORT       */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PORT;                   /*              */
             char               wk3[15];                /*              */
             union {                                    /* PDDR         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            DR;                     /*              */
};                                                      /*              */
struct st_pe {                                          /* struct PE    */
             unsigned char      DDR;                    /* PEDDR        */
             char               wk1[12];                /*              */
             union {                                    /* PEPCR        */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PCR;                    /*              */
             char               wk2[290];               /*              */
             union {                                    /* PEPORT       */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PORT;                   /*              */
             char               wk3[15];                /*              */
             union {                                    /* PEDR         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            DR;                     /*              */
};                                                      /*              */
struct st_pf {                                          /* struct PF    */
             unsigned char      DDR;                    /* PFDDR        */
             char               wk1[303];               /*              */
             union {                                    /* PFPORT       */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PORT;                   /*              */
             char               wk2[15];                /*              */
             union {                                    /* PFDR         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            DR;                     /*              */
};                                                      /*              */
struct st_pg {                                          /* struct PG    */
             unsigned char      DDR;                    /* PGDDR        */
             char               wk1[303];               /*              */
             union {                                    /* PGPORT       */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char   :1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PORT;                   /*              */
             char               wk2[15];                /*              */
             union {                                    /* PGDR         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char   :1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            DR;                     /*              */
};                                                      /*              */
struct st_intc {                                        /* struct INTC  */
               union {                                  /* IPRA         */
                     unsigned int WORD;                 /*  Word Access */
                     struct {                           /*  Bit  Access */
                            unsigned char      :1;      /*              */
                            unsigned char _IRQ0:3;      /*    IRQ0      */
                            unsigned char      :1;      /*              */
                            unsigned char _IRQ1:3;      /*    IRQ1      */
                            unsigned char      :1;      /*              */
                            unsigned char _IRQ2:3;      /*    IRQ2      */
                            unsigned char      :1;      /*              */
                            unsigned char _IRQ3:3;      /*    IRQ3      */
                            }     BIT;                  /*              */
                     }          IPRA;                   /*              */
               union {                                  /* IPRB         */
                     unsigned int WORD;                 /*  Word Access */
                     struct {                           /*  Bit  Access */
                            unsigned char      :1;      /*              */
                            unsigned char _IRQ4:3;      /*    IRQ4      */
                            unsigned char      :1;      /*              */
                            unsigned char _IRQ5:3;      /*    IRQ5      */
                            unsigned char      :1;      /*              */
                            unsigned char _IRQ6:3;      /*    IRQ6      */
                            unsigned char      :1;      /*              */
                            unsigned char _IRQ7:3;      /*    IRQ7      */
                            }     BIT;                  /*              */
                     }          IPRB;                   /*              */
               union {                                  /* IPRC         */
                     unsigned int WORD;                 /*  Word Access */
                     struct {                           /*  Bit  Access */
                            unsigned char       :1;     /*              */
                            unsigned char _IRQ8 :3;     /*    IRQ8      */
                            unsigned char       :1;     /*              */
                            unsigned char _IRQ9 :3;     /*    IRQ9      */
                            unsigned char       :1;     /*              */
                            unsigned char _IRQ10:3;     /*    IRQ10     */
                            unsigned char       :1;     /*              */
                            unsigned char _IRQ11:3;     /*    IRQ11     */
                            }     BIT;                  /*              */
                     }          IPRC;                   /*              */
               union {                                  /* IPRD         */
                     unsigned int WORD;                 /*  Word Access */
                     struct {                           /*  Bit  Access */
                            unsigned char       :1;     /*              */
                            unsigned char _IRQ12:3;     /*    IRQ12     */
                            unsigned char       :1;     /*              */
                            unsigned char _IRQ13:3;     /*    IRQ13     */
                            unsigned char       :1;     /*              */
                            unsigned char _IRQ14:3;     /*    IRQ14     */
                            unsigned char       :1;     /*              */
                            unsigned char _IRQ15:3;     /*    IRQ15     */
                            }     BIT;                  /*              */
                     }          IPRD;                   /*              */
               union {                                  /* IPRE         */
                     unsigned int WORD;                 /*  Word Access */
                     struct {                           /*  Bit  Access */
                            unsigned char       :1;     /*              */
                            unsigned char _DTC  :3;     /*    DTC       */
                            unsigned char       :1;     /*              */
                            unsigned char _WDT  :3;     /*    WDT       */
                            unsigned char       :5;     /*              */
                            unsigned char _RFSHC:3;     /*    RFSHC     */
                            }     BIT;                  /*              */
                     }          IPRE;                   /*              */
               union {                                  /* IPRF         */
                     unsigned int WORD;                 /*  Word Access */
                     struct {                           /*  Bit  Access */
                            unsigned char      :5;      /*              */
                            unsigned char _AD  :3;      /*    A/D       */
                            unsigned char      :1;      /*              */
                            unsigned char _TPU0:3;      /*    TPU0      */
                            unsigned char      :1;      /*              */
                            unsigned char _TPU1:3;      /*    TPU1      */
                            }     BIT;                  /*              */
                     }          IPRF;                   /*              */
               union {                                  /* IPRG         */
                     unsigned int WORD;                 /*  Word Access */
                     struct {                           /*  Bit  Access */
                            unsigned char      :1;      /*              */
                            unsigned char _TPU2:3;      /*    TPU2      */
                            unsigned char      :1;      /*              */
                            unsigned char _TPU3:3;      /*    TPU3      */
                            unsigned char      :1;      /*              */
                            unsigned char _TPU4:3;      /*    TPU4      */
                            unsigned char      :1;      /*              */
                            unsigned char _TPU5:3;      /*    TPU5      */
                            }     BIT;                  /*              */
                     }          IPRG;                   /*              */
               union {                                  /* IPRH         */
                     unsigned int WORD;                 /*  Word Access */
                     struct {                           /*  Bit  Access */
                            unsigned char         :1;   /*              */
                            unsigned char _TMR0   :3;   /*    TMR0      */
                            unsigned char         :1;   /*              */
                            unsigned char _TMR1   :3;   /*    TMR1      */
                            unsigned char         :1;   /*              */
                            unsigned char _DMAC   :3;   /*    DMAC      */
                            unsigned char         :1;   /*              */
                            unsigned char _EXDMAC0:3;   /*    EXDMAC0   */
                            }     BIT;                  /*              */
                     }          IPRH;                   /*              */
               union {                                  /* IPRI         */
                     unsigned int WORD;                 /*  Word Access */
                     struct {                           /*  Bit  Access */
                            unsigned char         :1;   /*              */
                            unsigned char _EXDMAC1:3;   /*    EXDMAC1   */
                            unsigned char         :1;   /*              */
                            unsigned char _EXDMAC2:3;   /*    EXDMAC2   */
                            unsigned char         :1;   /*              */
                            unsigned char _EXDMAC3:3;   /*    EXDMAC3   */
                            unsigned char         :1;   /*              */
                            unsigned char _SCI0   :3;   /*    SCI0      */
                            }     BIT;                  /*              */
                     }          IPRI;                   /*              */
               union {                                  /* IPRJ         */
                     unsigned int WORD;                 /*  Word Access */
                     struct {                           /*  Bit  Access */
                            unsigned char      :1;      /*              */
                            unsigned char _SCI1:3;      /*    SCI1      */
                            unsigned char      :1;      /*              */
                            unsigned char _SCI2:3;      /*    SCI2      */
                            }     BIT;                  /*              */
                     }          IPRJ;                   /*              */
               char             wk1[2];                 /*              */
               union {                                  /* ITSR         */
                     unsigned int WORD;                 /*  Word Access */
                     struct {                           /*  Bit  Access */
                            unsigned char ITS15:1;      /*    ITS15     */
                            unsigned char ITS14:1;      /*    ITS14     */
                            unsigned char ITS13:1;      /*    ITS13     */
                            unsigned char ITS12:1;      /*    ITS12     */
                            unsigned char ITS11:1;      /*    ITS11     */
                            unsigned char ITS10:1;      /*    ITS10     */
                            unsigned char ITS9 :1;      /*    ITS9      */
                            unsigned char ITS8 :1;      /*    ITS8      */
                            unsigned char ITS7 :1;      /*    ITS7      */
                            unsigned char ITS6 :1;      /*    ITS6      */
                            unsigned char ITS5 :1;      /*    ITS5      */
                            unsigned char ITS4 :1;      /*    ITS4      */
                            unsigned char ITS3 :1;      /*    ITS3      */
                            unsigned char ITS2 :1;      /*    ITS2      */
                            unsigned char ITS1 :1;      /*    ITS1      */
                            unsigned char ITS0 :1;      /*    ITS0      */
                            }     BIT;                  /*              */
                     }          ITSR;                   /*              */
               union {                                  /* SSIER        */
                     unsigned int WORD;                 /*  Word Access */
                     struct {                           /*  Bit  Access */
                            unsigned char SSI15:1;      /*    SSI15     */
                            unsigned char SSI14:1;      /*    SSI14     */
                            unsigned char SSI13:1;      /*    SSI13     */
                            unsigned char SSI12:1;      /*    SSI12     */
                            unsigned char SSI11:1;      /*    SSI11     */
                            unsigned char SSI10:1;      /*    SSI10     */
                            unsigned char SSI9 :1;      /*    SSI9      */
                            unsigned char SSI8 :1;      /*    SSI8      */
                            unsigned char SSI7 :1;      /*    SSI7      */
                            unsigned char SSI6 :1;      /*    SSI6      */
                            unsigned char SSI5 :1;      /*    SSI5      */
                            unsigned char SSI4 :1;      /*    SSI4      */
                            unsigned char SSI3 :1;      /*    SSI3      */
                            unsigned char SSI2 :1;      /*    SSI2      */
                            unsigned char SSI1 :1;      /*    SSI1      */
                            unsigned char SSI0 :1;      /*    SSI0      */
                            }     BIT;                  /*              */
                     }          SSIER;                  /*              */
               union {                                  /* ISCR         */
                     unsigned long LONG;                /*  Long Access */
                     struct {                           /*  Word Access */
                            unsigned int H;             /*    ISCRH     */
                            unsigned int L;             /*    ISCRL     */
                            }      WORD;                /*              */
                     struct {                           /*  Bit  Access */
                            unsigned char IRQ15SC:2;    /*    IRQ15SC   */
                            unsigned char IRQ14SC:2;    /*    IRQ14SC   */
                            unsigned char IRQ13SC:2;    /*    IRQ13SC   */
                            unsigned char IRQ12SC:2;    /*    IRQ12SC   */
                            unsigned char IRQ11SC:2;    /*    IRQ11SC   */
                            unsigned char IRQ10SC:2;    /*    IRQ10SC   */
                            unsigned char IRQ9SC :2;    /*    IRQ9SC    */
                            unsigned char IRQ8SC :2;    /*    IRQ8SC    */
                            unsigned char IRQ7SC :2;    /*    IRQ7SC    */
                            unsigned char IRQ6SC :2;    /*    IRQ6SC    */
                            unsigned char IRQ5SC :2;    /*    IRQ5SC    */
                            unsigned char IRQ4SC :2;    /*    IRQ4SC    */
                            unsigned char IRQ3SC :2;    /*    IRQ3SC    */
                            unsigned char IRQ2SC :2;    /*    IRQ2SC    */
                            unsigned char IRQ1SC :2;    /*    IRQ1SC    */
                            unsigned char IRQ0SC :2;    /*    IRQ0SC    */
                            }      BIT;                 /*              */
                     }          ISCR;                   /*              */
               char             wk2[275];               /*              */
               union {                                  /* INTCR        */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char      :2;      /*              */
                            unsigned char INTM :2;      /*    INTM      */
                            unsigned char NMIEG:1;      /*    NMIEG     */
                            }      BIT;                 /*              */
                     }          INTCR;                  /*              */
               union {                                  /* IER          */
                     unsigned int WORD;                 /*  Word Access */
                     struct {                           /*  Bit  Access */
                            unsigned char IRQ15E:1;     /*    IRQ15E    */
                            unsigned char IRQ14E:1;     /*    IRQ14E    */
                            unsigned char IRQ13E:1;     /*    IRQ13E    */
                            unsigned char IRQ12E:1;     /*    IRQ12E    */
                            unsigned char IRQ11E:1;     /*    IRQ11E    */
                            unsigned char IRQ10E:1;     /*    IRQ10E    */
                            unsigned char IRQ9E :1;     /*    IRQ9E     */
                            unsigned char IRQ8E :1;     /*    IRQ8E     */
                            unsigned char IRQ7E :1;     /*    IRQ7E     */
                            unsigned char IRQ6E :1;     /*    IRQ6E     */
                            unsigned char IRQ5E :1;     /*    IRQ5E     */
                            unsigned char IRQ4E :1;     /*    IRQ4E     */
                            unsigned char IRQ3E :1;     /*    IRQ3E     */
                            unsigned char IRQ2E :1;     /*    IRQ2E     */
                            unsigned char IRQ1E :1;     /*    IRQ1E     */
                            unsigned char IRQ0E :1;     /*    IRQ0E     */
                            }     BIT;                  /*              */
                     }          IER;                    /*              */
               union {                                  /* ISR          */
                     unsigned int WORD;                 /*  Word Access */
                     struct {                           /*  Bit  Access */
                            unsigned char IRQ15F:1;     /*    IRQ15F    */
                            unsigned char IRQ14F:1;     /*    IRQ14F    */
                            unsigned char IRQ13F:1;     /*    IRQ13F    */
                            unsigned char IRQ12F:1;     /*    IRQ12F    */
                            unsigned char IRQ11F:1;     /*    IRQ11F    */
                            unsigned char IRQ10F:1;     /*    IRQ10F    */
                            unsigned char IRQ9F :1;     /*    IRQ9F     */
                            unsigned char IRQ8F :1;     /*    IRQ8F     */
                            unsigned char IRQ7F :1;     /*    IRQ7F     */
                            unsigned char IRQ6F :1;     /*    IRQ6F     */
                            unsigned char IRQ5F :1;     /*    IRQ5F     */
                            unsigned char IRQ4F :1;     /*    IRQ4F     */
                            unsigned char IRQ3F :1;     /*    IRQ3F     */
                            unsigned char IRQ2F :1;     /*    IRQ2F     */
                            unsigned char IRQ1F :1;     /*    IRQ1F     */
                            unsigned char IRQ0F :1;     /*    IRQ0F     */
                            }     BIT;                  /*              */
                     }          ISR;                    /*              */
};                                                      /*              */
union un_ircr {                                         /* union IrCR   */
              unsigned char BYTE;                       /*  Byte Access */
              struct {                                  /*  Bit  Access */
                     unsigned char IrE  :1;             /*    IrE       */
                     unsigned char IrCKS:3;             /*    IrCKS     */
                     }      BIT;                        /*              */
};                                                      /*              */
struct st_bsc {                                         /* struct BSC   */
              union {                                   /* PFCR0        */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char CS7E:1;        /*    CS7E      */
                           unsigned char CS6E:1;        /*    CS6E      */
                           unsigned char CS5E:1;        /*    CS5E      */
                           unsigned char CS4E:1;        /*    CS4E      */
                           unsigned char CS3E:1;        /*    CS3E      */
                           unsigned char CS2E:1;        /*    CS2E      */
                           unsigned char CS1E:1;        /*    CS1E      */
                           unsigned char CS0E:1;        /*    CS0E      */
                           }      BIT;                  /*              */
                    }           PFCR0;                  /*              */
              union {                                   /* PFCR1        */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char A23E:1;        /*    A23E      */
                           unsigned char A22E:1;        /*    A22E      */
                           unsigned char A21E:1;        /*    A21E      */
                           unsigned char A20E:1;        /*    A20E      */
                           unsigned char A19E:1;        /*    A19E      */
                           unsigned char A18E:1;        /*    A18E      */
                           unsigned char A17E:1;        /*    A17E      */
                           unsigned char A16E:1;        /*    A16E      */
                           }      BIT;                  /*              */
                    }           PFCR1;                  /*              */
              union {                                   /* PFCR2        */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char      :4;       /*              */
                           unsigned char ASOE :1;       /*    ASOE      */
                           unsigned char LWROE:1;       /*    LWROE     */
                           unsigned char OES  :1;       /*    OES       */
                           unsigned char DMACS:1;       /*    DMACS     */
                           }      BIT;                  /*              */
                    }           PFCR2;                  /*              */
              char              wk1[139];               /*              */
              union {                                   /* ABWCR        */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char ABW7:1;        /*    ABW7      */
                           unsigned char ABW6:1;        /*    ABW6      */
                           unsigned char ABW5:1;        /*    ABW5      */
                           unsigned char ABW4:1;        /*    ABW4      */
                           unsigned char ABW3:1;        /*    ABW3      */
                           unsigned char ABW2:1;        /*    ABW2      */
                           unsigned char ABW1:1;        /*    ABW1      */
                           unsigned char ABW0:1;        /*    ABW0      */
                           }      BIT;                  /*              */
                    }           ABWCR;                  /*              */
              union {                                   /* ASTCR        */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char AST7:1;        /*    AST7      */
                           unsigned char AST6:1;        /*    AST6      */
                           unsigned char AST5:1;        /*    AST5      */
                           unsigned char AST4:1;        /*    AST4      */
                           unsigned char AST3:1;        /*    AST3      */
                           unsigned char AST2:1;        /*    AST2      */
                           unsigned char AST1:1;        /*    AST1      */
                           unsigned char AST0:1;        /*    AST0      */
                           }      BIT;                  /*              */
                    }           ASTCR;                  /*              */
              union {                                   /* WCR          */
                    unsigned long LONG;                 /*  Long Access */
                    struct {                            /*  Word Access */
                           unsigned int A;              /*    WCRA      */
                           unsigned int B;              /*    WCRB      */
                           }     WORD;                  /*              */
                    struct {                            /*  Bit  Access */
                           unsigned char   :1;          /*              */
                           unsigned char W7:3;          /*    W7        */
                           unsigned char   :1;          /*              */
                           unsigned char W6:3;          /*    W6        */
                           unsigned char   :1;          /*              */
                           unsigned char W5:3;          /*    W5        */
                           unsigned char   :1;          /*              */
                           unsigned char W4:3;          /*    W4        */
                           unsigned char   :1;          /*              */
                           unsigned char W3:3;          /*    W3        */
                           unsigned char   :1;          /*              */
                           unsigned char W2:3;          /*    W2        */
                           unsigned char   :1;          /*              */
                           unsigned char W1:3;          /*    W1        */
                           unsigned char   :1;          /*              */
                           unsigned char W0:3;          /*    W0        */
                           }      BIT;                  /*              */
                    }           WCR;                    /*              */
              union {                                   /* RDNCR        */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char RDN7:1;        /*    RDN7      */
                           unsigned char RDN6:1;        /*    RDN6      */
                           unsigned char RDN5:1;        /*    RDN5      */
                           unsigned char RDN4:1;        /*    RDN4      */
                           unsigned char RDN3:1;        /*    RDN3      */
                           unsigned char RDN2:1;        /*    RDN2      */
                           unsigned char RDN1:1;        /*    RDN1      */
                           unsigned char RDN0:1;        /*    RDN0      */
                           }      BIT;                  /*              */
                    }           RDNCR;                  /*              */
              char              wk2;                    /*              */
              union {                                   /* CSACR        */
                    unsigned int WORD;                  /*  Word Access */
                    struct {                            /*  Word Access */
                           unsigned char H;             /*    High      */
                           unsigned char L;             /*    Low       */
                           }     BYTE;                  /*              */
                    struct {                            /*  Bit  Access */
                           unsigned char CSXH7:1;       /*    CSXH7     */
                           unsigned char CSXH6:1;       /*    CSXH6     */
                           unsigned char CSXH5:1;       /*    CSXH5     */
                           unsigned char CSXH4:1;       /*    CSXH4     */
                           unsigned char CSXH3:1;       /*    CSXH3     */
                           unsigned char CSXH2:1;       /*    CSXH2     */
                           unsigned char CSXH1:1;       /*    CSXH1     */
                           unsigned char CSXH0:1;       /*    CSXH0     */
                           unsigned char CSXT7:1;       /*    CSXT7     */
                           unsigned char CSXT6:1;       /*    CSXT6     */
                           unsigned char CSXT5:1;       /*    CSXT5     */
                           unsigned char CSXT4:1;       /*    CSXT4     */
                           unsigned char CSXT3:1;       /*    CSXT3     */
                           unsigned char CSXT2:1;       /*    CSXT2     */
                           unsigned char CSXT1:1;       /*    CSXT1     */
                           unsigned char CSXT0:1;       /*    CSXT0     */
                           }     BIT;                   /*              */
                    }           CSACR;                  /*              */
              union {                                   /* BROMCR       */
                    unsigned int WORD;                  /*  Word Access */
                    struct {                            /*  Byte Access */
                           unsigned char H;             /*    BROMCRH   */
                           unsigned char L;             /*    BROMCRL   */
                           }     BYTE;                  /*              */
                    struct {                            /*  Bit  Access */
                           unsigned char BSRM0:1;       /*    BSRM0     */
                           unsigned char BSTS0:3;       /*    BSTS0     */
                           unsigned char      :2;       /*              */
                           unsigned char BSWD0:2;       /*    BSWD0     */
                           unsigned char BSRM1:1;       /*    BSRM1     */
                           unsigned char BSTS1:3;       /*    BSTS1     */
                           unsigned char      :2;       /*              */
                           unsigned char BSWD1:2;       /*    BSWD1     */
                           }     BIT;                   /*              */
                    }           BROMCR;                 /*              */
              union {                                   /* BCR          */
                    unsigned int WORD;                  /*  Word Access */
                    struct {                            /*  Bit  Access */
                           unsigned char BRLE  :1;      /*    BRLE      */
                           unsigned char BREQOE:1;      /*    BREQOE    */
                           unsigned char       :1;      /*              */
                           unsigned char IDLC  :1;      /*    IDLC      */
                           unsigned char ICIS1 :1;      /*    ICIS1     */
                           unsigned char ICIS0 :1;      /*    ICIS0     */
                           unsigned char WDBE  :1;      /*    WDBE      */
                           unsigned char WAITE :1;      /*    WAITE     */
                           unsigned char       :5;      /*              */
                           unsigned char ICIS2 :1;      /*    ICIS2     */
                           }     BIT;                   /*              */
                    }           BCR;                    /*              */
              char              wk3[2];                 /*              */
              union {                                   /* DRAMCR       */
                    unsigned int WORD;                  /*  Word Access */
                    struct {                            /*  Bit  Access */
                           unsigned char OEE :1;        /*    OEE       */
                           unsigned char RAST:1;        /*    RAST      */
                           unsigned char     :1;        /*              */
                           unsigned char CAST:1;        /*    CAST      */
                           unsigned char     :1;        /*              */
                           unsigned char RMTS:3;        /*    RMTS      */
                           unsigned char BE  :1;        /*    BE        */
                           unsigned char RCDM:1;        /*    RCDM      */
                           unsigned char DDS :1;        /*    DDS       */
                           unsigned char EDDS:1;        /*    EDDS      */
                           unsigned char     :1;        /*              */
                           unsigned char MXC :3;        /*    MXC       */
                           }     BIT;                   /*              */
                    }           DRAMCR;                 /*              */
              union {                                   /* DRACCR       */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char DRMI:1;        /*    DRMI      */
                           unsigned char     :1;        /*              */
                           unsigned char TPC :2;        /*    TPC       */
                           unsigned char     :2;        /*              */
                           unsigned char RCD :2;        /*    RCD       */
                           }      BIT;                  /*              */
                    }           DRACCR;                 /*              */
              char              wk4;                    /*              */
              union {                                   /* REFCR        */
                    unsigned int WORD;                  /*  Word Access */
                    struct {                            /*  Bit  Access */
                           unsigned char CMF  :1;       /*    CMF       */
                           unsigned char CMIE :1;       /*    CMIE      */
                           unsigned char RCW  :2;       /*    RCW       */
                           unsigned char      :1;       /*              */
                           unsigned char RTCK :3;       /*    RTCK      */
                           unsigned char RFSHE:1;       /*    RFSHE     */
                           unsigned char CBRM :1;       /*    CBRM      */
                           unsigned char RLW  :2;       /*    RLW       */
                           unsigned char SLFRF:1;       /*    SLFRF     */
                           unsigned char TPCS :3;       /*    TPCS      */
                           }     BIT;                   /*              */
                    }           REFCR;                  /*              */
              unsigned char     RTCNT;                  /* RTCNT        */
              unsigned char     RTCOR;                  /* RTCOR        */
};                                                      /*              */
struct st_sam0a {                                       /* struct DMAC0A*/
                void           *MAR;                    /* MAR          */
                unsigned int    IOAR;                   /* IOAR         */
                unsigned int    ETCR;                   /* ETCR         */
                char            wk1[58];                /*              */
                union {                                 /* DMACR        */
                      unsigned char BYTE;               /*  Byte Access */
                      struct {                          /*  Bit  Access */
                             unsigned char DTSZ :1;     /*    DTSZ      */
                             unsigned char DTID :1;     /*    DTID      */
                             unsigned char RPE  :1;     /*    RPE       */
                             unsigned char DTDIR:1;     /*    DTDIR     */
                             unsigned char DTF  :4;     /*    DTF       */
                             }      BIT;                /*              */
                      }         DMACR;                  /*              */
                char            wk2[3];                 /*              */
                union {                                 /* DMABCR       */
                      unsigned int WORD;                /*  Word Access */
                      struct {                          /*  Byte Access */
                             unsigned char H;           /*    DMABCRH   */
                             unsigned char L;           /*    DMABCRL   */
                             }     BYTE;                /*              */
                      struct {                          /*  Bit  Access */
                             unsigned char     :1;      /*              */
                             unsigned char FAE :1;      /*    FAE       */
                             unsigned char     :1;      /*              */
                             unsigned char SAE :1;      /*    SAE       */
                             unsigned char     :3;      /*              */
                             unsigned char DTA :1;      /*    DTA       */
                             unsigned char     :3;      /*              */
                             unsigned char DTE :1;      /*    DTE       */
                             unsigned char     :3;      /*              */
                             unsigned char DTIE:1;      /*    DTIE      */
                             }     BIT;                 /*              */
                      }         DMABCR;                 /*              */
};                                                      /*              */
struct st_sam0b {                                       /* struct DMAC0B*/
                void           *MAR;                    /* MAR          */
                unsigned int    IOAR;                   /* IOAR         */
                unsigned int    ETCR;                   /* ETCR         */
                char            wk1[51];                /*              */
                union {                                 /* DMACR        */
                      unsigned char BYTE;               /*  Byte Access */
                      struct {                          /*  Bit  Access */
                             unsigned char DTSZ :1;     /*    DTSZ      */
                             unsigned char DTID :1;     /*    DTID      */
                             unsigned char RPE  :1;     /*    RPE       */
                             unsigned char DTDIR:1;     /*    DTDIR     */
                             unsigned char DTF  :4;     /*    DTF       */
                             }      BIT;                /*              */
                      }         DMACR;                  /*              */
                char            wk2[2];                 /*              */
                union {                                 /* DMABCR       */
                      unsigned int WORD;                /*  Word Access */
                      struct {                          /*  Byte Access */
                             unsigned char H;           /*    DMABCRH   */
                             unsigned char L;           /*    DMABCRL   */
                             }     BYTE;                /*              */
                      struct {                          /*  Bit  Access */
                             unsigned char     :1;      /*              */
                             unsigned char FAE :1;      /*    FAE       */
                             unsigned char     :1;      /*              */
                             unsigned char SAE :1;      /*    SAE       */
                             unsigned char     :2;      /*              */
                             unsigned char DTA :1;      /*    DTA       */
                             unsigned char     :0;      /*              */
                             unsigned char     :2;      /*              */
                             unsigned char DTE :1;      /*    DTE       */
                             unsigned char     :3;      /*              */
                             unsigned char DTIE:1;      /*    DTIE      */
                             }     BIT;                 /*              */
                      }         DMABCR;                 /*              */
};                                                      /*              */
struct st_sam1a {                                       /* struct DMAC1A*/
                void           *MAR;                    /* MAR          */
                unsigned int    IOAR;                   /* IOAR         */
                unsigned int    ETCR;                   /* ETCR         */
                char            wk1[44];                /*              */
                union {                                 /* DMACR        */
                      unsigned char BYTE;               /*  Byte Access */
                      struct {                          /*  Bit  Access */
                             unsigned char DTSZ :1;     /*    DTSZ      */
                             unsigned char DTID :1;     /*    DTID      */
                             unsigned char RPE  :1;     /*    RPE       */
                             unsigned char DTDIR:1;     /*    DTDIR     */
                             unsigned char DTF  :4;     /*    DTF       */
                             }      BIT;                /*              */
                      }         DMACR;                  /*              */
                char            wk2;                    /*              */
                union {                                 /* DMABCR       */
                      unsigned int WORD;                /*  Word Access */
                      struct {                          /*  Byte Access */
                             unsigned char H;           /*    DMABCRH   */
                             unsigned char L;           /*    DMABCRL   */
                             }     BYTE;                /*              */
                      struct {                          /*  Bit  Access */
                             unsigned char FAE :1;      /*    FAE       */
                             unsigned char     :1;      /*              */
                             unsigned char SAE :1;      /*    SAE       */
                             unsigned char     :2;      /*              */
                             unsigned char DTA :1;      /*    DTA       */
                             unsigned char     :0;      /*              */
                             unsigned char     :1;      /*              */
                             unsigned char DTE :1;      /*    DTE       */
                             unsigned char     :3;      /*              */
                             unsigned char DTIE:1;      /*    DTIE      */
                             }     BIT;                 /*              */
                      }         DMABCR;                 /*              */
};                                                      /*              */
struct st_sam1b {                                       /* struct DMAC1B*/
                void           *MAR;                    /* MAR          */
                unsigned int    IOAR;                   /* IOAR         */
                unsigned int    ETCR;                   /* ETCR         */
                char            wk1[37];                /*              */
                union {                                 /* DMACR        */
                      unsigned char BYTE;               /*  Byte Access */
                      struct {                          /*  Bit  Access */
                             unsigned char DTSZ :1;     /*    DTSZ      */
                             unsigned char DTID :1;     /*    DTID      */
                             unsigned char RPE  :1;     /*    RPE       */
                             unsigned char DTDIR:1;     /*    DTDIR     */
                             unsigned char DTF  :4;     /*    DTF       */
                             }      BIT;                /*              */
                      }         DMACR;                  /*              */
                union {                                 /* DMABCR       */
                      unsigned int WORD;                /*  Word Access */
                      struct {                          /*  Byte Access */
                             unsigned char H;           /*    DMABCRH   */
                             unsigned char L;           /*    DMABCRL   */
                             }     BYTE;                /*              */
                      struct {                          /*  Bit  Access */
                             unsigned char FAE :1;      /*    FAE       */
                             unsigned char     :1;      /*              */
                             unsigned char SAE :1;      /*    SAE       */
                             unsigned char     :1;      /*              */
                             unsigned char DTA :1;      /*    DTA       */
                             unsigned char     :0;      /*              */
                             unsigned char DTE :1;      /*    DTE       */
                             unsigned char     :3;      /*              */
                             unsigned char DTIE:1;      /*    DTIE      */
                             }     BIT;                 /*              */
                      }         DMABCR;                 /*              */
};                                                      /*              */
struct st_fam0 {                                        /* struct DMAC0 */
               void            *MARA;                   /* MARA         */
               char             wk1[2];                 /*              */
               unsigned int     ETCRA;                  /* ETCRA        */
               void            *MARB;                   /* MARB         */
               char             wk2[2];                 /*              */
               unsigned int     ETCRB;                  /* ETCRB        */
               char             wk3[50];                /*              */
               union {                                  /* DMACR        */
                     unsigned int WORD;                 /*  Word Access */
                     struct {                           /*  Byte Access */
                            unsigned char A;            /*    DMACRA    */
                            unsigned char B;            /*    DMACRB    */
                            }     BYTE;                 /*              */
                     struct {                           /*  Bit  Access */
                            unsigned char DTSZ  :1;     /*    DTSZ      */
                            unsigned char SAID  :1;     /*    SAID      */
                            unsigned char SAIDE :1;     /*    SAIDE     */
                            unsigned char BLKDIR:1;     /*    BLKDIR    */
                            unsigned char BLKE  :1;     /*    BLKE      */
                            unsigned char       :0;     /*              */
                            unsigned char       :1;     /*              */
                            unsigned char DAID  :1;     /*    DAID      */
                            unsigned char DAIDE :1;     /*    DAIDE     */
                            unsigned char       :1;     /*              */
                            unsigned char DTF   :4;     /*    DTF       */
                            }     BIT;                  /*              */
                     }          DMACR;                  /*              */
               char             wk4[2];                 /*              */
               union {                                  /* DMABCR       */
                     unsigned int WORD;                 /*  Word Access */
                     struct {                           /*  Byte Access */
                            unsigned char H;            /*    DMABCRH   */
                            unsigned char L;            /*    DMABCRL   */
                            }     BYTE;                 /*              */
                     struct {                           /*  Bit  Access */
                            unsigned char      :1;      /*              */
                            unsigned char FAE  :1;      /*    FAE       */
                            unsigned char      :4;      /*              */
                            unsigned char DTA  :1;      /*    DTA       */
                            unsigned char      :0;      /*              */
                            unsigned char      :2;      /*              */
                            unsigned char DTME :1;      /*    DTME      */
                            unsigned char DTE  :1;      /*    DTE       */
                            unsigned char      :2;      /*              */
                            unsigned char DTIEB:1;      /*    DTIEB     */
                            unsigned char DTIEA:1;      /*    DTIEA     */
                            }     BIT;                  /*              */
                     }          DMABCR;                 /*              */
};                                                      /*              */
struct st_fam1 {                                        /* struct DMAC1 */
               void            *MARA;                   /* MARA         */
               char             wk1[2];                 /*              */
               unsigned int     ETCRA;                  /* ETCRA        */
               void            *MARB;                   /* MARB         */
               char             wk2[2];                 /*              */
               unsigned int     ETCRB;                  /* ETCRB        */
               char             wk3[36];                /*              */
               union {                                  /* DMACR        */
                     unsigned int WORD;                 /*  Word Access */
                     struct {                           /*  Byte Access */
                            unsigned char A;            /*    DMACRA    */
                            unsigned char B;            /*    DMACRB    */
                            }     BYTE;                 /*              */
                     struct {                           /*  Bit  Access */
                            unsigned char DTSZ  :1;     /*    DTSZ      */
                            unsigned char SAID  :1;     /*    SAID      */
                            unsigned char SAIDE :1;     /*    SAIDE     */
                            unsigned char BLKDIR:1;     /*    BLKDIR    */
                            unsigned char BLKE  :1;     /*    BLKE      */
                            unsigned char       :0;     /*              */
                            unsigned char       :1;     /*              */
                            unsigned char DAID  :1;     /*    DAID      */
                            unsigned char DAIDE :1;     /*    DAIDE     */
                            unsigned char       :1;     /*              */
                            unsigned char DTF   :4;     /*    DTF       */
                            }     BIT;                  /*              */
                     }         DMACR;                   /*              */
               union {                                  /* DMABCR       */
                     unsigned int WORD;                 /*  Word Access */
                     struct {                           /*  Byte Access */
                            unsigned char H;            /*    DMABCRH   */
                            unsigned char L;            /*    DMABCRL   */
                            }     BYTE;                 /*              */
                     struct {                           /*  Bit  Access */
                            unsigned char FAE  :1;      /*    FAE       */
                            unsigned char      :3;      /*              */
                            unsigned char DTA  :1;      /*    DTA       */
                            unsigned char      :0;      /*              */
                            unsigned char DTME :1;      /*    DTME      */
                            unsigned char DTE  :1;      /*    DTE       */
                            unsigned char      :2;      /*              */
                            unsigned char DTIEB:1;      /*    DTIEB     */
                            unsigned char DTIEA:1;      /*    DTIEA     */
                            }     BIT;                  /*              */
                     }          DMABCR;                 /*              */
};                                                      /*              */
struct st_dmac {                                        /* struct DMAC  */
               union {                                  /* DMAWER       */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char     :4;       /*              */
                            unsigned char WE1B:1;       /*    WE1B      */
                            unsigned char WE1A:1;       /*    WE1A      */
                            unsigned char WE0B:1;       /*    WE0B      */
                            unsigned char WE0A:1;       /*    WE0A      */
                            }      BIT;                 /*              */
                     }          DMAWER;                 /*              */
               union {                                  /* DMATCR       */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char     :2;       /*              */
                            unsigned char TEE1:1;       /*    TEE1      */
                            unsigned char TEE0:1;       /*    TEE0      */
                            }      BIT;                 /*              */
                     }          DMATCR;                 /*              */
};                                                      /*              */
struct st_dtc {                                         /* struct DTC   */
              union {                                   /* DTCEA        */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char IRQ0:1;        /*    IRQ0      */
                           unsigned char IRQ1:1;        /*    IRQ1      */
                           unsigned char IRQ2:1;        /*    IRQ2      */
                           unsigned char IRQ3:1;        /*    IRQ3      */
                           unsigned char IRQ4:1;        /*    IRQ4      */
                           unsigned char IRQ5:1;        /*    IRQ5      */
                           unsigned char IRQ6:1;        /*    IRQ6      */
                           unsigned char IRQ7:1;        /*    IRQ7      */
                           }      BIT;                  /*              */
                    }           DTCEA;                  /*              */
              union {                                   /* DTCEB        */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char IRQ8 :1;       /*    IRQ8      */
                           unsigned char IRQ9 :1;       /*    IRQ9      */
                           unsigned char IRQ10:1;       /*    IRQ10     */
                           unsigned char IRQ11:1;       /*    IRQ11     */
                           unsigned char IRQ12:1;       /*    IRQ12     */
                           unsigned char IRQ13:1;       /*    IRQ13     */
                           unsigned char IRQ14:1;       /*    IRQ14     */
                           unsigned char IRQ15:1;       /*    IRQ15     */
                           }      BIT;                  /*              */
                    }           DTCEB;                  /*              */
              union {                                   /* DTCEC        */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char      :1;       /*              */
                           unsigned char ADI  :1;       /*    ADI       */
                           unsigned char TGI0A:1;       /*    TGI0A     */
                           unsigned char TGI0B:1;       /*    TGI0B     */
                           unsigned char TGI0C:1;       /*    TGI0C     */
                           unsigned char TGI0D:1;       /*    TGI0D     */
                           unsigned char TGI1A:1;       /*    TGI1A     */
                           unsigned char TGI1B:1;       /*    TGI1B     */
                           }      BIT;                  /*              */
                    }           DTCEC;                  /*              */
              union {                                   /* DTCED        */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char TGI2A:1;       /*    TGI2A     */
                           unsigned char TGI2B:1;       /*    TGI2B     */
                           unsigned char TGI3A:1;       /*    TGI3A     */
                           unsigned char TGI3B:1;       /*    TGI3B     */
                           unsigned char TGI3C:1;       /*    TGI3C     */
                           unsigned char TGI3D:1;       /*    TGI3D     */
                           unsigned char TGI4A:1;       /*    TGI4A     */
                           unsigned char TGI4B:1;       /*    TGI4B     */
                           }      BIT;                  /*              */
                    }           DTCED;                  /*              */
              union {                                   /* DTCEE        */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char TGI5A:1;       /*    TGI5A     */
                           unsigned char TGI5B:1;       /*    TGI5B     */
                           unsigned char      :2;       /*              */
                           unsigned char CMIA0:1;       /*    CMIA0     */
                           unsigned char CMIB0:1;       /*    CMIB0     */
                           unsigned char CMIA1:1;       /*    CMIA1     */
                           unsigned char CMIB1:1;       /*    CMIB1     */
                           }      BIT;                  /*              */
                    }           DTCEE;                  /*              */
              union {                                   /* DTCEF        */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char DMTEND0A:1;    /*    DMTEND0A  */
                           unsigned char DMTEND0B:1;    /*    DMTEND0B  */
                           unsigned char DMTEND1A:1;    /*    DMTEND1A  */
                           unsigned char DMTEND1B:1;    /*    DMTEND1B  */
                           unsigned char RXI0    :1;    /*    RXI0      */
                           unsigned char TXI0    :1;    /*    TXI0      */
                           unsigned char RXI1    :1;    /*    RXI1      */
                           unsigned char TXI1    :1;    /*    TXI1      */
                           }      BIT;                  /*              */
                    }           DTCEF;                  /*              */
              union {                                   /* DTCEG        */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char RXI2:1;        /*    RXI2      */
                           unsigned char TXI2:1;        /*    TXI2      */
                           }      BIT;                  /*              */
                    }           DTCEG;                  /*              */
              char              wk;                     /*              */
              union {                                   /* DTVECR       */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char SWDTE:1;       /*    SWDTE     */
                           unsigned char DTVEC:7;       /*    DTVEC     */
                           }      BIT;                  /*              */
                    }           DTVECR;                 /*              */
};                                                      /*              */
union un_sbycr {                                        /* union SBYCR  */
               unsigned char BYTE;                      /*  Byte Access */
               struct {                                 /*  Bit  Access */
                      unsigned char SSBY:1;             /*    SSBY      */
                      unsigned char OPE :1;             /*    OPE       */
                      unsigned char     :2;             /*              */
                      unsigned char STS :4;             /*    STS       */
                      }      BIT;                       /*              */
};                                                      /*              */
union un_sckcr {                                        /* union SCKCR  */
               unsigned char BYTE;                      /*  Byte Access */
               struct {                                 /*  Bit  Access */
                      unsigned char PSTOP:1;            /*    PSTOP     */
                      unsigned char      :3;            /*              */
                      unsigned char STCS :1;            /*    STCS      */
                      unsigned char SCK  :3;            /*    SCK       */
                      }      BIT;                       /*              */
};                                                      /*              */
union un_syscr {                                        /* union SYSCR  */
               unsigned char BYTE;                      /*  Byte Access */
               struct {                                 /*  Bit  Access */
                      unsigned char      :2;            /*              */
                      unsigned char MACS :1;            /*    MACS      */
                      unsigned char      :1;            /*              */
                      unsigned char FLSHE:1;            /*    FLSHE     */
                      unsigned char      :1;            /*              */
                      unsigned char EXPE :1;            /*    EXPE      */
                      unsigned char RAME :1;            /*    RAME      */
                      }      BIT;                       /*              */
};                                                      /*              */
union un_mdcr {                                         /* union MDCR   */
              unsigned char BYTE;                       /*  Byte Access */
              struct {                                  /*  Bit  Access */
                     unsigned char    :5;               /*              */
                     unsigned char MDS:3;               /*    MDS       */
                     }      BIT;                        /*              */
};                                                      /*              */
union un_mstpcr {                                       /* union MSTPCR */
                unsigned int WORD;                      /*  Word Access */
                struct {                                /*  Byte Access */
                       unsigned char H;                 /*    MSTPCRH   */
                       unsigned char L;                 /*    MSTPCRL   */
                       }     BYTE;                      /*              */
                struct {                                /*  Bit  Access */
                       unsigned char ACSE   :1;         /*    ALL       */
                       unsigned char _EXDMAC:1;         /*    EXDMAC    */
                       unsigned char _DMAC  :1;         /*    DMAC      */
                       unsigned char _DTC   :1;         /*    DTC       */
                       unsigned char _TPU   :1;         /*    TPU       */
                       unsigned char _PPG   :1;         /*    PPG       */
                       unsigned char _DA0   :1;         /*    D/A0      */
                       unsigned char _DA1   :1;         /*    D/A1      */
                       unsigned char        :1;         /*              */
                       unsigned char _AD    :1;         /*    A/D       */
                       unsigned char        :2;         /*              */
                       unsigned char _SCI2  :1;         /*    SCI2      */
                       unsigned char _SCI1  :1;         /*    SCI1      */
                       unsigned char _SCI0  :1;         /*    SCI0      */
                       unsigned char _TMR   :1;         /*    TMR       */
                       }     BIT;                       /*              */
};                                                      /*              */
union un_pllcr {                                        /* union PLLCR  */
               unsigned char BYTE;                      /*  Byte Access */
               struct {                                 /*  Bit  Access */
                      unsigned char    :6;              /*              */
                      unsigned char STC:2;              /*    STC       */
                      }      BIT;                       /*              */
};                                                      /*              */
struct st_ppg {                                         /* struct PPG   */
              union {                                   /* PCR          */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char G3CMS:2;       /*    G3CMS     */
                           unsigned char G2CMS:2;       /*    G2CMS     */
                           unsigned char G1CMS:2;       /*    G1CMS     */
                           unsigned char G0CMS:2;       /*    G0CMS     */
                           }      BIT;                  /*              */
                    }           PCR;                    /*              */
              union {                                   /* PMR          */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char G3INV:1;       /*    G3INV     */
                           unsigned char G2INV:1;       /*    G2INV     */
                           unsigned char G1INV:1;       /*    G1INV     */
                           unsigned char G0INV:1;       /*    G0INV     */
                           unsigned char G3NOV:1;       /*    G3NOV     */
                           unsigned char G2NOV:1;       /*    G2NOV     */
                           unsigned char G1NOV:1;       /*    G1NOV     */
                           unsigned char G0NOV:1;       /*    G0NOV     */
                           }      BIT;                  /*              */
                    }           PMR;                    /*              */
              union {                                   /* NDER         */
                    unsigned int WORD;                  /*  Word Access */
                    struct {                            /*  Bit  Access */
                           unsigned char H;             /*    NDERH     */
                           unsigned char L;             /*    NDERL     */
                           }     BYTE;                  /*              */
                    struct {                            /*  Bit  Access */
                           unsigned char B15:1;         /*    NDER15    */
                           unsigned char B14:1;         /*    NDER14    */
                           unsigned char B13:1;         /*    NDER13    */
                           unsigned char B12:1;         /*    NDER12    */
                           unsigned char B11:1;         /*    NDER11    */
                           unsigned char B10:1;         /*    NDER10    */
                           unsigned char B9 :1;         /*    NDER9     */
                           unsigned char B8 :1;         /*    NDER8     */
                           unsigned char B7 :1;         /*    NDER7     */
                           unsigned char B6 :1;         /*    NDER6     */
                           unsigned char B5 :1;         /*    NDER5     */
                           unsigned char B4 :1;         /*    NDER4     */
                           unsigned char B3 :1;         /*    NDER3     */
                           unsigned char B2 :1;         /*    NDER2     */
                           unsigned char B1 :1;         /*    NDER1     */
                           unsigned char B0 :1;         /*    NDER0     */
                           }      BIT;                  /*              */
                    }           NDER;                   /*              */
              union {                                   /* PODR         */
                    unsigned int WORD;                  /*  Word Access */
                    struct {                            /*  Bit  Access */
                           unsigned char H;             /*    PODRH     */
                           unsigned char L;             /*    PODRL     */
                           }     BYTE;                  /*              */
                    struct {                            /*  Bit  Access */
                           unsigned char B15:1;         /*    NDER15    */
                           unsigned char B14:1;         /*    NDER14    */
                           unsigned char B13:1;         /*    NDER13    */
                           unsigned char B12:1;         /*    NDER12    */
                           unsigned char B11:1;         /*    NDER11    */
                           unsigned char B10:1;         /*    NDER10    */
                           unsigned char B9 :1;         /*    NDER9     */
                           unsigned char B8 :1;         /*    NDER8     */
                           unsigned char B7 :1;         /*    NDER7     */
                           unsigned char B6 :1;         /*    NDER6     */
                           unsigned char B5 :1;         /*    NDER5     */
                           unsigned char B4 :1;         /*    NDER4     */
                           unsigned char B3 :1;         /*    NDER3     */
                           unsigned char B2 :1;         /*    NDER2     */
                           unsigned char B1 :1;         /*    NDER1     */
                           unsigned char B0 :1;         /*    NDER0     */
                           }     BIT;                   /*              */
                    }           PODR;                   /*              */
              union {                                   /* NDRH (H'4C)  */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char B15:1;         /*    NDR15     */
                           unsigned char B14:1;         /*    NDR14     */
                           unsigned char B13:1;         /*    NDR13     */
                           unsigned char B12:1;         /*    NDR12     */
                           unsigned char B11:1;         /*    NDR11     */
                           unsigned char B10:1;         /*    NDR10     */
                           unsigned char B9 :1;         /*    NDR9      */
                           unsigned char B8 :1;         /*    NDR8      */
                           }      BIT;                  /*              */
                    }           NDRH1;                  /*              */
              union {                                   /* NDRL (H'4D)  */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char B7:1;          /*    NDR7      */
                           unsigned char B6:1;          /*    NDR6      */
                           unsigned char B5:1;          /*    NDR5      */
                           unsigned char B4:1;          /*    NDR4      */
                           unsigned char B3:1;          /*    NDR3      */
                           unsigned char B2:1;          /*    NDR2      */
                           unsigned char B1:1;          /*    NDR1      */
                           unsigned char B0:1;          /*    NDR0      */
                           }      BIT;                  /*              */
                    }           NDRL1;                  /*              */
              union {                                   /* NDRH (H'4E)  */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char    :4;         /*              */
                           unsigned char B11:1;         /*    NDR11     */
                           unsigned char B10:1;         /*    NDR10     */
                           unsigned char B9 :1;         /*    NDR9      */
                           unsigned char B8 :1;         /*    NDR8      */
                           }      BIT;                  /*              */
                    }           NDRH2;                  /*              */
              union {                                   /* NDRL (H'4F)  */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char   :4;          /*              */
                           unsigned char B3:1;          /*    NDR3      */
                           unsigned char B2:1;          /*    NDR2      */
                           unsigned char B1:1;          /*    NDR1      */
                           unsigned char B0:1;          /*    NDR0      */
                           }      BIT;                  /*              */
                    }           NDRL2;                  /*              */
};                                                      /*              */
struct st_sci {                                         /* struct SCI   */
              union {                                   /* SMR          */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char CA  :1;        /*    C/A       */
                           unsigned char CHR :1;        /*    CHR       */
                           unsigned char _PE :1;        /*    PE        */
                           unsigned char OE  :1;        /*    O/E       */
                           unsigned char STOP:1;        /*    STOP      */
                           unsigned char MP  :1;        /*    MP        */
                           unsigned char CKS :2;        /*    CKS       */
                           }      BIT;                  /*              */
                    }           SMR;                    /*              */
              unsigned char     BRR;                    /* BRR          */
              union {                                   /* SCR          */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char TIE :1;        /*    TIE       */
                           unsigned char RIE :1;        /*    RIE       */
                           unsigned char TE  :1;        /*    TE        */
                           unsigned char RE  :1;        /*    RE        */
                           unsigned char MPIE:1;        /*    MPIE      */
                           unsigned char TEIE:1;        /*    TEIE      */
                           unsigned char CKE :2;        /*    CKE       */
                           }      BIT;                  /*              */
                    }           SCR;                    /*              */
              unsigned char     TDR;                    /* TDR          */
              union {                                   /* SSR          */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char TDRE:1;        /*    TDRE      */
                           unsigned char RDRF:1;        /*    RDRF      */
                           unsigned char ORER:1;        /*    ORER      */
                           unsigned char FER :1;        /*    FER       */
                           unsigned char PER :1;        /*    PER       */
                           unsigned char TEND:1;        /*    TEND      */
                           unsigned char MPB :1;        /*    MPB       */
                           unsigned char MPBT:1;        /*    MPBT      */
                           }      BIT;                  /*              */
                    }           SSR;                    /*              */
              unsigned char     RDR;                    /* RDR          */
              union {                                   /* SCMR         */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char     :4;        /*              */
                           unsigned char SDIR:1;        /*    SDIR      */
                           unsigned char SINV:1;        /*    SINV      */
                           unsigned char     :1;        /*              */
                           unsigned char SMIF:1;        /*    SMIF      */
                           }      BIT;                  /*              */
                    }           SCMR;                   /*              */
};                                                      /*              */
struct st_smci {                                        /* struct SMCI  */
               union {                                  /* SMR          */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char GM :1;        /*    GM        */
                            unsigned char BLK:1;        /*    BLK       */
                            unsigned char _PE:1;        /*    PE        */
                            unsigned char OE :1;        /*    O/E       */
                            unsigned char BCP:2;        /*    BCP       */
                            unsigned char CKS:2;        /*    CKS       */
                            }      BIT;                 /*              */
                     }          SMR;                    /*              */
               unsigned char    BRR;                    /* BRR          */
               union {                                  /* SCR          */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char TIE :1;       /*    TIE       */
                            unsigned char RIE :1;       /*    RIE       */
                            unsigned char TE  :1;       /*    TE        */
                            unsigned char RE  :1;       /*    RE        */
                            unsigned char MPIE:1;       /*    MPIE      */
                            unsigned char TEIE:1;       /*    TEIE      */
                            unsigned char CKE :2;       /*    CKE       */
                            }      BIT;                 /*              */
                     }          SCR;                    /*              */
               unsigned char    TDR;                    /* TDR          */
               union {                                  /* SSR          */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char TDRE:1;       /*    TDRE      */
                            unsigned char RDRF:1;       /*    RDRF      */
                            unsigned char ORER:1;       /*    ORER      */
                            unsigned char ERS :1;       /*    ERS       */
                            unsigned char PER :1;       /*    PER       */
                            unsigned char TEND:1;       /*    TEND      */
                            unsigned char MPB :1;       /*    MPB       */
                            unsigned char MPBT:1;       /*    MPBT      */
                            }      BIT;                 /*              */
                     }          SSR;                    /*              */
               unsigned char    RDR;                    /* RDR          */
               union {                                  /* SCMR         */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char     :4;       /*              */
                            unsigned char SDIR:1;       /*    SDIR      */
                            unsigned char SINV:1;       /*    SINV      */
                            unsigned char     :1;       /*              */
                            unsigned char SMIF:1;       /*    SMIF      */
                            }      BIT;                 /*              */
                     }          SCMR;                   /*              */
};                                                      /*              */
struct st_ad {                                          /* struct A/D   */
             unsigned int       ADDRA;                  /* ADDRA        */
             unsigned int       ADDRB;                  /* ADDRB        */
             unsigned int       ADDRC;                  /* ADDRC        */
             unsigned int       ADDRD;                  /* ADDRD        */
             union {                                    /* ADCSR        */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char ADF :1;         /*    ADF       */
                          unsigned char ADIE:1;         /*    ADIE      */
                          unsigned char ADST:1;         /*    ADST      */
                          unsigned char SCAN:1;         /*    SCAN      */
                          unsigned char CKS :1;         /*    CKS       */
                          unsigned char CH  :3;         /*    CH        */
                          }      BIT;                   /*              */
                   }            ADCSR;                  /*              */
             union {                                    /* ADCR         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char TRGS:2;         /*    TRGS      */
                          unsigned char     :2;         /*              */
                          unsigned char CKS :1;         /*    CKS       */
                          unsigned char CH  :1;         /*    CH        */
                          }      BIT;                   /*              */
                   }            ADCR;                   /*              */
};                                                      /*              */
struct st_da0 {                                         /* struct D/A0  */
              unsigned char      DADR0;                 /* DADR0        */
              unsigned char      DADR1;                 /* DADR1        */
              union {                                   /* DACR         */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char DAOE1:1;       /*    DAOE1     */
                           unsigned char DAOE0:1;       /*    DAOE0     */
                           unsigned char DAE  :1;       /*    DAE       */
                           }      BIT;                  /*              */
                    }            DACR;                  /*              */
};                                                      /*              */
struct st_da1 {                                         /* struct D/A1  */
              unsigned char      DADR2;                 /* DADR2        */
              unsigned char      DADR3;                 /* DADR3        */
              union {                                   /* DACR         */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char DAOE3:1;       /*    DAOE3     */
                           unsigned char DAOE2:1;       /*    DAOE2     */
                           unsigned char DAE  :1;       /*    DAE       */
                           }      BIT;                  /*              */
                    }            DACR;                  /*              */
};                                                      /*              */
struct st_tmr {                                         /* struct TMR   */
              union {                                   /* TCR0         */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char CMIEB:1;       /*    CMIEB     */
                           unsigned char CMIEA:1;       /*    CMIEA     */
                           unsigned char OVIE :1;       /*    OVIE      */
                           unsigned char CCLR :2;       /*    CCLR      */
                           unsigned char CKS  :3;       /*    CKS       */
                           }      BIT;                  /*              */
                    }           TCR0;                   /*              */
              union {                                   /* TCR1         */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char CMIEB:1;       /*    CMIEB     */
                           unsigned char CMIEA:1;       /*    CMIEA     */
                           unsigned char OVIE :1;       /*    OVIE      */
                           unsigned char CCLR :2;       /*    CCLR      */
                           unsigned char CKS  :3;       /*    CKS       */
                           }      BIT;                  /*              */
                    }           TCR1;                   /*              */
              union {                                   /* TCSR0        */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char CMFB:1;        /*    CMFB      */
                           unsigned char CMFA:1;        /*    CMFA      */
                           unsigned char OVF :1;        /*    OVF       */
                           unsigned char ADTE:1;        /*    ADTE      */
                           unsigned char OS  :4;        /*    OS        */
                           }      BIT;                  /*              */
                    }           TCSR0;                  /*              */
              union {                                   /* TCSR1        */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char CMFB:1;        /*    CMFB      */
                           unsigned char CMFA:1;        /*    CMFA      */
                           unsigned char OVF :1;        /*    OVF       */
                           unsigned char     :1;        /*              */
                           unsigned char OS  :4;        /*    OS        */
                           }      BIT;                  /*              */
                    }           TCSR1;                  /*              */
              unsigned int      TCORA;                  /* TCORA        */
              unsigned int      TCORB;                  /* TCORB        */
              unsigned int      TCNT;                   /* TCNT         */
};                                                      /*              */
struct st_tmr0 {                                        /* struct TMR0  */
               union {                                  /* TCR          */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char CMIEB:1;      /*    CMIEB     */
                            unsigned char CMIEA:1;      /*    CMIEA     */
                            unsigned char OVIE :1;      /*    OVIE      */
                            unsigned char CCLR :2;      /*    CCLR      */
                            unsigned char CKS  :3;      /*    CKS       */
                            }      BIT;                 /*              */
                     }          TCR;                    /*              */
               char             wk1;                    /*              */
               union {                                  /* TCSR         */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char CMFB:1;       /*    CMFB      */
                            unsigned char CMFA:1;       /*    CMFA      */
                            unsigned char OVF :1;       /*    OVF       */
                            unsigned char ADTE:1;       /*    ADTE      */
                            unsigned char OS  :4;       /*    OS        */
                            }      BIT;                 /*              */
                     }          TCSR;                   /*              */
               char             wk2;                    /*              */
               unsigned char    TCORA;                  /* TCORA        */
               char             wk3;                    /*              */
               unsigned char    TCORB;                  /* TCORB        */
               char             wk4;                    /*              */
               unsigned char    TCNT;                   /* TCNT         */
};                                                      /*              */
struct st_tmr1 {                                        /* struct TMR1  */
               union {                                  /* TCR          */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char CMIEB:1;      /*    CMIEB     */
                            unsigned char CMIEA:1;      /*    CMIEA     */
                            unsigned char OVIE :1;      /*    OVIE      */
                            unsigned char CCLR :2;      /*    CCLR      */
                            unsigned char CKS  :3;      /*    CKS       */
                            }      BIT;                 /*              */
                     }          TCR;                    /*              */
               char             wk1;                    /*              */
               union {                                  /* TCSR         */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char CMFB:1;       /*    CMFB      */
                            unsigned char CMFA:1;       /*    CMFA      */
                            unsigned char OVF :1;       /*    OVF       */
                            unsigned char     :1;       /*              */
                            unsigned char OS  :4;       /*    OS        */
                            }      BIT;                 /*              */
                     }          TCSR;                   /*              */
               char             wk2;                    /*              */
               unsigned char    TCORA;                  /* TCORA        */
               char             wk3;                    /*              */
               unsigned char    TCORB;                  /* TCORB        */
               char             wk4;                    /*              */
               unsigned char    TCNT;                   /* TCNT         */
};                                                      /*              */
union un_wdt {                                          /* union WDT    */
             struct {                                   /* Read  Access */
                    union {                             /* TCSR         */
                          unsigned char BYTE;           /*  Byte Access */
                          struct {                      /*  Bit  Access */
                                 unsigned char OVF :1;  /*    OVF       */
                                 unsigned char WTIT:1;  /*    WT/IT     */
                                 unsigned char TME :1;  /*    TME       */
                                 unsigned char     :2;  /*              */
                                 unsigned char CKS :3;  /*    CKS       */
                                 }      BIT;            /*              */
                          }       TCSR;                 /*              */
                    unsigned char TCNT;                 /* TCNT         */
                    char          wk;                   /*              */
                    union {                             /* RSTCSR       */
                          unsigned char BYTE;           /*  Byte Access */
                          struct {                      /*              */
                                 unsigned char WRST:1;  /*    WSRT      */
                                 unsigned char RSTE:1;  /*    RSTE      */
                                 }      BIT;            /*              */
                          }       RSTCSR;               /*              */
                    } READ;                             /*              */
             struct {                                   /* Write Access */
                    unsigned int  TCSR;                 /* TCSR/TCNT    */
                    unsigned int  RSTCSR;               /* RSTCSR       */
                    } WRITE;                            /*              */
};                                                      /*              */
struct st_flash {                                       /* struct FLASH */
                union {                                 /* RAMER        */
                      unsigned char BYTE;               /*  Byte Access */
                      struct {                          /*  Bit  Access */
                             unsigned char     :4;      /*              */
                             unsigned char RAMS:1;      /*    RAMS      */
                             unsigned char RAM :3;      /*    RAM       */
                             }      BIT;                /*              */
                      }         RAMER;                  /*              */
                char            wk[236];                /*              */
                union {                                 /* FLMCR1       */
                      unsigned char BYTE;               /*  Byte Access */
                      struct {                          /*  Bit  Access */
                             unsigned char FWE:1;       /*    FWE       */
                             unsigned char SWE:1;       /*    SWE       */
                             unsigned char ESU:1;       /*    ESU       */
                             unsigned char PSU:1;       /*    PSU       */
                             unsigned char EV :1;       /*    EV        */
                             unsigned char PV :1;       /*    PV        */
                             unsigned char E  :1;       /*    E         */
                             unsigned char P  :1;       /*    P         */
                             }      BIT;                /*              */
                      }         FLMCR1;                 /*              */
                union {                                 /* FLMCR2       */
                      unsigned char BYTE;               /*  Byte Access */
                      struct {                          /*  Bit  Access */
                             unsigned char FLER:1;      /*    FLER      */
                             }      BIT;                /*              */
                      }         FLMCR2;                 /*              */
                union {                                 /* EBR1         */
                      unsigned char BYTE;               /*  Byte Access */
                      struct {                          /*  Bit  Access */
                             unsigned char EB7:1;       /*    EB7       */
                             unsigned char EB6:1;       /*    EB6       */
                             unsigned char EB5:1;       /*    EB5       */
                             unsigned char EB4:1;       /*    EB4       */
                             unsigned char EB3:1;       /*    EB3       */
                             unsigned char EB2:1;       /*    EB2       */
                             unsigned char EB1:1;       /*    EB1       */
                             unsigned char EB0:1;       /*    EB0       */
                             }      BIT;                /*              */
                      }         EBR1;                   /*              */
                union {                                 /* EBR2         */
                      unsigned char BYTE;               /*  Byte Access */
                      struct {                          /*  Bit  Access */
                             unsigned char     :4;      /*              */
                             unsigned char EB11:1;      /*    EB11      */
                             unsigned char EB10:1;      /*    EB10      */
                             unsigned char EB9 :1;      /*    EB9       */
                             unsigned char EB8 :1;      /*    EB8       */
                             }      BIT;                /*              */
                      }         EBR2;                   /*              */
};                                                      /*              */
#define EXDMAC0 (*(volatile struct st_exdmac*)0xFFFDC0) /* EXDMAC0 Addr */
#define EXDMAC1 (*(volatile struct st_exdmac*)0xFFFDD0) /* EXDMAC1 Addr */
#define EXDMAC2 (*(volatile struct st_exdmac*)0xFFFDE0) /* EXDMAC2 Addr */
#define EXDMAC3 (*(volatile struct st_exdmac*)0xFFFDF0) /* EXDMAC3 Addr */
#define TPU     (*(volatile struct st_tpu   *)0xFFFFC0) /* TPU   Address*/
#define TPU0    (*(volatile struct st_tpu0  *)0xFFFFD0) /* TPU0  Address*/
#define TPU1    (*(volatile struct st_tpu1  *)0xFFFFE0) /* TPU1  Address*/
#define TPU2    (*(volatile struct st_tpu1  *)0xFFFFF0) /* TPU2  Address*/
#define TPU3    (*(volatile struct st_tpu0  *)0xFFFE80) /* TPU3  Address*/
#define TPU4    (*(volatile struct st_tpu1  *)0xFFFE90) /* TPU4  Address*/
#define TPU5    (*(volatile struct st_tpu1  *)0xFFFEA0) /* TPU5  Address*/
#define P1      (*(volatile struct st_p1    *)0xFFFE20) /* P1    Address*/
#define P2      (*(volatile struct st_p2    *)0xFFFE21) /* P2    Address*/
#define P3      (*(volatile struct st_p3    *)0xFFFE22) /* P3    Address*/
#define P4      (*(volatile struct st_p4    *)0xFFFF53) /* P4    Address*/
#define P5      (*(volatile struct st_p5    *)0xFFFE24) /* P5    Address*/
#define P6      (*(volatile struct st_p6    *)0xFFFE25) /* P6    Address*/
#define P7      (*(volatile struct st_p7    *)0xFFFE26) /* P7    Address*/
#define P8      (*(volatile struct st_p8    *)0xFFFE27) /* P8    Address*/
#define PA      (*(volatile struct st_pa    *)0xFFFE29) /* PA    Address*/
#define PB      (*(volatile struct st_pb    *)0xFFFE2A) /* PB    Address*/
#define PC      (*(volatile struct st_pc    *)0xFFFE2B) /* PC    Address*/
#define PD      (*(volatile struct st_pd    *)0xFFFE2C) /* PD    Address*/
#define PE      (*(volatile struct st_pe    *)0xFFFE2D) /* PE    Address*/
#define PF      (*(volatile struct st_pf    *)0xFFFE2E) /* PF    Address*/
#define PG      (*(volatile struct st_pg    *)0xFFFE2F) /* PG    Address*/
#define INTC    (*(volatile struct st_intc  *)0xFFFE00) /* INTC  Address*/
#define IrCR    (*(volatile union  un_ircr  *)0xFFFE1E) /* IrCR  Address*/
#define BSC     (*(volatile struct st_bsc   *)0xFFFE32) /* BSC   Address*/
#define DMAC0A  (*(volatile struct st_sam0a *)0xFFFEE0) /* DMAC 0A Addr */
#define DMAC0B  (*(volatile struct st_sam0b *)0xFFFEE8) /* DMAC 0B Addr */
#define DMAC1A  (*(volatile struct st_sam1a *)0xFFFEF0) /* DMAC 1A Addr */
#define DMAC1B  (*(volatile struct st_sam1b *)0xFFFEF8) /* DMAC 1B Addr */
#define DMAC0   (*(volatile struct st_fam0  *)0xFFFEE0) /* DMAC 0  Addr */
#define DMAC1   (*(volatile struct st_fam1  *)0xFFFEF0) /* DMAC 1  Addr */
#define DMAC    (*(volatile struct st_dmac  *)0xFFFF20) /* DMAC  Address*/
#define DTC     (*(volatile struct st_dtc   *)0xFFFF28) /* DTC   Address*/
#define SBYCR   (*(volatile union  un_sbycr *)0xFFFF3A) /* SBYCR Address*/
#define SCKCR   (*(volatile union  un_sckcr *)0xFFFF3B) /* SCKCR Address*/
#define SYSCR   (*(volatile union  un_syscr *)0xFFFF3D) /* SYSCR Address*/
#define MDCR    (*(volatile union  un_mdcr  *)0xFFFF3E) /* MDCR  Address*/
#define MSTPCR  (*(volatile union  un_mstpcr*)0xFFFF40) /* MSTPCRAddress*/
#define PLLCR   (*(volatile union  un_pllcr *)0xFFFF45) /* PLLCR Address*/
#define PPG     (*(volatile struct st_ppg   *)0xFFFF46) /* PPG   Address*/
#define SCI0    (*(volatile struct st_sci   *)0xFFFF78) /* SCI0  Address*/
#define SCI1    (*(volatile struct st_sci   *)0xFFFF80) /* SCI1  Address*/
#define SCI2    (*(volatile struct st_sci   *)0xFFFF88) /* SCI2  Address*/
#define SMCI0   (*(volatile struct st_smci  *)0xFFFF78) /* SMCI0 Address*/
#define SMCI1   (*(volatile struct st_smci  *)0xFFFF80) /* SMCI1 Address*/
#define SMCI2   (*(volatile struct st_smci  *)0xFFFF88) /* SMCI2 Address*/
#define AD      (*(volatile struct st_ad    *)0xFFFF90) /* A/D   Address*/
#define DA0     (*(volatile struct st_da0   *)0xFFFFA4) /* D/A0  Address*/
#define DA1     (*(volatile struct st_da1   *)0xFFFFA8) /* D/A1  Address*/
#define TMR     (*(volatile struct st_tmr   *)0xFFFFB0) /* TMR   Address*/
#define TMR0    (*(volatile struct st_tmr0  *)0xFFFFB0) /* TMR0  Address*/
#define TMR1    (*(volatile struct st_tmr1  *)0xFFFFB1) /* TMR1  Address*/
#define WDT     (*(volatile union  un_wdt   *)0xFFFFBC) /* WDT   Address*/
#define FLASH   (*(volatile struct st_flash *)0xFFFEDB) /* FLASH Address*/
