/* Copyright 2004, RENESAS TECHNOLOGY CORPORATION */

/* $RCSfile: itcpip.h,v $ */
/* $Revision: 1.30 $ */
/* $Date: 2004/07/13 04:44:36 $ */


/*
 *  ITRON f[^^`
 */
#if defined(__MR30_H) || defined(__MR308_H) || defined(__MR32R)
#define __ITRON_DATA_TYPE
#endif

#if !defined(__ITRON_DATA_TYPE)
#define __ITRON_DATA_TYPE
# if defined(__R8C__)  || defined(__H8__) || defined(__SH2__) || defined(__SH4__)\
		||  defined(__M16C__) || defined(__M16C80__) || defined(__M32C80__)
typedef signed char	 	B;
typedef signed short 	H;
typedef signed long	 	W;
typedef unsigned char	UB;
typedef unsigned short	UH;
typedef unsigned long	UW;
typedef signed char		VB;
typedef signed short	VH;
typedef signed long		VW;
typedef void _far * 	VP;
typedef void			(*FP)();
typedef H				INT;
typedef UH				UINT;
typedef H				ID;
typedef H				BOOL_ID;
typedef H				PRI;
typedef H				TMO;
typedef H				HNO;
typedef H				ER;
typedef H				ATR;
typedef H				CYCTIME;

#elif defined(__M32R__)
typedef char		 	B;
typedef short		 	H;
typedef long		 	W;
typedef unsigned char	UB;
typedef unsigned short	UH;
typedef unsigned long	UW;
typedef char			VB;
typedef short			VH;
typedef long			VW;
typedef void	      	*VP;
typedef W	       		INT;
typedef W	       		RNO;
typedef UW	      		UINT;
typedef H				ID;
typedef H	       		PRI;
typedef INT	       		TMO;
typedef H	       		HNO;
typedef INT				ER;
typedef INT	     		ATR;
typedef INT	   			DLYTIME;
typedef INT	   			CYCTIME;
typedef void	  		*PT_MSG;
typedef void	  		(* FP)();
typedef H	   			BOOL_ID;
typedef UINT	   		PSW;
typedef UW           	T_MSG;
# endif
#endif
typedef	INT				FN;			/* TCP/IP @\R[h^`	*/

/*
 *  ITRON TCP/IP APIdl wb_t@C
 */
/************************/
/***  f[^\`  ***/
/************************/
/***  IP AhX/|[gԍ  ***/
typedef struct t_ipv4ep {
	UW		 ipaddr;	/* IP AhX	*/
	UH		 portno;	/* |[gԍ	*/
} T_IPV4EP;

/***  TCP t̐  ***/
typedef struct t_tcp_crep {
	ATR		 repatr;	/* TCP t					*/
	T_IPV4EP myaddr;	/*  IP AhXƃ|[gԍ	*/
} T_TCP_CREP;

/***  TCP ʐM[_̐  ***/
typedef struct t_tcp_ccep {
	ATR		 cepatr;	/* TCP ʐM[_					*/
	VP		 sbuf;		/* MpEBhEobt@̐擪	*/
	INT		 sbufsz;	/* MpEBhEobt@̃TCY	*/
	VP		 rbuf;		/* MpEBhEobt@̐擪	*/
	INT		 rbufsz;	/* MpEBhEobt@̃TCY	*/
	ER		(*callback)(ID cepid, FN fncd , VP p_parblk); /* R[obN[`	*/
} T_TCP_CCEP;

/***  UDP ʐM[_̐  ***/
typedef struct t_udp_ccep {
	ATR		 cepatr;	/* UDP ʐM[_					*/
	T_IPV4EP myaddr;	/*  IP AhXƃ|[gԍ	*/
	ER	(*callback)(ID cepid, FN fncd , VP p_parblk);	/* R[obN[`	*/
} T_UDP_CCEP;


/**************************/
/***  API ̋@\R[h  ***/
/**************************/
#define	TFN_TCP_CRE_REP	-0x0201		/* TCP t̐						*/
#define	TFN_TCP_DEL_REP	-0x0202		/* TCP t̍폜						*/
#define	TFN_TCP_CRE_CEP	-0x0203		/* TCP ʐM[_̐					*/
#define	TFN_TCP_DEL_CEP	-0x0204		/* TCP ʐM[_̍폜					*/
#define	TFN_TCP_ACP_CEP	-0x0205		/* TCP ڑv҂						*/
#define	TFN_TCP_CON_CEP	-0x0206		/* TCP ڑv(\I[v)			*/
#define	TFN_TCP_SHT_CEP	-0x0207		/* TCP f[^M̏I					*/
#define	TFN_TCP_CLS_CEP	-0x0208		/* TCP ʐM[_̃N[Y				*/
#define	TFN_TCP_SND_DAT	-0x0209		/* TCP f[^̑M						*/
#define	TFN_TCP_RCV_DAT	-0x020A		/* TCP f[^̎M						*/
#define	TFN_TCP_GET_BUF	-0x020B		/* TCP Mpobt@̎擾				*/
#define	TFN_TCP_SND_BUF	-0x020C		/* TCP obt@̃f[^M			*/
#define	TFN_TCP_RCV_BUF	-0x020D		/* TCP Mf[^̓obt@擾	*/
#define	TFN_TCP_REL_BUF	-0x020E		/* TCP Mpobt@̉				*/
#define	TFN_TCP_SND_OOB	-0x020F		/* TCP ً}f[^̑M					*/
#define	TFN_TCP_RCV_OOB	-0x0210		/* TCP ً}f[^̎M					*/
#define	TFN_TCP_CAN_CEP	-0x0211		/* yfBO TCP LZ	*/
#define	TFN_TCP_SET_OPT	-0x0212		/* TCP ʐM[_IvV̐ݒ			*/
#define	TFN_TCP_GET_OPT	-0x0213		/* TCP ʐM[_IvV̓ǂݏo		*/
#define	TFN_TCP_ALL	 	 0x0000
#define	TFN_UDP_CRE_CEP	-0x0221		/* UDP ʐM[_̐					*/
#define	TFN_UDP_DEL_CEP	-0x0222		/* UDP ʐM[_̍폜					*/
#define	TFN_UDP_SND_DAT	-0x0223		/* UDP f[^̑M						*/
#define	TFN_UDP_RCV_DAT	-0x0224		/* UDP f[^̎M						*/
#define	TFN_UDP_CAN_CEP	-0x0225		/* yfBO UDP LZ	*/
#define	TFN_UDP_SET_OPT	-0x0226		/* UDP ʐM[_IvV̐ݒ			*/
#define	TFN_UDP_GET_OPT	-0x0227		/* UDP ʐM[_IvV̓ǂݏo		*/
#define	TFN_UDP_ALL	 	 0x0000


/********************************/
/***  API Ɋւ鎖ۃR[h  ***/
/********************************/
#define	TEV_TCP_RCV_OOB		0x0201	/* TCP ً}f[^̎M	*/
#define	TEV_UDP_RCV_DAT		0x0221	/* UDP f[^̎M		*/


/**********************/
/***  G[R[h  ***/
/**********************/
#ifndef E_SYS
#define	E_SYS		 -5		/* VXeG[				*/
#endif
#ifndef E_NOSPT
#define	E_NOSPT		-17		/* T|[g@\				*/
#endif
#ifndef	E_RSATR
#define	E_RSATR		-24		/* \񑮐						*/
#endif
#ifndef	E_PAR
#define	E_PAR		-33		/* p[^G[				*/
#endif
#ifndef	E_ID
#define	E_ID		-35		/* s ID ԍ					*/
#endif
#ifndef	E_NOEXS
#define	E_NOEXS		-52		/* IuWFNg			*/
#endif
#ifndef	E_MACV
#define	E_MACV		-65		/* ANZXᔽ			*/
#endif
#ifndef	E_DLT
#define	E_DLT		-81		/* ҂IuWFNg폜			*/
#endif
#ifndef	E_WBLK
#define	E_WBLK		-83		/* mubLOR[t	*/
#endif
#ifndef	E_CLS
#define	E_CLS		-87		/* ڑ̎s					*/
#endif
#ifndef	E_BOVR
#define	E_BOVR		-89		/* obt@I[o[t[		*/
#endif

/***************************
 *      Error Code         *
 ***************************/
#ifndef	E_OK
#define E_OK            0x0000
#endif
#ifndef	E_OBJ
#define E_OBJ          -0x003f
#endif
#ifndef	E_QOVR
#define E_QOVR         -0x0049
#endif
#ifndef	E_TMOUT
#define E_TMOUT        -0x0055
#endif
#ifndef	E_RLWAI
#define E_RLWAI        -0x0056
#endif
#ifndef	E_NOMEM
#define E_NOMEM        -0x000a
#endif


/****************/
/***  ̑  ***/
/****************/
#ifndef	TMO_POL
#define TMO_POL			0
#endif
#ifndef	TMO_FEVR
#define TMO_FEVR		-1
#endif
#ifndef	TMO_NBLK
#define	TMO_NBLK		-2	/* mubLOR[(^CAEgw) */
#endif
#ifndef	NADR
#define NADR			((T_IPV4EP*)-1)		/* IPAhXC|[gԍ̎wȗ */
#endif
#ifndef	IPV4_ADDRANY
#define	IPV4_ADDRANY	 0	/* IP AhX̎wȗ					*/
#endif
#ifndef	TCP_PORTANY
#define	TCP_PORTANY		 0	/* TCP |[gԍ̎wȗ					*/
#endif
#ifndef	UDP_PORTANY
#define	UDP_PORTANY		 0	/* UCP |[gԍ̎wȗ					*/
#endif


/**************************/
/***  p          ***/
/**************************/
typedef struct	{
	UB	ipaddr[4];				/* ǂIPAhX */
	UB	maskaddr[4];			/* TulbgE}XN */
	UB	gwaddr[4];				/* Q[gEFCEAhX */
#if defined(__M32R__)
	UW	dummy;					/* ACgp */
#endif
} TCPUDP_ENV;


/**************************/
/***  vg^Cv錾  ***/
/**************************/
ER udp_snd_dat( ID cepid, T_IPV4EP *p_dstaddr, VP data, INT len, TMO tmout );
ER udp_rcv_dat( ID cepid, T_IPV4EP *p_dstaddr, VP data, INT len, TMO tmout );
ER udp_can_cep( ID cepid, FN fncd );

ER tcp_acp_cep( ID cepid, ID repid, T_IPV4EP *p_dstadr, TMO tmout );
ER tcp_con_cep( ID cepid, T_IPV4EP *p_myadr,  T_IPV4EP *p_dstadr, TMO tmout );
ER tcp_sht_cep( ID cepid );
ER tcp_cls_cep( ID cepid, TMO tmout );
ER tcp_snd_dat( ID cepid, VP data,  INT dlen, TMO tmout );
ER tcp_rcv_dat( ID cepid, VP data, INT dlen, TMO tmout );
ER tcp_can_cep( ID cepid, FN fncd );

ER tcpudp_open( UW *workp );		/* TCP/IPCuEI[v() */
ER tcpudp_close( void );			/* TCP/IPCuEN[Yi~j */
W tcpudp_get_ramsize( void );	/* gp郏[N̈̃TCY̎Zo */

/* PPP֘AAPI */
ER ppp_open(void);				/* PPPI[v */
ER ppp_close(void);				/* PPPN[Y */
UH ppp_status(void);			/* PPP         */


/*******************************/
/***  hCoC^tF[X ***/
/********************************/
/*++++++++++++++++ PPP/Ether +++++++++++++++++*/
H	 rcv_buff_release(void);
void tcpudp_act_cyc(UB cycact);			/* TCPNE~ */
void api_slp(void);						/* API҂(莞Ԃ̑҂^iv҂) */
void api_wup(void);						/* APIʒm */
UH	tcpudp_get_time(void);				/* 擾֐ */

/*++++++++++++++++ PPP֘A +++++++++++++++++*/
/* PPP̔Fؕ (ppp_authɐݒ) */
#define AUTH_NON				1		/* Fؖ  */
#define AUTH_PAP				2		/* PAP       */

/* VA̒ʐMx (sio_open()̈) */
#define	BR96					0
#define	BR192					1
#define	BR288					2
#define	BR384					3
#define	BR576					4
#define	BR1152					5

/* VA̓][h (ppp_sio_status) */
#define PPP_SIO_STAT_MODEM		1		/* fR}hM[h	*/
#define PPP_SIO_STAT_PPP		2		/* PPPt[M[h		*/

/* ppp_status()̖߂l */
#define PS_DEAD					0x0001	/* 			 */
#define PS_ESTABLISH			0x0002	/* LCPtF[Y		 */
#define PS_AUTHENTICATE			0x0004	/* F؃tF[Y		 */
#define PS_NETWORK				0x0008	/* NCP(IPCP)tF[Y */
#define PS_NETOPEN				0x0010	/* lbg[Nm  */
#define PS_TERMINATE			0x0020	/* Nؒf		 */
#define PS_RESERVED				0xffc0	/* \				 */

/* ppp_drv_statsu()̖߂l */
#define PDS_SND					0x0001	/* 1: M, 0FMobt@EM */
#define PDS_SND_FULL			0x0002	/* 1: Mobt@Et, 0: Mobt@󂫗L */
#define PDS_RCV					0x0010	/* 1: Mf[^LC0: Mobt@   */
#define PDS_RCV_FULL			0x0020	/* 1: Mobt@Et, 0: Mobt@󂫗L */
#define PDS_RESERVED			0xffcc	/* \				 */

/* ppp_api_req()Ŏw\type */
#define	PPP_API_SNDCOMMAND		3		/* ATR}hMv	*/
#define	PPP_API_RCVRZLT			4		/* R[hMv	*/
#define	PPP_API_WAIT			5		/* ̎ԑ҂v	*/

/* PPPڑ	*/
typedef struct {
    UB	src_ipaddr[4];					/* IPAhX		*/
    UB	dst_ipaddr[4];					/* IPAhX		*/
} PPP_INFO;

/* _CAbv */
typedef struct {
    UB		*at_commands;				/* f[^ʐMpfݒ */
    UB		*peer_dial;					/* T[oE_Cԍ	  */
} DUP_INFO;

/* PPPhCoAPI ([UEAvP[VR[) */
void sio_open(UB rate);
void sio_close(void);
ER	 modem_open(void);
ER	 modem_close(void);

/* PPPhCoEC^tF[X֐ (CuR[) */
H	ppp_read(UB **ppp);
H	ppp_write(B *hdr, H hlen, B **pdata, H *pdlen, H num);
ER	ppp_api_req(UH type, void far *parblk, H tmout);
UH	ppp_drv_status(void);				/* PPPhCoԂ̎擾 */
H	modem_read(UB **rzlt);
H	modem_write(void far *parblk);


/*++++++++++++++++ Ether֘A +++++++++++++++++*/
ER	lan_open( void );					/* LAN hCo  */
ER	lan_close( void );					/* LAN hCo @\~ */
H	lan_read( B **buf );
H	lan_write( B * , H, B * , H );		/* LAN hCo f[^M */
void    lan_reset( void ) ;


/* Copyright 2004, RENESAS TECHNOLOGY CORPORATION */








